/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package cheminzlib;

import fydat.CenterRenderer;
import fydat.CenterRendererSloz;
import fydat.Slozka;
import fydat.TableModelSmes;
import fydatlib.Latka;
import fydatlib.Smes;
import java.awt.Color;
import java.awt.event.KeyEvent;
import java.io.IOException;
import java.util.Locale;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.DefaultListModel;
import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableColumn;
import javax.swing.table.TableColumnModel;
import org.jdom2.JDOMException;

/**
 * Třída modálního vyskakovacího panelu pro zadávání parametrů proudu.
 * Volat nejsnadněji jako:<br>
 * Proud myProud = new Proud();<br>
 * myProud.zadejParametryInteraktivne();<br> nebo složitěji: <br>
 * JDialogProudInp jdpi = new JDialogProudInp(null, true);<br>
 * nebo<br> Proud myProud = new Proud();<br>
 *      JDialogProudInp jdpi = new JDialogProudInp(null,myProud, true);<br>
 * a pak:<br> jdpi.setVisible(true); <br>
 *      myProud = jdpi.getProud(); (jen v případě prvního způsobu)<br>
 *  Jinak lze parametry proudu zadávat softwarově přes konstruktory a funkce set
 * @author V. Hlubuček
 */
public class JDialogProudInp extends javax.swing.JDialog {

    final double TABS = 273.15;
    int jVyber = 0;
    int[] jCisla = new int[50];
    boolean jeHmot; // je hmotové složení?
    Proud pr;       // zadávaný proud
    Smes sm;        // směs proudu
    Schema sch;     // technologické schema (aparáty)
    TableModelSmes smesModel = new TableModelSmes();
    DefaultListModel listModel = new DefaultListModel();
    Prevod p = new Prevod();
    
    
    /**
     * Vytváří nový form JDialogProudInp (true - modální)
     * zadaný proud se získá pomocí getProud();
     * @param parent obvykle null
     * @param modal
     */
    public JDialogProudInp(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        pr = new Proud();   // vytvoří dosazovaný proud
        myInit();
    }

    /**
     * Vytváří nový form JDialogProudInp (true - modální)
     * pr  proud do kterého se dosazuje zadává uživatel
     * @param parent obvykle null
     * @param pr  proud
     * @param modal
     */
    public JDialogProudInp(java.awt.Frame parent, Proud pr, boolean modal) {
        super(parent, modal);
        initComponents();
        this.pr = pr;       // dosadí odkaz na zadávaný proud
        myInit();
    }

    /**
     * Vytváří nový form JDialogProudInp (true - modální)
     * pr  proud do kterého se dosazuje zadává uživatel
     * @param parent obvykle null
     * @param sch technologické schema
     * @param pr  proud
     * @param modal
     */
    public JDialogProudInp(java.awt.Frame parent, Schema sch, Proud pr, boolean modal) {
        super(parent, modal);
        initComponents();
        this.sch = sch;
        this.pr = pr;       // dosadí odkaz na zadávaný proud
        myInit();
    }

    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jTextFieldcProud = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jTextFieldNazevProudu = new javax.swing.JTextField();
        jLabel11 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jTextFieldHmPrutok = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        jTextFieldpVstup = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        jTextFieldpVystup = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jTextFieldtVstup = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        jTextFieldtVystup = new javax.swing.JTextField();
        jLabel9 = new javax.swing.JLabel();
        jLabel16 = new javax.swing.JLabel();
        jButtonVybrano1 = new javax.swing.JButton();
        jComboBoxzUzlu = new javax.swing.JComboBox();
        jComboBoxdoUzlu = new javax.swing.JComboBox();
        jPanel2 = new javax.swing.JPanel();
        jLabelSeznam = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        jScrollPaneSeznam = new javax.swing.JScrollPane();
        jList1 = new javax.swing.JList();
        jLabel15 = new javax.swing.JLabel();
        jTextFieldCislem = new javax.swing.JTextField();
        jLabel12 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jListVybrano = new javax.swing.JList();
        jButtonDo = new javax.swing.JButton();
        jButtonLatBack = new javax.swing.JButton();
        jButtonSmaz = new javax.swing.JButton();
        jButtonVybrano = new javax.swing.JButton();
        jLabel17 = new javax.swing.JLabel();
        jPanel3 = new javax.swing.JPanel();
        jScrollPane4 = new javax.swing.JScrollPane();
        jTableSmes = new javax.swing.JTable();
        jPanel9 = new javax.swing.JPanel();
        jRadioButtonHmot = new javax.swing.JRadioButton();
        jRadioButtonMol = new javax.swing.JRadioButton();
        jLabelInfoSloz = new javax.swing.JLabel();
        jLabel13 = new javax.swing.JLabel();
        jButtonSmazSloz = new javax.swing.JButton();
        jLabel14 = new javax.swing.JLabel();
        jTextFieldNazSmesi = new javax.swing.JTextField();
        jButton1 = new javax.swing.JButton();
        jPanelLatka = new javax.swing.JPanel();
        jLabel26 = new javax.swing.JLabel();
        jTextFieldLNaz = new javax.swing.JTextField();
        jLabel27 = new javax.swing.JLabel();
        jTextFieldLVz = new javax.swing.JTextField();
        jLabel31 = new javax.swing.JLabel();
        jTextFieldLCAS = new javax.swing.JTextField();
        jLabel32 = new javax.swing.JLabel();
        jTextFieldLCis = new javax.swing.JTextField();
        jLabel33 = new javax.swing.JLabel();
        jTextFieldLMol = new javax.swing.JTextField();
        jLabel34 = new javax.swing.JLabel();
        jTextFieldLTkr = new javax.swing.JTextField();
        jLabel35 = new javax.swing.JLabel();
        jTextFieldLTkrC = new javax.swing.JTextField();
        jLabel36 = new javax.swing.JLabel();
        jTextFieldLPkr = new javax.swing.JTextField();
        jLabel37 = new javax.swing.JLabel();
        jTextFieldLVkr = new javax.swing.JTextField();
        jLabel38 = new javax.swing.JLabel();
        jTextFieldLAc = new javax.swing.JTextField();
        jLabel39 = new javax.swing.JLabel();
        jTextFieldLGyr = new javax.swing.JTextField();
        jLabel40 = new javax.swing.JLabel();
        jTextFieldLInd = new javax.swing.JTextField();
        jLabel41 = new javax.swing.JLabel();
        jTextFieldLTInd = new javax.swing.JTextField();
        jLabel42 = new javax.swing.JLabel();
        jTextFieldLDip = new javax.swing.JTextField();
        jLabel43 = new javax.swing.JLabel();
        jTextFieldLDiel = new javax.swing.JTextField();
        jLabel44 = new javax.swing.JLabel();
        jTextFieldLHt = new javax.swing.JTextField();
        jLabel45 = new javax.swing.JLabel();
        jTextFieldLTt = new javax.swing.JTextField();
        jLabel46 = new javax.swing.JLabel();
        jTextFieldLTnbv = new javax.swing.JTextField();
        jToggleButtonDocas = new javax.swing.JToggleButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Interaktivní zadávání dat proudu");

        jLabel1.setText("Proud č.:");

        jTextFieldcProud.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N

        jLabel2.setText("Název proudu:");

        jTextFieldNazevProudu.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N

        jLabel11.setText("Vede z uzlu:");

        jLabel3.setText("Hmotový průtok (kg/s):");

        jTextFieldHmPrutok.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jTextFieldHmPrutok.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                jTextFieldHmPrutokFocusLost(evt);
            }
        });

        jLabel4.setText("Tlak na vstupu (Pa):");

        jTextFieldpVstup.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jTextFieldpVstup.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                jTextFieldpVstupFocusLost(evt);
            }
        });

        jLabel5.setText("Tlak na výstupu (Pa):");

        jTextFieldpVystup.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jTextFieldpVystup.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                jTextFieldpVystupFocusLost(evt);
            }
        });

        jLabel6.setText("Vede do uzlu):");

        jLabel7.setText("Teplota na vstupu (°C):");

        jTextFieldtVstup.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jTextFieldtVstup.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                jTextFieldtVstupFocusLost(evt);
            }
        });

        jLabel8.setText("Teplota na výstupu (°C):");

        jTextFieldtVystup.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jTextFieldtVystup.setToolTipText("");
        jTextFieldtVystup.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                jTextFieldtVystupFocusLost(evt);
            }
        });

        jLabel9.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jLabel9.setText("Zadání parametrů proudu:");

        jLabel16.setText("<html>Zadejte parametry proudu, potom přejděte na výběr složek směsi tvořících proud a nakonec zadejte  k jednotlivým složkám složení. Parametry a některé další parametry proudu lze zadávat i softwarově.<br> Fyzikální veličiny je možno zadávat i s rozměrem, pokud nejsou v základních veličinách SI. Rozměr musí být oddělen od čísla mezerou (např. 125 kg/h). K přepočtu dojde po změně fokusu. Pokud byste zadávali teploty v Kelvinech a zde jsou vyžadovány v °C, tak je zadejte jako  C 345 , pokud by byly ve Fahrenheitech, tak C 92 F.</html>");
        jLabel16.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        jLabel16.setVerticalTextPosition(javax.swing.SwingConstants.TOP);

        jButtonVybrano1.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jButtonVybrano1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fydat/data/next24.png"))); // NOI18N
        jButtonVybrano1.setMnemonic('s');
        jButtonVybrano1.setText("Zadání složek");
        jButtonVybrano1.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        jButtonVybrano1.setIconTextGap(8);
        jButtonVybrano1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonVybrano1ActionPerformed(evt);
            }
        });
        jButtonVybrano1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                jButtonVybrano1KeyPressed(evt);
            }
        });

        jComboBoxzUzlu.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Aparát" }));

        jComboBoxdoUzlu.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Aparát" }));

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(22, 22, 22)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jLabel16, javax.swing.GroupLayout.PREFERRED_SIZE, 432, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jButtonVybrano1))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(jLabel9)
                                .addGap(269, 269, 269))
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                        .addComponent(jLabel1)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                        .addComponent(jTextFieldcProud, javax.swing.GroupLayout.PREFERRED_SIZE, 35, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                        .addComponent(jLabel2)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jTextFieldNazevProudu, javax.swing.GroupLayout.PREFERRED_SIZE, 232, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(jLabel4, javax.swing.GroupLayout.Alignment.TRAILING)
                                            .addGroup(jPanel1Layout.createSequentialGroup()
                                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                                        .addComponent(jLabel6)
                                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                        .addComponent(jComboBoxdoUzlu, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                                        .addComponent(jLabel3)
                                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                        .addComponent(jTextFieldHmPrutok, javax.swing.GroupLayout.PREFERRED_SIZE, 83, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                                .addGap(15, 15, 15)
                                                .addComponent(jLabel7)))
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                            .addComponent(jTextFieldtVstup, javax.swing.GroupLayout.DEFAULT_SIZE, 85, Short.MAX_VALUE)
                                            .addComponent(jTextFieldpVstup))))
                                .addGap(33, 33, 33)))
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(jLabel8)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jTextFieldtVystup, javax.swing.GroupLayout.PREFERRED_SIZE, 88, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(jLabel11)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jComboBoxzUzlu, javax.swing.GroupLayout.PREFERRED_SIZE, 136, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(jLabel5)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(jTextFieldpVystup, javax.swing.GroupLayout.PREFERRED_SIZE, 99, javax.swing.GroupLayout.PREFERRED_SIZE)))))
                .addContainerGap(240, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel9)
                .addGap(28, 28, 28)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jTextFieldcProud, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2)
                    .addComponent(jTextFieldNazevProudu, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel11)
                    .addComponent(jComboBoxzUzlu, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(jTextFieldHmPrutok, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel4)
                    .addComponent(jTextFieldpVstup, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel5)
                    .addComponent(jTextFieldpVystup, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(jLabel7)
                    .addComponent(jTextFieldtVstup, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel8)
                    .addComponent(jTextFieldtVystup, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jComboBoxdoUzlu, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(34, 34, 34)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jButtonVybrano1)
                    .addComponent(jLabel16, javax.swing.GroupLayout.PREFERRED_SIZE, 146, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(246, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("Proud", jPanel1);

        jLabelSeznam.setText("Látky obsažené v databázi:");

        jLabel10.setText("<html>Na požadovanou látku najeďte šipkami nebo myší a vyberte dvojklikem nebo stiskem <i>Enter</i>.<br>Při stisknutém <i>Ctrl</i>  můžete provádět vícenásovný výběr a uplatnit ho najednou kliknutím na buttonu uprostřed s šipkou. Stisk jednoho písmene nastaví na látky od tohoto písmene.</html>");

        jScrollPaneSeznam.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N

        jList1.setFont(new java.awt.Font("Lucida Sans Typewriter", 1, 11)); // NOI18N
        jList1.setModel(listModel);
        jList1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jList1MouseClicked(evt);
            }
        });
        jList1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jList1KeyTyped(evt);
            }
        });
        jScrollPaneSeznam.setViewportView(jList1);

        jLabel15.setText("Sem zadávejte látky číslem:");

        jTextFieldCislem.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jTextFieldCislem.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextFieldCislem.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jTextFieldCislemKeyTyped(evt);
            }
        });

        jLabel12.setText("Látky vybrané do směsi:");

        jListVybrano.setFont(new java.awt.Font("Lucida Sans Typewriter", 1, 11)); // NOI18N
        jListVybrano.setModel(new DefaultListModel());
        jListVybrano.setAutoscrolls(false);
        jScrollPane2.setViewportView(jListVybrano);

        jButtonDo.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fydat/data/next24.png"))); // NOI18N
        jButtonDo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonDoActionPerformed(evt);
            }
        });

        jButtonLatBack.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fydat/data/back24.png"))); // NOI18N
        jButtonLatBack.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonLatBackActionPerformed(evt);
            }
        });

        jButtonSmaz.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fydat/data/delete16.png"))); // NOI18N
        jButtonSmaz.setText("Smaž dosud vybrané");
        jButtonSmaz.setIconTextGap(8);
        jButtonSmaz.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSmazActionPerformed(evt);
            }
        });

        jButtonVybrano.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jButtonVybrano.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fydat/data/next24.png"))); // NOI18N
        jButtonVybrano.setMnemonic('s');
        jButtonVybrano.setText("Směs vybrána");
        jButtonVybrano.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        jButtonVybrano.setIconTextGap(8);
        jButtonVybrano.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonVybranoActionPerformed(evt);
            }
        });
        jButtonVybrano.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                jButtonVybranoKeyPressed(evt);
            }
        });

        jLabel17.setText("<html>Chcete-li měnit směs<br>smažte dosud vybrané.</html>");

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(jScrollPaneSeznam, javax.swing.GroupLayout.PREFERRED_SIZE, 398, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(27, 27, 27)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jButtonDo)
                            .addComponent(jButtonLatBack))
                        .addGap(26, 26, 26)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(jPanel2Layout.createSequentialGroup()
                                        .addComponent(jLabel15)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                        .addComponent(jTextFieldCislem, javax.swing.GroupLayout.PREFERRED_SIZE, 61, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addGap(0, 0, Short.MAX_VALUE))
                                    .addComponent(jLabel12, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addGroup(jPanel2Layout.createSequentialGroup()
                                        .addGap(8, 8, 8)
                                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addGroup(jPanel2Layout.createSequentialGroup()
                                                .addComponent(jButtonSmaz)
                                                .addGap(34, 34, 34))
                                            .addGroup(jPanel2Layout.createSequentialGroup()
                                                .addComponent(jButtonVybrano)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                                .addComponent(jLabel17)))))
                                .addGap(61, 61, 61))
                            .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 237, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(jLabelSeznam, javax.swing.GroupLayout.PREFERRED_SIZE, 187, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel10, javax.swing.GroupLayout.PREFERRED_SIZE, 535, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap())))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabelSeznam)
                            .addComponent(jLabel10, javax.swing.GroupLayout.PREFERRED_SIZE, 77, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addGap(11, 11, 11)
                                .addComponent(jScrollPaneSeznam, javax.swing.GroupLayout.DEFAULT_SIZE, 421, Short.MAX_VALUE))
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addGap(144, 144, 144)
                                .addComponent(jButtonDo)
                                .addGap(18, 18, 18)
                                .addComponent(jButtonLatBack))))
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGap(99, 99, 99)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jTextFieldCislem, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel15))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabel12)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 196, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jButtonSmaz)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jButtonVybrano)
                            .addComponent(jLabel17, javax.swing.GroupLayout.PREFERRED_SIZE, 38, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addGap(33, 33, 33))
        );

        jTabbedPane1.addTab("Složky", jPanel2);

        jTableSmes.setModel(new TableModelSmes());
        jScrollPane4.setViewportView(jTableSmes);

        jPanel9.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jRadioButtonHmot.setSelected(true);
        jRadioButtonHmot.setText("Hmotové zadání složení");
        jRadioButtonHmot.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonHmotActionPerformed(evt);
            }
        });

        jRadioButtonMol.setText("Molární zadání složení");
        jRadioButtonMol.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonMolActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel9Layout = new javax.swing.GroupLayout(jPanel9);
        jPanel9.setLayout(jPanel9Layout);
        jPanel9Layout.setHorizontalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel9Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jRadioButtonMol)
                    .addComponent(jRadioButtonHmot))
                .addContainerGap(48, Short.MAX_VALUE))
        );
        jPanel9Layout.setVerticalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel9Layout.createSequentialGroup()
                .addComponent(jRadioButtonHmot)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jRadioButtonMol))
        );

        jLabelInfoSloz.setText("<html>Složení je možno vkládat hmotově nebo molárně (viz volba). Vkládat můžete zlomky nebo i jen poměrové díly. Složení bude následně normalizováno. Jednotlivé již zadané složení smažete pomocí <i>Del</i>.</html>");
        jLabelInfoSloz.setMaximumSize(new java.awt.Dimension(300, 28));
        jLabelInfoSloz.setVerticalTextPosition(javax.swing.SwingConstants.TOP);

        jLabel13.setText("<html>Na spodním panelu se zobrazí  bodové vlastnosti látky na jejímž řádku je fokus. Tlačítko vám umožní dočasnou změnu názvu složky (náhradní látky).</html>");
        jLabel13.setVerticalAlignment(javax.swing.SwingConstants.TOP);

        jButtonSmazSloz.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fydat/data/delete16.png"))); // NOI18N
        jButtonSmazSloz.setText("Smazat celé složení");
        jButtonSmazSloz.setIconTextGap(8);
        jButtonSmazSloz.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSmazSlozActionPerformed(evt);
            }
        });

        jLabel14.setText("Možno vložit uživatelský název směsi:");

        jButton1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fydat/data/next24.png"))); // NOI18N
        jButton1.setText("Ukončit zadávání proudu");
        jButton1.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        jButton1.setIconTextGap(6);
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jButton1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                jButton1KeyPressed(evt);
            }
        });

        jPanelLatka.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanelLatka.setPreferredSize(new java.awt.Dimension(700, 163));

        jLabel26.setText("Látka:");

        jTextFieldLNaz.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N

        jLabel27.setText("Vzorec:");

        jTextFieldLVz.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel31.setText("CAS:");

        jTextFieldLCAS.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel32.setText("Číslo:");

        jTextFieldLCis.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel33.setText("<html>Mol.hmot.<br>(kg/mol):</html>");

        jTextFieldLMol.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel34.setText("Tkr (K):");

        jTextFieldLTkr.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel35.setText("Tkr (°C):");

        jTextFieldLTkrC.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel36.setText("Pkr (MPa):");

        jTextFieldLPkr.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel37.setText("Vkr (ml/mol):");

        jTextFieldLVkr.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel38.setText("Acentr.f.:");

        jTextFieldLAc.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextFieldLAc.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextFieldLAcActionPerformed(evt);
            }
        });

        jLabel39.setText("Gyr.p:");

        jTextFieldLGyr.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel40.setText("Ind.lomu:");

        jTextFieldLInd.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel41.setText("TInd.lomu:");

        jTextFieldLTInd.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel42.setText("Dipolm:");

        jTextFieldLDip.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel43.setText("Dielek.k:");

        jTextFieldLDiel.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel44.setText("<html>Teplo tání.<br>(J/mol):</html>");

        jTextFieldLHt.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel45.setText("Ttání (°C):");

        jTextFieldLTt.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel46.setText("Tnbv (°C):");

        jTextFieldLTnbv.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jToggleButtonDocas.setText("<html>Uplatni dočasnou <br>změnu názvu látky</html>");
        jToggleButtonDocas.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButtonDocasActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanelLatkaLayout = new javax.swing.GroupLayout(jPanelLatka);
        jPanelLatka.setLayout(jPanelLatkaLayout);
        jPanelLatkaLayout.setHorizontalGroup(
            jPanelLatkaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelLatkaLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelLatkaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanelLatkaLayout.createSequentialGroup()
                        .addGroup(jPanelLatkaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanelLatkaLayout.createSequentialGroup()
                                .addComponent(jLabel26)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jTextFieldLNaz, javax.swing.GroupLayout.DEFAULT_SIZE, 369, Short.MAX_VALUE)
                                .addGap(18, 18, 18)
                                .addComponent(jLabel27)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jTextFieldLVz, javax.swing.GroupLayout.PREFERRED_SIZE, 76, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(jLabel31)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jTextFieldLCAS, javax.swing.GroupLayout.PREFERRED_SIZE, 76, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(jPanelLatkaLayout.createSequentialGroup()
                                .addGroup(jPanelLatkaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanelLatkaLayout.createSequentialGroup()
                                        .addComponent(jLabel38)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jTextFieldLAc))
                                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanelLatkaLayout.createSequentialGroup()
                                        .addComponent(jLabel33, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jTextFieldLMol, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(jPanelLatkaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(jPanelLatkaLayout.createSequentialGroup()
                                        .addComponent(jLabel34)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jTextFieldLTkr, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jLabel35)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jTextFieldLTkrC, javax.swing.GroupLayout.PREFERRED_SIZE, 38, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jLabel36)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jTextFieldLPkr, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jLabel37)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jTextFieldLVkr, javax.swing.GroupLayout.PREFERRED_SIZE, 48, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(jPanelLatkaLayout.createSequentialGroup()
                                        .addComponent(jLabel39)
                                        .addGap(2, 2, 2)
                                        .addComponent(jTextFieldLGyr, javax.swing.GroupLayout.PREFERRED_SIZE, 57, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addGap(18, 18, 18)
                                        .addComponent(jLabel40)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jTextFieldLInd, javax.swing.GroupLayout.DEFAULT_SIZE, 46, Short.MAX_VALUE)
                                        .addGap(18, 18, 18)
                                        .addComponent(jLabel41)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jTextFieldLTInd, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jLabel42)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jTextFieldLDip, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                .addGap(35, 35, 35)
                                .addComponent(jToggleButtonDocas, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addGap(115, 115, 115))
                    .addGroup(jPanelLatkaLayout.createSequentialGroup()
                        .addComponent(jLabel43)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextFieldLDiel, javax.swing.GroupLayout.PREFERRED_SIZE, 53, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel44, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextFieldLHt, javax.swing.GroupLayout.PREFERRED_SIZE, 63, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jLabel45)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextFieldLTt, javax.swing.GroupLayout.PREFERRED_SIZE, 38, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel46)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextFieldLTnbv, javax.swing.GroupLayout.PREFERRED_SIZE, 38, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel32)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextFieldLCis, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap(260, Short.MAX_VALUE))))
        );
        jPanelLatkaLayout.setVerticalGroup(
            jPanelLatkaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelLatkaLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelLatkaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel26)
                    .addComponent(jTextFieldLNaz, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel27)
                    .addComponent(jTextFieldLVz, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel31)
                    .addComponent(jTextFieldLCAS, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanelLatkaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanelLatkaLayout.createSequentialGroup()
                        .addGroup(jPanelLatkaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jLabel33, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(jPanelLatkaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                .addComponent(jTextFieldLMol, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(jLabel34)
                                .addComponent(jLabel35)
                                .addComponent(jTextFieldLTkrC, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(jLabel36)
                                .addComponent(jTextFieldLTkr, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(jTextFieldLPkr, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(jLabel37)
                                .addComponent(jTextFieldLVkr, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jPanelLatkaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel38)
                            .addComponent(jTextFieldLAc, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel39)
                            .addComponent(jTextFieldLGyr, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel40)
                            .addComponent(jTextFieldLInd, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel41)
                            .addComponent(jTextFieldLTInd, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel42)
                            .addComponent(jTextFieldLDip, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanelLatkaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(jPanelLatkaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                .addComponent(jLabel43)
                                .addComponent(jTextFieldLDiel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(jLabel44, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(jPanelLatkaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                .addComponent(jTextFieldLHt, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(jLabel45)
                                .addComponent(jTextFieldLTt, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(jLabel46)
                                .addComponent(jTextFieldLTnbv, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(jLabel32)
                                .addComponent(jTextFieldLCis, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addContainerGap(28, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanelLatkaLayout.createSequentialGroup()
                        .addComponent(jToggleButtonDocas, javax.swing.GroupLayout.PREFERRED_SIZE, 41, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(28, 28, 28))))
        );

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanelLatka, javax.swing.GroupLayout.PREFERRED_SIZE, 780, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jScrollPane4, javax.swing.GroupLayout.PREFERRED_SIZE, 362, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel13, javax.swing.GroupLayout.PREFERRED_SIZE, 293, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabelInfoSloz, javax.swing.GroupLayout.PREFERRED_SIZE, 315, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addGap(76, 76, 76)
                                .addComponent(jPanel9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(jLabel14)
                            .addComponent(jButton1)
                            .addComponent(jButtonSmazSloz)
                            .addComponent(jTextFieldNazSmesi, javax.swing.GroupLayout.PREFERRED_SIZE, 213, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap(134, Short.MAX_VALUE))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGap(20, 20, 20)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jPanel9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabelInfoSloz, javax.swing.GroupLayout.PREFERRED_SIZE, 72, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel13, javax.swing.GroupLayout.PREFERRED_SIZE, 53, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jButtonSmazSloz)
                        .addGap(18, 18, 18)
                        .addComponent(jLabel14)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextFieldNazSmesi, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(15, 15, 15)
                        .addComponent(jButton1))
                    .addComponent(jScrollPane4, javax.swing.GroupLayout.PREFERRED_SIZE, 320, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addComponent(jPanelLatka, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("Složení", jPanel3);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 929, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(26, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPane1)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void myInit() {
// úvodní zadání
        jeHmot = false;
        if(jRadioButtonHmot.isSelected())jeHmot = true;
        if(sch == null) {
            jComboBoxzUzlu.setEnabled(false);
            jComboBoxdoUzlu.setEnabled(false);
        } else {    // naplnit nabídku aparátů
            jComboBoxzUzlu.setEnabled(true);
            jComboBoxdoUzlu.setEnabled(true);
            jComboBoxzUzlu.removeAllItems();    // aby se prvky nekumulovaly
            jComboBoxdoUzlu.removeAllItems();
            jComboBoxzUzlu.addItem("žádný");
            jComboBoxdoUzlu.addItem("žádný");
            for(Aparat ap : sch.aparaty) {
                jComboBoxzUzlu.addItem(ap.nazevAparatu);
                jComboBoxdoUzlu.addItem(ap.nazevAparatu);
            }
        }
        if(pr.hmotPrutok > 0) {
            jTextFieldHmPrutok.setText(String.format("%6.3f",pr.hmotPrutok));
            jTextFieldcProud.setText(String.format("%3d",pr.cProudu));
            jTextFieldNazevProudu.setText(pr.nazProudu);
            jTextFieldpVstup.setText(String.format("%8.0f",pr.pVstup));
            jTextFieldtVstup.setText(String.format("%5.1f",pr.tVstup));
                    
        }
        
// Formátování tabulky
        jTableSmes.setModel(smesModel);
        JTableHeader header = jTableSmes.getTableHeader();
        header.setBackground(new Color(0xA0CCFF));
        jTableSmes.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
        int vColIndex = 0;
        TableColumn col = jTableSmes.getColumnModel().getColumn(vColIndex);
        int width = 50;
        col.setPreferredWidth(width);
        TableColumn col2 = jTableSmes.getColumnModel().getColumn(1);
        col2.setPreferredWidth(225);
        TableColumn col3 = jTableSmes.getColumnModel().getColumn(2);
        col3.setPreferredWidth(80);
        TableColumnModel tcm = jTableSmes.getColumnModel();
        TableColumn tc = tcm.getColumn(TableModelSmes.COLUMN_CISLO);
        tc.setCellRenderer(new CenterRenderer());
        TableColumnModel tcmSl = jTableSmes.getColumnModel();
        TableColumn tcSl = tcmSl.getColumn(TableModelSmes.COLUMN_SLOZENI);
        tcSl.setCellRenderer(new CenterRendererSloz());
        jTableSmes.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent e) {
                int row = jTableSmes.getSelectedRow();
                if (row != -1) {
                    Object o = jTableSmes.getModel().getValueAt(row, 2);
                    Object o1 = jTableSmes.getModel().getValueAt(row, 0);
//                    System.out.println("INDEX:" + e.getLastIndex() + "   c= " + o1 + "   x= " + o);
                    int cislo = Integer.parseInt("" + o1);
                    zobrazLatku(cislo);
                }
            }
        });  
        this.setLocale(new Locale("cs", "CZ"));  // ******************************************
        try {
            naplnSeznam();
//            naplnSeznam2();
        } catch (JDOMException e) {
            System.out.println("Chyba xml při načítání souboru látek!");            
        } catch (IOException e) {
            System.out.println("Chyba při načítání souboru látek!");
        } 
        this.setVisible(true);
    }    


    /**
     * Naplnění seznamu látek pro výběr látek
     * @throws IOException
     */
    void naplnSeznam() throws IOException, JDOMException {
        String[] s;       // původně: musí být přesně 533 jinak chyby!
//        Font fontCur = new Font("Courier", Font.BOLD,  12);
        int nLat;
//        jLabel23.setText("Seznam látek v bázi nebo ve výběru:");
        s = Latka.seznamLatek(true);  // true - dle abecedy
        nLat = s.length;
        for (int i = 0; i < nLat; i++) {
            listModel.addElement(s[i]);  // vkládání přes model (tabelace, porov.)
        }
    }

    private void zobrazLatku(int cislo) {
        // TODO add your handling code here:
        int i;
        Latka la = new Latka();
        Latka.getLatka(cislo);
        jTextFieldLNaz.setText(Latka.getLatka(cislo).getNazev());
        jTextFieldLVz.setText(Latka.getLatka(cislo).getVzorec());
        jTextFieldLCAS.setText("" + Latka.getLatka(cislo).getCas());
        jTextFieldLCis.setText("" + Latka.getLatka(cislo).getCislo());
        jTextFieldLMol.setText(String.format("%6.4f", Latka.getLatka(cislo).getMolHmot()));
        jTextFieldLTkr.setText(String.format("%6.1f", Latka.getLatka(cislo).gettKr()));
        jTextFieldLTkrC.setText(String.format("%6.1f", (Latka.getLatka(cislo).gettKr() - TABS)));
        jTextFieldLPkr.setText(String.format("%6.3f", Latka.getLatka(cislo).getpKr() / 1e6));
        jTextFieldLVkr.setText(String.format("%6.1f", Latka.getLatka(cislo).getvKr() * 1e6));
        jTextFieldLAc.setText(String.format("%6.4f", Latka.getLatka(cislo).getAcent()));
        jTextFieldLGyr.setText(String.format("%6.3f", Latka.getLatka(cislo).getGyr()));
        jTextFieldLInd.setText(String.format("%6.4f", Latka.getLatka(cislo).getIndLomu()));
        jTextFieldLTInd.setText(String.format("%4.1f", Latka.getLatka(cislo).gettIndLomu()));
        jTextFieldLDip.setText(String.format("%6.3f", Latka.getLatka(cislo).getDipolm()));
        jTextFieldLDiel.setText(String.format("%6.2f", Latka.getLatka(cislo).getDielektr()));
        if (Latka.getLatka(cislo).getdHtani() > 0.01) {
            jTextFieldLHt.setText(String.format("%6.2f", Latka.getLatka(cislo).getdHtani()));
        } else {
            jTextFieldLHt.setText("N/A");
        }
        if (Latka.getLatka(cislo).gettTani() > 0.01) {
            jTextFieldLTt.setText(String.format("%6.1f", Latka.getLatka(cislo).gettTani() - TABS));
        } else {
            jTextFieldLTt.setText("N/A");
        }
        if (Latka.getLatka(cislo).gettNbv() > 0.01) {
            jTextFieldLTnbv.setText(String.format("%6.1f", Latka.getLatka(cislo).gettNbv() - TABS));
        } else {
            jTextFieldLTnbv.setText("N/A");
            
        }

    }
/**
 * Pomocná funkce převádí string na hodnotu double
 * @param tx
 * @return 
 */    
    protected double doubleFromString(String tx)  {
        return (tx.equals("")) ? 0:Double.parseDouble(tx.replace(',', '.'));
    }
    
    /**
     * Normalizuje zlomky složení
     * @param n počet prvků pole
     * @param x pole double[]
     */
    private void normalizuj(int n, double[] x) {
        int i;
        double sum = 0;
        for (i = 0; i < n; i++) {
            sum += x[i];
        }
        for (i = 0; i < n; i++) {
            x[i] = (Math.abs(sum) < 1e-8) ? 0.0 : x[i] / sum;
        }
    }
/**
 * Vrací interaktivně zadaný proud
 * aby ho uživatel mohl použít ve svém programu
 * @return 
 */
    public Proud getProud() {
        return pr;
    }
    /**
     * Umožní dočasnou změnu názvu látky (náhradní látky)
     * @param n pořadový index látky ve směsi
     */
    private void docasnaZmenaNazvu() {
        int n;
        String nova;
        Latka poml;     // pomocná látka k přejmenování
        do {
            nova = JOptionPane.showInputDialog(
                    null,
                    "Vložte nahrazující název látky\n"
                    + "Bude jen dočasný:",
                    "Dočasná změna názvu látky",
                    JOptionPane.PLAIN_MESSAGE);
        } while (nova.equals(""));
        if (nova.equals(null)) {
            return;
        }
        n = jTableSmes.getSelectedRow();
        sm.setNazevSlozky(n, nova);
        jTableSmes.setValueAt(nova, n, 1);
        jTextFieldLNaz.setText(nova);
        jTableSmes.repaint();
    }

    
    
    private void jList1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jList1MouseClicked
        // výběr látky myší
        String s;
        int k;
        if (evt.getClickCount() == 2) {
            s = (String) jList1.getSelectedValue();
            k = Integer.valueOf(s.substring(0, 3).trim()); // první znaky č. látky
            jCisla[jVyber] = k;
            //            System.out.println("mCislo: " + jVyber + " " + jCisla[jVyber]);
            jVyber++;
            ((DefaultListModel) jListVybrano.getModel()).addElement(s.substring(0, 33));
        }
    }//GEN-LAST:event_jList1MouseClicked

    private void jList1KeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jList1KeyTyped
        // výběr látky Enterem nebo nastavení na písmeno
        String s;
        int k;
        int[] iSel;
        if (evt.getKeyChar() == KeyEvent.VK_ENTER) {
            iSel = jList1.getSelectedIndices();
            for (int i=0; i<iSel.length; i++) {
                //                s = (String) jList1.getSelectedValue();
                s = (String) jList1.getModel().getElementAt(iSel[i]);
                k = Integer.valueOf(s.substring(0, 3).trim()); // první znaky č. látky
                jCisla[jVyber] = k;
                jVyber++;
                ((DefaultListModel) jListVybrano.getModel()).addElement(s.substring(0, 33));
            }
        }
        if (evt.getKeyChar() >= 'A' && evt.getKeyChar() <= 'z') {  // nastaví list na stisk písmene
            //            System.out.println("bylo písmeno " +evt.getKeyChar());
            for (k = 0; k < jList1.getModel().getSize(); k++) {
                s = (String) ((DefaultListModel) jList1.getModel()).getElementAt(k);
                s = s.toLowerCase();
                if (evt.getKeyChar() <= s.charAt(4)) {
                    jList1.ensureIndexIsVisible(530);    // aby nejprve zajel na konec
                    jList1.ensureIndexIsVisible(k);
                    break;
                }
            }
        }
    }//GEN-LAST:event_jList1KeyTyped

    private void jTextFieldCislemKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextFieldCislemKeyTyped
        // Enter za složkou směsi číslem
        int i;
        String s = "";
        if (evt.getKeyChar() == KeyEvent.VK_ENTER) {
            if (jTextFieldCislem.getText().equals("")) {
                //                    JOptionPane.showMessageDialog(this,
                    //                            "Nemůžete zadat 'prázdné' číslo látky !",
                    //                            "Zadej složky směsi", JOptionPane.WARNING_MESSAGE);
                return;
            }
            try {
                i = Integer.parseInt(jTextFieldCislem.getText());   // číslo zadané látky
                s = String.format("%3d ", i)
                + ((Latka.getLatka(i) == null) ? "mimo rozsah" : Latka.getLatka(i).getNazev());
                if (s.indexOf("mimo rozsah") > 0 || i > 700) {
                    JOptionPane.showMessageDialog(this,
                        "Číslo látky musí být kladné a maximálně 700 !",
                        "Zadej složky směsi", JOptionPane.WARNING_MESSAGE);
                    jTextFieldCislem.setText("");
                    return;
                }
                if (Latka.getLatka(i).getNazev().equals("")) {
                    JOptionPane.showMessageDialog(this,
                        "Látka s tímto číslem (" + i + ") neexistuje !",
                        "Zadej složky směsi", JOptionPane.WARNING_MESSAGE);
                    jTextFieldCislem.setText("");
                    return;
                } else {
                    ((DefaultListModel) jListVybrano.getModel()).addElement(s);
                    jCisla[jVyber] = i;
                    jVyber++;
                }
        } catch (NumberFormatException e) {
                JOptionPane.showMessageDialog(this,
                    "Číslo " + e.getMessage() + " nebylo zadáno správně! !",
                    "Zadej látku číslem", JOptionPane.WARNING_MESSAGE);
                // e.printStackTrace();
            }
            jTextFieldCislem.setText("");
        }
    }//GEN-LAST:event_jTextFieldCislemKeyTyped

    private void jButtonDoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonDoActionPerformed
        // Multiselection látek vybrána
        String s;
        int k;
        int[] iSel;
        iSel = jList1.getSelectedIndices();
        for (int i=0; i<iSel.length; i++) {
            //                s = (String) jList1.getSelectedValue();
            s = (String) jList1.getModel().getElementAt(iSel[i]);
            k = Integer.valueOf(s.substring(0, 3).trim()); // první znaky č. látky
            jCisla[jVyber] = k;
            jVyber++;
            ((DefaultListModel) jListVybrano.getModel()).addElement(s.substring(0, 33));
        }
    }//GEN-LAST:event_jButtonDoActionPerformed

    private void jButtonLatBackActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonLatBackActionPerformed
        // Odebrat vybranou látku
        int i, j;
        i = jListVybrano.getSelectedIndex();
        ((DefaultListModel) jListVybrano.getModel()).removeElementAt(i);
        for (j=i; j<jVyber; j++) {
            jCisla[j] =  jCisla[j+1];
        }
        jVyber--;
    }//GEN-LAST:event_jButtonLatBackActionPerformed

    private void jButtonSmazActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSmazActionPerformed
        // Smaže dosud vybrané látky:
        //        jListVybrano.removeAll(); // nefunguje !
        ((DefaultListModel) jListVybrano.getModel()).removeAllElements();
        jVyber = 0;
        jCisla = new int[50];
    }//GEN-LAST:event_jButtonSmazActionPerformed

    private void jButtonVybranoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonVybranoActionPerformed
        // Ukončen výběr směsi
        int i;
            if(pr.sm == null || jVyber > 0){
                try {
                    sm = new Smes(jVyber, jCisla);  // založí z vybraných složek směs
                } catch (JDOMException e) {
                    System.out.println("Chyba xml při načítání souboru látek!");                    
                } catch (IOException e) {
                    e.printStackTrace();
                }
            } else {
                jVyber = pr.sm.getnSloz();
                jCisla = pr.sm.getCislaSlozek();
            try {
                sm = pr.sm.kopirujSmes(pr.sm);
        } catch (JDOMException e) {
            System.out.println("Chyba xml při načítání souboru látek!");                
            } catch (IOException ex) {
                Logger.getLogger(JDialogProudInp.class.getName()).log(Level.SEVERE, null, ex);
            }
            }
            jTabbedPane1.setSelectedIndex(2);
            //  Zrušení případné předchozí tabulky
            smesModel.removeAllSlozka();
            //  Vytvoření tabulky z nové směsi
            String sloz;
            double xS;
            for (i = 0; i < jVyber; i++) {
                sloz = "";
                if(pr.sm != null && pr.sm.getxMol() != null && jVyber <= pr.sm.getnSloz()) {   // složení už je v proudu
                    xS = (jeHmot)? pr.sm.getxHmot(i):pr.sm.getxMol(i);
                    sloz = String.format("%6.4f",xS);
                }
                smesModel.addSlozka(new Slozka(jCisla[i],
                    sm.getSlozka(i).getNazev(), sloz));
            }
            if (jTableSmes.getRowCount() > 0) {
                jTableSmes.getSelectionModel().setSelectionInterval(0, 0);
                jTableSmes.getColumnModel().getSelectionModel().setSelectionInterval(2, 2);
                jTableSmes.requestFocus();
        }
    }//GEN-LAST:event_jButtonVybranoActionPerformed

    private void jRadioButtonHmotActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonHmotActionPerformed
        // hmotové složení
        jRadioButtonMol.setSelected(false);
    }//GEN-LAST:event_jRadioButtonHmotActionPerformed

    private void jRadioButtonMolActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonMolActionPerformed
        // molární složení
        jRadioButtonHmot.setSelected(false);
    }//GEN-LAST:event_jRadioButtonMolActionPerformed

    private void jButtonSmazSlozActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSmazSlozActionPerformed
        // Smazat celé zadané složení:
        //        listSlozeni.removeAll();
        int i;
        for (i = 0; i < jVyber; i++) {
            jTableSmes.setValueAt("", i, 2);
        }
        jTableSmes.repaint();
    }//GEN-LAST:event_jButtonSmazSlozActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        // Ukončení zadávání proudu
        int i;
        boolean isSlozeni = true;
        double sSloz = 0;
        double[] x = new double[smesModel.getRowCount()];
        jeHmot = jRadioButtonHmot.isSelected();
        for (i = 0; i < smesModel.getRowCount(); i++) {
//                x[i] = (smesModel.getValueAt(i, 2).equals(""))? 0:Double.parseDouble(((String)(smesModel.getValueAt(i, 2))).replace(',', '.'));
            x[i] = doubleFromString((String)(smesModel.getValueAt(i, 2)));
            sSloz += x[i];
            if (smesModel.getValueAt(i, 2).equals("")) {
                isSlozeni = false;
            }
        }
        if(smesModel.getRowCount() == 0) isSlozeni = false;
        if(pr.sm != null && pr.sm.getxMol() != null) {
            isSlozeni = true;   // složení zadáno v proudu
        }   
        if (isSlozeni && pr.hmotPrutok > 0) {  // bylo zadáno složení
            if(Math.abs(sSloz) > 1e-5) normalizuj(jVyber,x); else x = (jeHmot)? pr.sm.getxHmot():pr.sm.getxMol(); 
        } else {
            int input = JOptionPane.showOptionDialog(null, "Je třeba nejdříve zadat složení!\n"
                    + "A to pro všechny složky a nenulový průtok.\nMám ukončit program? (OK)" 
                    , "Proud - data", JOptionPane.OK_CANCEL_OPTION, 
                    JOptionPane.INFORMATION_MESSAGE, null, null, null);
            if(input == JOptionPane.OK_OPTION) System.exit(0);
            return;                        
        }
        try {
            sm.zadatSloz(jeHmot, x);    //  zadat složení do směsi
            pr.setSmes(sm);     // přiřazení nové směsi k proudu
        } catch (IOException ex) {
            Logger.getLogger(JDialogProudInp.class.getName()).log(Level.SEVERE, null, ex);
        }
        this.dispose();
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jTextFieldLAcActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextFieldLAcActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jTextFieldLAcActionPerformed

    private void jToggleButtonDocasActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButtonDocasActionPerformed
        // Dočasná změna názvu složky
        docasnaZmenaNazvu();
    }//GEN-LAST:event_jToggleButtonDocasActionPerformed

    private void jButtonVybrano1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonVybrano1ActionPerformed
        // uložení dat a přechod na zadání složek. Pokud se údaj nezadá, dosadí se nula
            pr.setNazProudu(jTextFieldNazevProudu.getText());
            pr.setcProudu((jTextFieldcProud.getText().equals(""))? 0:Integer.parseInt(jTextFieldcProud.getText().trim()));
            if(sch != null) {
                if(jComboBoxzUzlu.getSelectedIndex()> 0) pr.setzUzlu(sch.aparaty.get(jComboBoxzUzlu.getSelectedIndex() - 1));
                if(jComboBoxdoUzlu.getSelectedIndex()> 0) pr.setDoUzlu(sch.aparaty.get(jComboBoxdoUzlu.getSelectedIndex() - 1));
            } else {
                pr.setzUzlu(null);
                pr.setDoUzlu(null);
            }
//            pr.setHmotPrutok((jTextFieldHmPrutok.getText().equals(""))? 0:Double.parseDouble((jTextFieldHmPrutok.getText()).replace(',', '.')));
            pr.setHmotPrutok(doubleFromString(jTextFieldHmPrutok.getText()));
            pr.setpVstup(doubleFromString(jTextFieldpVstup.getText()));
            pr.setpVystup(doubleFromString(jTextFieldpVystup.getText()));
            pr.settVstup(doubleFromString(jTextFieldtVstup.getText()));
//            pr.settVystup((jTextFieldtVystup.getText().equals(""))? 0:Double.parseDouble((jTextFieldtVystup.getText()).replace(',', '.')));
            pr.settVystup(doubleFromString(jTextFieldtVystup.getText()));
            if(pr.getpVystup() <= 1e-8) pr.setpVystup(pr.getpVstup());  // výstupní tlak jako vstupní při nule
            if(Math.abs(pr.gettVystup()) <= 1e-8) pr.settVystup(pr.gettVstup()); 
            jTabbedPane1.setSelectedIndex(1);
            if(pr.sm == null) return;   // dosud nezadána směs
            for(int i = 0; i < pr.sm.getnSloz(); i++) {     // použít směs z proudu
                String s = String.format("%3d  %s",pr.sm.getCisloSlozky(i),pr.sm.getNazevSlozky(i));
                ((DefaultListModel) jListVybrano.getModel()).addElement(s);
            }
    }//GEN-LAST:event_jButtonVybrano1ActionPerformed

    private void jButtonVybrano1KeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jButtonVybrano1KeyPressed
        // Ukončení zadání proudu Enterem
        if (evt.getKeyChar() == KeyEvent.VK_ENTER) {
           jButtonVybrano1ActionPerformed(null);
        }        
    }//GEN-LAST:event_jButtonVybrano1KeyPressed

    private void jButtonVybranoKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jButtonVybranoKeyPressed
        // Ukončení zadání složek směsi Enterem:
        if (evt.getKeyChar() == KeyEvent.VK_ENTER) {
           jButtonVybranoActionPerformed(null);
        }         
    }//GEN-LAST:event_jButtonVybranoKeyPressed

    private void jButton1KeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jButton1KeyPressed
        // Celkové ukončení zadávání proudu a uzavření
        if (evt.getKeyChar() == KeyEvent.VK_ENTER) {
           jButton1ActionPerformed(null);
        }         
    }//GEN-LAST:event_jButton1KeyPressed

    private void jTextFieldHmPrutokFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jTextFieldHmPrutokFocusLost
        // přepočet dle rozměrů při opuštění
        jTextFieldHmPrutok.setText(p.hodnotaString(jTextFieldHmPrutok.getText()));
    }//GEN-LAST:event_jTextFieldHmPrutokFocusLost

    private void jTextFieldpVstupFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jTextFieldpVstupFocusLost
        // přepočet dle rozměrů při opuštění
        jTextFieldpVstup.setText(p.hodnotaString(jTextFieldpVstup.getText()));
    }//GEN-LAST:event_jTextFieldpVstupFocusLost

    private void jTextFieldpVystupFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jTextFieldpVystupFocusLost
        // přepočet dle rozměrů při opuštění
        jTextFieldpVystup.setText(p.hodnotaString(jTextFieldpVystup.getText()));
    }//GEN-LAST:event_jTextFieldpVystupFocusLost

    private void jTextFieldtVstupFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jTextFieldtVstupFocusLost
        // přepočet dle rozměrů při opuštění
        jTextFieldtVstup.setText(p.hodnotaString(jTextFieldtVstup.getText()));
    }//GEN-LAST:event_jTextFieldtVstupFocusLost

    private void jTextFieldtVystupFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jTextFieldtVystupFocusLost
        // přepočet dle rozměrů při opuštění
        jTextFieldtVystup.setText(p.hodnotaString(jTextFieldtVystup.getText()));
    }//GEN-LAST:event_jTextFieldtVystupFocusLost

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(JDialogProudInp.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(JDialogProudInp.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(JDialogProudInp.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(JDialogProudInp.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the dialog */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                JDialogProudInp dialog = new JDialogProudInp(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButtonDo;
    private javax.swing.JButton jButtonLatBack;
    private javax.swing.JButton jButtonSmaz;
    private javax.swing.JButton jButtonSmazSloz;
    private javax.swing.JButton jButtonVybrano;
    private javax.swing.JButton jButtonVybrano1;
    private javax.swing.JComboBox jComboBoxdoUzlu;
    private javax.swing.JComboBox jComboBoxzUzlu;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel26;
    private javax.swing.JLabel jLabel27;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel31;
    private javax.swing.JLabel jLabel32;
    private javax.swing.JLabel jLabel33;
    private javax.swing.JLabel jLabel34;
    private javax.swing.JLabel jLabel35;
    private javax.swing.JLabel jLabel36;
    private javax.swing.JLabel jLabel37;
    private javax.swing.JLabel jLabel38;
    private javax.swing.JLabel jLabel39;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel40;
    private javax.swing.JLabel jLabel41;
    private javax.swing.JLabel jLabel42;
    private javax.swing.JLabel jLabel43;
    private javax.swing.JLabel jLabel44;
    private javax.swing.JLabel jLabel45;
    private javax.swing.JLabel jLabel46;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JLabel jLabelInfoSloz;
    private javax.swing.JLabel jLabelSeznam;
    private javax.swing.JList jList1;
    private javax.swing.JList jListVybrano;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JPanel jPanelLatka;
    private javax.swing.JRadioButton jRadioButtonHmot;
    private javax.swing.JRadioButton jRadioButtonMol;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPaneSeznam;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTable jTableSmes;
    private javax.swing.JTextField jTextFieldCislem;
    private javax.swing.JTextField jTextFieldHmPrutok;
    private javax.swing.JTextField jTextFieldLAc;
    private javax.swing.JTextField jTextFieldLCAS;
    private javax.swing.JTextField jTextFieldLCis;
    private javax.swing.JTextField jTextFieldLDiel;
    private javax.swing.JTextField jTextFieldLDip;
    private javax.swing.JTextField jTextFieldLGyr;
    private javax.swing.JTextField jTextFieldLHt;
    private javax.swing.JTextField jTextFieldLInd;
    private javax.swing.JTextField jTextFieldLMol;
    private javax.swing.JTextField jTextFieldLNaz;
    private javax.swing.JTextField jTextFieldLPkr;
    private javax.swing.JTextField jTextFieldLTInd;
    private javax.swing.JTextField jTextFieldLTkr;
    private javax.swing.JTextField jTextFieldLTkrC;
    private javax.swing.JTextField jTextFieldLTnbv;
    private javax.swing.JTextField jTextFieldLTt;
    private javax.swing.JTextField jTextFieldLVkr;
    private javax.swing.JTextField jTextFieldLVz;
    private javax.swing.JTextField jTextFieldNazSmesi;
    private javax.swing.JTextField jTextFieldNazevProudu;
    private javax.swing.JTextField jTextFieldcProud;
    private javax.swing.JTextField jTextFieldpVstup;
    private javax.swing.JTextField jTextFieldpVystup;
    private javax.swing.JTextField jTextFieldtVstup;
    private javax.swing.JTextField jTextFieldtVystup;
    private javax.swing.JToggleButton jToggleButtonDocas;
    // End of variables declaration//GEN-END:variables
}
