/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package cheminzlib;

import javax.swing.JOptionPane;

/**
 * Třída modálního vyskakovacího panelu pro zadávání parametrů chemické reakce.
 * Volat nejsnadněji jako:<br>
 * Reakce reak = new Reakce();<br>
 * reak.zadejParametryInteraktivne();<br> nebo složitěji: <br>
 * JDialogReakceInp jdpi = new JDialogReakceInp(null, true);<br>
 * nebo<br> Reakce reak = new Reakce();<br>
 *      JDialogReakceInp jdri = new JDialogReakceInp(null,reak, true);<br>
 * a pak:<br> jdri.setVisible(true); <br>
 *      reak = jdri.getReakce(); (jen v případě prvního způsobu)<br>
 * Jinak lze parametry reakce zadávat softwarově přes konstruktory a funkce set.
 * @author V. Hlubuček
 */
public class JDialogReakceInp extends javax.swing.JDialog {

    final double TABS = 273.15; 
    Reakce rea;
    

    /**
     * Vytvoří nový form JDialogReakceInp
     * @param parent obvykle null
     * @param modal
     */
    public JDialogReakceInp(java.awt.Frame parent, boolean modal) {
        super(parent, modal);   // volání rodičovského konstruktoru
        initComponents();
        rea = new Reakce();
        myInit();
    }
    /**
     * Vytvoří nový form JDialogReakceInp
     * @param parent obvykle null
     * @param modal
     * @param rea
     */
    public JDialogReakceInp(java.awt.Frame parent, Reakce rea, boolean modal) {
        super(parent, modal);   // volání rodičovského konstruktoru
        initComponents();
        this.rea = rea;
        myInit();
    }
    
    private void myInit() {

        this.setTitle("Interaktivní zadání parametrů chemické reakce č. : " + Reakce.pocetReakci);
    
    }   
/**
 * Vrací interaktivně zadanou reakci
 * aby ji uživatel mohl použít ve svém programu
 * @return 
 */
    public Reakce getReakci() {
        return rea;
    }
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jTextFieldNazev = new javax.swing.JTextField();
        jPanel1 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jTextFieldCisSloz1 = new javax.swing.JTextField();
        jTextFieldStech1 = new javax.swing.JTextField();
        jCheckBoxKin1 = new javax.swing.JCheckBox();
        jTextFieldCisSloz2 = new javax.swing.JTextField();
        jTextFieldStech2 = new javax.swing.JTextField();
        jCheckBoxKin2 = new javax.swing.JCheckBox();
        jTextFieldCisSloz3 = new javax.swing.JTextField();
        jTextFieldStech3 = new javax.swing.JTextField();
        jCheckBoxKin3 = new javax.swing.JCheckBox();
        jLabel6 = new javax.swing.JLabel();
        jTextFieldCisSloz4 = new javax.swing.JTextField();
        jTextFieldStech4 = new javax.swing.JTextField();
        jCheckBoxKin4 = new javax.swing.JCheckBox();
        jTextFieldCisSloz5 = new javax.swing.JTextField();
        jTextFieldStech5 = new javax.swing.JTextField();
        jCheckBoxKin5 = new javax.swing.JCheckBox();
        jTextFieldCisSloz6 = new javax.swing.JTextField();
        jTextFieldStech6 = new javax.swing.JTextField();
        jCheckBoxKin6 = new javax.swing.JCheckBox();
        jLabelSl1 = new javax.swing.JLabel();
        jLabelSl2 = new javax.swing.JLabel();
        jLabelSl3 = new javax.swing.JLabel();
        jLabelSl4 = new javax.swing.JLabel();
        jLabelSl5 = new javax.swing.JLabel();
        jLabelSl6 = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        jLabel7 = new javax.swing.JLabel();
        jTextFieldRychKonst = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        jTextFieldRefT = new javax.swing.JTextField();
        jLabel9 = new javax.swing.JLabel();
        jTextFieldAktE = new javax.swing.JTextField();
        jLabel10 = new javax.swing.JLabel();
        jTextFielddH = new javax.swing.JTextField();
        jLabel11 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        jTextFieldKinSloz1 = new javax.swing.JTextField();
        jTextFieldRad1 = new javax.swing.JTextField();
        jTextFieldKinSloz2 = new javax.swing.JTextField();
        jTextFieldRad2 = new javax.swing.JTextField();
        jTextFieldKinSloz3 = new javax.swing.JTextField();
        jTextFieldRad3 = new javax.swing.JTextField();
        jLabel14 = new javax.swing.JLabel();
        jTextFieldRovn = new javax.swing.JTextField();
        jLabel15 = new javax.swing.JLabel();
        jTextFieldRefTr = new javax.swing.JTextField();
        jLabel13 = new javax.swing.JLabel();
        jButtonReak = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jLabel1.setText("Název reakce:");

        jPanel1.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jLabel2.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jLabel2.setText("Reaktanty:");

        jLabel3.setText("Čís.složky");

        jLabel4.setText("Stech.koef.");

        jLabel5.setText("Je kinetická?\n");

        jTextFieldCisSloz1.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextFieldCisSloz1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jTextFieldCisSloz1KeyTyped(evt);
            }
        });

        jTextFieldStech1.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jCheckBoxKin1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxKin1ActionPerformed(evt);
            }
        });

        jTextFieldCisSloz2.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextFieldCisSloz2.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jTextFieldCisSloz2KeyTyped(evt);
            }
        });

        jTextFieldStech2.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jCheckBoxKin2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxKin2ActionPerformed(evt);
            }
        });

        jTextFieldCisSloz3.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextFieldCisSloz3.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jTextFieldCisSloz3KeyTyped(evt);
            }
        });

        jTextFieldStech3.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel6.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jLabel6.setText("Produkty:");

        jTextFieldCisSloz4.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextFieldCisSloz4.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jTextFieldCisSloz4KeyTyped(evt);
            }
        });

        jTextFieldStech4.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jTextFieldCisSloz5.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextFieldCisSloz5.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jTextFieldCisSloz5KeyTyped(evt);
            }
        });

        jTextFieldStech5.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jTextFieldCisSloz6.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextFieldCisSloz6.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jTextFieldCisSloz6KeyTyped(evt);
            }
        });

        jTextFieldStech6.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jTextFieldCisSloz4, javax.swing.GroupLayout.PREFERRED_SIZE, 55, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jTextFieldStech4, javax.swing.GroupLayout.PREFERRED_SIZE, 58, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jLabel2)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                .addComponent(jTextFieldCisSloz3, javax.swing.GroupLayout.DEFAULT_SIZE, 57, Short.MAX_VALUE)
                                .addComponent(jTextFieldCisSloz2)
                                .addComponent(jTextFieldCisSloz1, javax.swing.GroupLayout.Alignment.LEADING))
                            .addComponent(jLabel3))
                        .addGap(18, 18, 18)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jTextFieldStech3)
                            .addComponent(jTextFieldStech2)
                            .addComponent(jLabel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jTextFieldStech1))
                        .addGap(18, 18, 18)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel5)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGap(10, 10, 10)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jCheckBoxKin1)
                                    .addComponent(jCheckBoxKin2)
                                    .addComponent(jCheckBoxKin3)
                                    .addComponent(jCheckBoxKin4)
                                    .addComponent(jCheckBoxKin5)
                                    .addComponent(jCheckBoxKin6))
                                .addGap(34, 34, 34)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabelSl6, javax.swing.GroupLayout.PREFERRED_SIZE, 173, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jLabelSl5, javax.swing.GroupLayout.PREFERRED_SIZE, 173, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jLabelSl4, javax.swing.GroupLayout.PREFERRED_SIZE, 173, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jLabelSl3, javax.swing.GroupLayout.PREFERRED_SIZE, 189, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jLabelSl2, javax.swing.GroupLayout.PREFERRED_SIZE, 189, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jLabelSl1, javax.swing.GroupLayout.PREFERRED_SIZE, 189, javax.swing.GroupLayout.PREFERRED_SIZE)))))
                    .addComponent(jLabel6)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jTextFieldCisSloz5, javax.swing.GroupLayout.PREFERRED_SIZE, 55, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jTextFieldStech5, javax.swing.GroupLayout.PREFERRED_SIZE, 58, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jTextFieldCisSloz6, javax.swing.GroupLayout.PREFERRED_SIZE, 55, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jTextFieldStech6, javax.swing.GroupLayout.PREFERRED_SIZE, 58, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel2)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                            .addComponent(jLabel3)
                                            .addComponent(jLabel4)
                                            .addComponent(jLabel5))
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                            .addComponent(jTextFieldCisSloz1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                            .addComponent(jTextFieldStech1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                            .addComponent(jCheckBoxKin1)))
                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                        .addGap(23, 23, 23)
                                        .addComponent(jLabelSl1)))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 6, Short.MAX_VALUE)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jCheckBoxKin2)
                                    .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                        .addComponent(jTextFieldCisSloz2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addComponent(jTextFieldStech2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))))
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGap(0, 0, Short.MAX_VALUE)
                                .addComponent(jLabelSl2)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jCheckBoxKin3)
                            .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                .addComponent(jTextFieldCisSloz3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(jTextFieldStech3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(0, 0, Short.MAX_VALUE)
                        .addComponent(jLabelSl3)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jLabel6)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addComponent(jCheckBoxKin4, javax.swing.GroupLayout.Alignment.TRAILING)
                                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                            .addComponent(jTextFieldCisSloz4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                            .addComponent(jTextFieldStech4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                    .addComponent(jLabelSl4))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jCheckBoxKin5, javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                        .addComponent(jTextFieldCisSloz5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addComponent(jTextFieldStech5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))))
                            .addComponent(jLabelSl5))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jCheckBoxKin6)
                            .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                .addComponent(jTextFieldCisSloz6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(jTextFieldStech6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))))
                    .addComponent(jLabelSl6))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jLabel7.setText("Rychlostní konst.:");

        jTextFieldRychKonst.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel8.setText("Ref.teplota (°C):");

        jTextFieldRefT.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel9.setText("Aktiv.energie(J/mol):");

        jTextFieldAktE.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel10.setText("Reak.entalpie (J/mol):");

        jTextFielddH.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel11.setText("Kinetická složka");

        jLabel12.setText("Reakční řád");

        jTextFieldKinSloz1.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jTextFieldRad1.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jTextFieldKinSloz2.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jTextFieldRad2.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jTextFieldKinSloz3.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jTextFieldRad3.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel14.setText("Rovnovážná konst.:");

        jTextFieldRovn.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel15.setText("Ref.teplota rovn.k.\n (°C):");

        jTextFieldRefTr.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addComponent(jLabel11)
                                .addGap(15, 15, 15)
                                .addComponent(jLabel12)
                                .addGap(14, 14, 14))
                            .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                .addGroup(jPanel2Layout.createSequentialGroup()
                                    .addComponent(jTextFieldKinSloz1, javax.swing.GroupLayout.PREFERRED_SIZE, 55, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(jTextFieldRad1, javax.swing.GroupLayout.PREFERRED_SIZE, 58, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(jPanel2Layout.createSequentialGroup()
                                        .addComponent(jTextFieldKinSloz2, javax.swing.GroupLayout.PREFERRED_SIZE, 55, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addGap(131, 131, 131))
                                    .addComponent(jTextFieldRad2, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 58, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(jPanel2Layout.createSequentialGroup()
                                        .addComponent(jTextFieldKinSloz3, javax.swing.GroupLayout.PREFERRED_SIZE, 55, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addGap(131, 131, 131))
                                    .addComponent(jTextFieldRad3, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 58, javax.swing.GroupLayout.PREFERRED_SIZE))))
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel7)
                                    .addComponent(jLabel9))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jTextFieldAktE, javax.swing.GroupLayout.PREFERRED_SIZE, 91, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jTextFieldRychKonst, javax.swing.GroupLayout.PREFERRED_SIZE, 91, javax.swing.GroupLayout.PREFERRED_SIZE)))
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addComponent(jLabel14)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(jTextFieldRovn, javax.swing.GroupLayout.PREFERRED_SIZE, 91, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addGap(35, 35, 35)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addComponent(jLabel15)
                                .addGap(33, 33, 33)
                                .addComponent(jTextFieldRefTr))
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel8)
                                    .addComponent(jLabel10))
                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(jPanel2Layout.createSequentialGroup()
                                        .addGap(48, 48, 48)
                                        .addComponent(jTextFieldRefT))
                                    .addGroup(jPanel2Layout.createSequentialGroup()
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addComponent(jTextFielddH, javax.swing.GroupLayout.PREFERRED_SIZE, 88, javax.swing.GroupLayout.PREFERRED_SIZE)))))))
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel7)
                    .addComponent(jTextFieldRychKonst, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel8)
                    .addComponent(jTextFieldRefT, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel9)
                    .addComponent(jTextFieldAktE, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel10)
                    .addComponent(jTextFielddH, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel14)
                    .addComponent(jTextFieldRovn, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel15)
                    .addComponent(jTextFieldRefTr, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 21, Short.MAX_VALUE)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel11)
                    .addComponent(jLabel12))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextFieldKinSloz1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jTextFieldRad1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextFieldKinSloz2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jTextFieldRad2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextFieldKinSloz3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jTextFieldRad3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jLabel13.setText("<html>Vkládejte čísla složek reaktantů a produktů. Pokud neznáte vložte <b>?</b> vyberte složku ze seznamu látek.  Pak ke složce zadejte jeí stechiometrický koeficint v reakci. Záporně reaktanty, kladně produkty. Nakonec označte, zda je složka kinetická, t.zn., že její koncentrace vystupuje v kinetické rovnici.<br>Pak vložte hodnotu rychlostní konstanty a její referenční  teplotu  (°C), aktivační energii a tepelné zabarvení reakce (exotermní záporně). Je-li reakce rovnovážná, vložte rovnovážnou konstantu a její ref. teplotu(°C). Nakonec vyplňte konetické řády.  </html>");
        jLabel13.setVerticalAlignment(javax.swing.SwingConstants.TOP);

        jButtonReak.setText("<html>Parametry reakce<br> zadány</html>");
        jButtonReak.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonReakActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addGap(18, 18, 18)
                        .addComponent(jTextFieldNazev, javax.swing.GroupLayout.PREFERRED_SIZE, 356, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jButtonReak, javax.swing.GroupLayout.PREFERRED_SIZE, 162, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel13, javax.swing.GroupLayout.PREFERRED_SIZE, 171, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(28, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jTextFieldNazev, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(jLabel13, javax.swing.GroupLayout.PREFERRED_SIZE, 366, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jButtonReak, javax.swing.GroupLayout.PREFERRED_SIZE, 38, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(9, 9, 9)
                        .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(21, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonReakActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonReakActionPerformed
        // Ukončeno zadání reakce
        rea.nazevReakce = jTextFieldNazev.getText();
        int i = 0;
        int[] iSlozky = new int[6];
        jTextFieldCisSloz1.setText(jTextFieldCisSloz1.getText().trim());
        if(!jTextFieldCisSloz1.getText().equals("")) {iSlozky[i] = Integer.parseInt(jTextFieldCisSloz1.getText()); i++;}
        jTextFieldCisSloz2.setText(jTextFieldCisSloz2.getText().trim());
        if(!jTextFieldCisSloz2.getText().equals("")) {iSlozky[i] = Integer.parseInt(jTextFieldCisSloz2.getText()); i++;}
        jTextFieldCisSloz3.setText(jTextFieldCisSloz3.getText().trim());
        if(!jTextFieldCisSloz3.getText().equals("")) {iSlozky[i] = Integer.parseInt(jTextFieldCisSloz3.getText()); i++;}
        jTextFieldCisSloz4.setText(jTextFieldCisSloz4.getText().trim());
        if(!jTextFieldCisSloz4.getText().equals("")) {iSlozky[i] = Integer.parseInt(jTextFieldCisSloz4.getText()); i++;}
        jTextFieldCisSloz5.setText(jTextFieldCisSloz5.getText().trim());
        if(!jTextFieldCisSloz5.getText().equals("")) {iSlozky[i] = Integer.parseInt(jTextFieldCisSloz5.getText()); i++;}
        jTextFieldCisSloz6.setText(jTextFieldCisSloz6.getText().trim());
        if(!jTextFieldCisSloz6.getText().equals("")) {iSlozky[i] = Integer.parseInt(jTextFieldCisSloz6.getText()); i++;}
        rea.iSlozky = new int[i];
        for(int j = 0; j < i; j++) rea.iSlozky[j] = iSlozky[j];
        i = 0;
        iSlozky = new int[6];
        if(!jTextFieldStech1.getText().equals("")) {iSlozky[i] = Integer.parseInt(jTextFieldStech1.getText()); if(iSlozky[i]>0) iSlozky[i] = - iSlozky[i]; i++;}
        if(!jTextFieldStech2.getText().equals("")) {iSlozky[i] = Integer.parseInt(jTextFieldStech2.getText()); if(iSlozky[i]>0) iSlozky[i] = - iSlozky[i]; i++;}
        if(!jTextFieldStech3.getText().equals("")) {iSlozky[i] = Integer.parseInt(jTextFieldStech3.getText()); if(iSlozky[i]>0) iSlozky[i] = - iSlozky[i]; i++;}
        if(!jTextFieldStech4.getText().equals("")) {iSlozky[i] = Integer.parseInt(jTextFieldStech4.getText()); i++;}
        if(!jTextFieldStech5.getText().equals("")) {iSlozky[i] = Integer.parseInt(jTextFieldStech5.getText()); i++;}
        if(!jTextFieldStech6.getText().equals("")) {iSlozky[i] = Integer.parseInt(jTextFieldStech6.getText()); i++;}
        if(iSlozky[0] == 0 && iSlozky[1] == 0) {
            int input = JOptionPane.showOptionDialog(null, "Musíte zadat i stechiometrické koeficienty reakce!\n"
                    + "Mám ukončit program? (OK)" 
                    , "Reakce - data", JOptionPane.OK_CANCEL_OPTION, 
                    JOptionPane.INFORMATION_MESSAGE, null, null, null);
            if(input == JOptionPane.OK_OPTION) System.exit(0);
            return;                                   
        }
        rea.iStech = new int[i];
        for(int j = 0; j < i; j++) rea.iStech[j] = iSlozky[j];
        i = 0;
        iSlozky = new int[3];
        rea.iKinSloz = new int[3];
        if(jCheckBoxKin1.isSelected()) {iSlozky[i] = rea.iSlozky[i]; jTextFieldKinSloz1.setText("" + rea.iSlozky[i]); i++;}
        if(jCheckBoxKin2.isSelected()) {iSlozky[i] = rea.iSlozky[i]; jTextFieldKinSloz2.setText("" + rea.iSlozky[i]); i++;}
        if(jCheckBoxKin3.isSelected()) {iSlozky[i] = rea.iSlozky[i]; jTextFieldKinSloz3.setText("" + rea.iSlozky[i]); i++;}
        rea.iKinSloz = new int[i];
        for(int j = 0; j < i; j++) rea.iKinSloz[j] = iSlozky[j];        
        rea.k0 = doubleFromString(jTextFieldRychKonst.getText());
        rea.t0 = doubleFromString(jTextFieldRefT.getText()) + TABS;
        rea.eAkt = doubleFromString(jTextFieldAktE.getText());
        rea.dH = doubleFromString(jTextFielddH.getText());
        rea.kR0 = doubleFromString(jTextFieldRovn.getText());
        rea.tR0 = doubleFromString(jTextFieldRefTr.getText()) + TABS;
        i = 0;
        rea.radSlozky = new double[3];
        if(!jTextFieldRad1.getText().equals("")) {rea.radSlozky[i] = doubleFromString(jTextFieldRad1.getText()); i++;}        
        if(!jTextFieldRad2.getText().equals("")) {rea.radSlozky[i] = doubleFromString(jTextFieldRad2.getText()); i++;}        
        if(!jTextFieldRad3.getText().equals("")) {rea.radSlozky[i] = doubleFromString(jTextFieldRad3.getText()); i++;} 
        if(rea.k0 * rea.geteAkt() * rea.iKinSloz[0] == 0) {
            JOptionPane.showMessageDialog(null,
                "Nezadali jste některé kinetické parametry!" ,
                "Prametry reakce", JOptionPane.WARNING_MESSAGE);
        return;
        }
        this.dispose();     // zavřít okno
        

    }//GEN-LAST:event_jButtonReakActionPerformed

    private void jCheckBoxKin1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxKin1ActionPerformed
        // Složka 1 je kinetická
        if(jCheckBoxKin1.isSelected()) jTextFieldKinSloz1.setText(jTextFieldCisSloz1.getText());
    }//GEN-LAST:event_jCheckBoxKin1ActionPerformed

    private void jCheckBoxKin2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxKin2ActionPerformed
        // Složka 2 je kinetická
        if(jCheckBoxKin2.isSelected()) jTextFieldKinSloz2.setText(jTextFieldCisSloz2.getText());
    }//GEN-LAST:event_jCheckBoxKin2ActionPerformed

    private void jTextFieldCisSloz1KeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextFieldCisSloz1KeyTyped
        // Zadán otazník
       if (evt.getKeyChar() >= '?')   {
          JDialogSeznam jdsi = new JDialogSeznam(null, true); // interaktivní vstup dat proudu
          jdsi.setVisible(true);
          evt.setKeyChar(' ');
          jTextFieldCisSloz1.setText("" + jdsi.getcSlozky());
          jTextFieldCisSloz1.setText(jTextFieldCisSloz1.getText().trim());
          jLabelSl1.setText(jdsi.getNazev().substring(4,48));
       }      
    }//GEN-LAST:event_jTextFieldCisSloz1KeyTyped

    private void jTextFieldCisSloz2KeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextFieldCisSloz2KeyTyped
        // Zadán otazník
       if (evt.getKeyChar() >= '?')   {
          JDialogSeznam jdsi = new JDialogSeznam(null, true); // interaktivní vstup dat proudu
          jdsi.setVisible(true);
          evt.setKeyChar(' ');
          jTextFieldCisSloz2.setText("" + jdsi.getcSlozky());
          jTextFieldCisSloz2.setText(jTextFieldCisSloz2.getText().trim());
          jLabelSl2.setText(jdsi.getNazev().substring(4,48));          
       }        
    }//GEN-LAST:event_jTextFieldCisSloz2KeyTyped

    private void jTextFieldCisSloz3KeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextFieldCisSloz3KeyTyped
        // Zadán otazník
       if (evt.getKeyChar() >= '?')   {
          JDialogSeznam jdsi = new JDialogSeznam(null, true); // interaktivní vstup dat proudu
          jdsi.setVisible(true);
          evt.setKeyChar(' ');
          jTextFieldCisSloz3.setText("" + jdsi.getcSlozky());
          jTextFieldCisSloz3.setText(jTextFieldCisSloz3.getText().trim());
          jLabelSl3.setText(jdsi.getNazev().substring(4,48));          
       } 
    }//GEN-LAST:event_jTextFieldCisSloz3KeyTyped

    private void jTextFieldCisSloz4KeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextFieldCisSloz4KeyTyped
        // Zadán otazník
       if (evt.getKeyChar() >= '?')   {
          JDialogSeznam jdsi = new JDialogSeznam(null, true); // interaktivní vstup dat proudu
          jdsi.setVisible(true);
          evt.setKeyChar(' ');
          jTextFieldCisSloz4.setText("" + jdsi.getcSlozky());
          jTextFieldCisSloz4.setText(jTextFieldCisSloz4.getText().trim());
          jLabelSl4.setText(jdsi.getNazev().substring(4,48));                    
       } 
    }//GEN-LAST:event_jTextFieldCisSloz4KeyTyped

    private void jTextFieldCisSloz5KeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextFieldCisSloz5KeyTyped
        // Zadán otazník
       if (evt.getKeyChar() >= '?')   {
          JDialogSeznam jdsi = new JDialogSeznam(null, true); // interaktivní vstup dat proudu
          jdsi.setVisible(true);
          evt.setKeyChar(' ');
          jTextFieldCisSloz5.setText("" + jdsi.getcSlozky());
          jTextFieldCisSloz5.setText(jTextFieldCisSloz5.getText().trim());
          jLabelSl5.setText(jdsi.getNazev().substring(4,48));                    
       } 
    }//GEN-LAST:event_jTextFieldCisSloz5KeyTyped

    private void jTextFieldCisSloz6KeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextFieldCisSloz6KeyTyped
        // Zadán otazník
       if (evt.getKeyChar() >= '?')   {
          JDialogSeznam jdsi = new JDialogSeznam(null, true); // interaktivní vstup dat proudu
          jdsi.setVisible(true);
          evt.setKeyChar(' ');
          jTextFieldCisSloz6.setText("" + jdsi.getcSlozky());
          jTextFieldCisSloz6.setText(jTextFieldCisSloz6.getText().trim());
          jLabelSl6.setText(jdsi.getNazev().substring(4,48));                    
       } 
    }//GEN-LAST:event_jTextFieldCisSloz6KeyTyped
/**
 * Pomocná funkce převádí string na hodnotu double
 * @param tx
 * @return 
 */    
    protected double doubleFromString(String tx)  {
        return (tx.equals("")) ? 0:Double.parseDouble(tx.replace(',', '.'));
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(JDialogReakceInp.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(JDialogReakceInp.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(JDialogReakceInp.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(JDialogReakceInp.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the dialog */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                JDialogReakceInp dialog = new JDialogReakceInp(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonReak;
    private javax.swing.JCheckBox jCheckBoxKin1;
    private javax.swing.JCheckBox jCheckBoxKin2;
    private javax.swing.JCheckBox jCheckBoxKin3;
    private javax.swing.JCheckBox jCheckBoxKin4;
    private javax.swing.JCheckBox jCheckBoxKin5;
    private javax.swing.JCheckBox jCheckBoxKin6;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JLabel jLabelSl1;
    private javax.swing.JLabel jLabelSl2;
    private javax.swing.JLabel jLabelSl3;
    private javax.swing.JLabel jLabelSl4;
    private javax.swing.JLabel jLabelSl5;
    private javax.swing.JLabel jLabelSl6;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JTextField jTextFieldAktE;
    private javax.swing.JTextField jTextFieldCisSloz1;
    private javax.swing.JTextField jTextFieldCisSloz2;
    private javax.swing.JTextField jTextFieldCisSloz3;
    private javax.swing.JTextField jTextFieldCisSloz4;
    private javax.swing.JTextField jTextFieldCisSloz5;
    private javax.swing.JTextField jTextFieldCisSloz6;
    private javax.swing.JTextField jTextFieldKinSloz1;
    private javax.swing.JTextField jTextFieldKinSloz2;
    private javax.swing.JTextField jTextFieldKinSloz3;
    private javax.swing.JTextField jTextFieldNazev;
    private javax.swing.JTextField jTextFieldRad1;
    private javax.swing.JTextField jTextFieldRad2;
    private javax.swing.JTextField jTextFieldRad3;
    private javax.swing.JTextField jTextFieldRefT;
    private javax.swing.JTextField jTextFieldRefTr;
    private javax.swing.JTextField jTextFieldRovn;
    private javax.swing.JTextField jTextFieldRychKonst;
    private javax.swing.JTextField jTextFieldStech1;
    private javax.swing.JTextField jTextFieldStech2;
    private javax.swing.JTextField jTextFieldStech3;
    private javax.swing.JTextField jTextFieldStech4;
    private javax.swing.JTextField jTextFieldStech5;
    private javax.swing.JTextField jTextFieldStech6;
    private javax.swing.JTextField jTextFielddH;
    // End of variables declaration//GEN-END:variables
}
