/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package cheminzlib;

import fydatlib.Latka;
import java.awt.event.KeyEvent;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.DefaultListModel;
import org.jdom2.JDOMException;

/**
 *  Vyskakovací okno pro výběr složky směsi<br>
 * volat jako:<br>
 * JDialogSeznam jdsi = new JDialogSeznam(null, true); <br>
 * jdsi.setVisible(true);<br>
 * jdsi.getcSlozky();     číslo vybrané složky<br>
 * jdsi.getNazev();       její název<br>
 * @author V. Hlubuček
 */
public class JDialogSeznam extends javax.swing.JDialog {
    int cSlozky;
    String nazev;
    /**
     * Vytváří nový formulář JDialogSeznam látek databáze pro výběr složek
     */
    public JDialogSeznam(java.awt.Frame parent, boolean modal) {
        super(parent, modal);   // volání rodičovského konstruktoru
        initComponents();
        myInit();
    }
/**
 * Pomocná vlastní inicializace
 * naplnění seznamu látek
 */
    private void myInit() {
        this.setTitle("Seznam látek v databázi fyzikálních vlastností" );
        try {
            naplnSeznam2(); // seznam látek pomocí Default list modelu
        } catch (JDOMException ex) {
            Logger.getLogger(JDialogSeznam.class.getName()).log(Level.SEVERE, null, ex);            
        } catch (IOException ex) {
            Logger.getLogger(JDialogSeznam.class.getName()).log(Level.SEVERE, null, ex);
        }
    }   
/**
 * Vrací číslo zvolené složky ze seznamu
 * @return 
 */
    public int getcSlozky() {
        return cSlozky;
    }
/**
 * Vrací názec zvolené složky ze seznamu
 * @return 
 */
    public String getNazev() {
        return nazev;
    }


    /**
     * Vlastní naplnění seznamu látek
     * @throws IOException
     */
    void naplnSeznam2() throws IOException, JDOMException {
        String[] s;       // původně: muselo být přesně 533 jinak chyby!?
//        Font fontCur = new Font("Courier", Font.BOLD,  12);
        int nLat;
        ((DefaultListModel) jList1.getModel()).removeAllElements();
        s = Latka.seznamLatek(true);  // true - dle abecedy
        nLat = s.length;
        for (int i = 0; i < nLat; i++) {
            ((DefaultListModel) jList1.getModel()).addElement(s[i]);  // vkládání přes model
        }
    }
    
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jList1 = new javax.swing.JList();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jList1.setFont(new java.awt.Font("Lucida Sans Typewriter", 1, 11)); // NOI18N
        jList1.setModel(new DefaultListModel());
        jList1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jList1MouseClicked(evt);
            }
        });
        jList1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                jList1KeyPressed(evt);
            }
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jList1KeyTyped(evt);
            }
        });
        jScrollPane1.setViewportView(jList1);

        jLabel1.setText("Č.látky    Název                                                          Vzorec            Synonyma");

        jLabel2.setText("<html><p>Stisk jednoho písmene<br> nastaví na látky od tohoto písmene. Seznam ovšem musí mít fokus.</p><p> Dvojklikem nebo Entrem látku vyberete.</p></html>");
        jLabel2.setVerticalAlignment(javax.swing.SwingConstants.TOP);

        jButton1.setText("Složka vybrána");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 494, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(26, 26, 26)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE)
                            .addComponent(jButton1, javax.swing.GroupLayout.DEFAULT_SIZE, 156, Short.MAX_VALUE)))
                    .addComponent(jLabel1))
                .addContainerGap(38, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(27, 27, 27)
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 489, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap(51, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 139, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jButton1)
                        .addGap(93, 93, 93))))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jList1KeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jList1KeyTyped
        // Listování "písmeny" v seznamu
        int k;
        String s;
        if (evt.getKeyChar() >= 'A' && evt.getKeyChar() <= 'z') {  // nastaví list na stisk písmene
            for (k = 0; k < jList1.getModel().getSize(); k++) {
                s = (String) ((DefaultListModel) jList1.getModel()).getElementAt(k);
                s = s.toLowerCase();
                if (evt.getKeyChar() <= s.charAt(4)) {
                    jList1.ensureIndexIsVisible(530);    // aby nejprve zajel na konec
                    jList1.ensureIndexIsVisible(k);
                    break;
                }
            }
        }

    }//GEN-LAST:event_jList1KeyTyped

    private void jList1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jList1MouseClicked
        // Výběr látky dvojklikem
        String s;
        if (evt.getClickCount() == 2 ) {
            s = (String) jList1.getSelectedValue();
            cSlozky = Integer.valueOf(s.substring(0, 3).trim()); // první znaky č. látky
            nazev = s;
        this.dispose();
        }
    }//GEN-LAST:event_jList1MouseClicked

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        // Ukončení tlačítkem po výběru klikem
        String s;
        s = (String) jList1.getSelectedValue();
        nazev = s;
        cSlozky = Integer.valueOf(s.substring(0, 3).trim()); // první znaky č. látky 
        this.dispose();     // zavřít seznam látek
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jList1KeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jList1KeyPressed
        // Ukončení zadání proudu Enterem
        if (evt.getKeyChar() == KeyEvent.VK_ENTER) {
           String s = (String) jList1.getSelectedValue(); 
            nazev = s;
            cSlozky = Integer.valueOf(s.substring(0, 3).trim()); // první znaky č. látky 
            this.dispose();     // zavřít seznam látek        
        }           
    }//GEN-LAST:event_jList1KeyPressed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(JDialogSeznam.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(JDialogSeznam.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(JDialogSeznam.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(JDialogSeznam.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the dialog */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                JDialogSeznam dialog = new JDialogSeznam(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JList jList1;
    private javax.swing.JScrollPane jScrollPane1;
    // End of variables declaration//GEN-END:variables
}
