/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cheminzlib;

import java.awt.Font;

/**
 * Třída panelu pro zobrazení výsledků proudu. Lze použít samostatně v 
 * uživatelském Frame nebo je také použit v modálním dialogu.
 * @author V.Hlubuček
 */
public class JPanelProud extends javax.swing.JPanel {

    private Proud pr;
    private final double TABS = 273.15;

    /**
     * Creates new form JPanelProud
     */
    public JPanelProud() {
        initComponents();
        myInit();
    }
    
    /**
     * Creates new form JPanelProud
     * a dosadí do panelu hodnoty z pr
     */
    public JPanelProud(Proud pr) {
        initComponents();
        this.pr = pr;
        myInit();
    }    
    /**
     * Uživatelská inicializace panelu
     */
    public void myInit() {
        if (pr == null) return;
        jTextFieldcProud.setText(""+pr.getcProudu());
        jTextFieldNazevProudu.setText(pr.getNazProudu());
        jTextFieldZApar.setText((pr.zUzlu == null) ? "":pr.zUzlu.nazevAparatu);
        jTextFieldDoApar.setText((pr.doUzlu == null) ? "":pr.doUzlu.nazevAparatu);
        if(pr.getNazProudu().substring(0, 5).toUpperCase().equals("BATCH")) {
            jLabel3.setText("Hmotnost vsádky (kg)");
            jTextFieldHmPrutok.setText(String.format("%7.4g", pr.getPom()));
        } else {
            jTextFieldHmPrutok.setText(String.format("%7.4g", pr.getHmotPrutok()));
        }
        jTextFieldpVstup.setText(String.format("%7.0f", pr.getpVstup()));
        jTextFieldpVystup.setText(String.format("%7.0f", pr.getpVystup()));
        jTextFieldtVstup.setText(String.format("%5.1f", pr.gettVstup()));
        jTextFieldtVystup.setText(String.format("%5.1f", pr.gettVystup()));
        jTextFieldTlakZtr.setText(String.format("%6.0f", pr.getpVstup()-pr.getpVystup()));
        jTextAreaSlozeni.setText(pr.getSmes().getSlozeni());
        jTextAreaReport.setText(pr.getVysledek());
        jTextFieldPocElem.setText(String.format("%3d",pr.getnElem()));
        jTextFieldtVystup.setToolTipText(String.format("%5.1f (K)", pr.gettVystup()+TABS));
        jTextFieldtVstup.setToolTipText(String.format("%5.1f (K)", pr.gettVstup()+TABS));
        jTextFieldpVystup.setToolTipText(String.format("%5.3f (MPa)", pr.getpVystup()/1e6));
        jTextFieldpVstup.setToolTipText(String.format("%5.3f (MPa)", pr.getpVstup()/1e6));
        jTextFieldHmPrutok.setToolTipText(String.format("%7.2f (kg/h)%n  %6.5f (m3/s)", 
          pr.getHmotPrutok()*3600,pr.getHmotPrutok()/pr.getSmes().sHust(pr.gettVstup()+TABS, pr.getpVstup())));
        jTextFieldTlakZtr.setToolTipText(String.format("%7.2f (kPa)", (pr.getpVstup()-pr.getpVystup())/1000));
        jTextFieldSpocten.setText((pr.spocten) ? "ANO": "NE");
    }
/**
 * Nastaví proud pro JPanelProud
 * @param pr 
 */
    public void setPr(Proud pr) {
        this.pr = pr;
    }
    
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jTextFieldcProud = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jTextFieldNazevProudu = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jTextFieldHmPrutok = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        jTextFieldpVstup = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        jTextFieldpVystup = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        jTextFieldTlakZtr = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        jTextFieldtVstup = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        jTextFieldtVystup = new javax.swing.JTextField();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextAreaSlozeni = new javax.swing.JTextArea();
        jLabel9 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTextAreaReport = new javax.swing.JTextArea();
        jLabel11 = new javax.swing.JLabel();
        jTextFieldPocElem = new javax.swing.JTextField();
        jLabelSpocten = new javax.swing.JLabel();
        jTextFieldSpocten = new javax.swing.JTextField();
        jLabel12 = new javax.swing.JLabel();
        jTextFieldZApar = new javax.swing.JTextField();
        jLabel13 = new javax.swing.JLabel();
        jTextFieldDoApar = new javax.swing.JTextField();

        jLabel1.setText("Proud č.:");

        jTextFieldcProud.setEditable(false);
        jTextFieldcProud.setBackground(new java.awt.Color(255, 255, 255));
        jTextFieldcProud.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N

        jLabel2.setText("Název proudu:");

        jTextFieldNazevProudu.setEditable(false);
        jTextFieldNazevProudu.setBackground(new java.awt.Color(255, 255, 255));
        jTextFieldNazevProudu.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N

        jLabel3.setText("Hmotový průtok (kg/s):");

        jTextFieldHmPrutok.setEditable(false);
        jTextFieldHmPrutok.setBackground(new java.awt.Color(255, 255, 255));
        jTextFieldHmPrutok.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N

        jLabel4.setText("Tlak na vstupu (Pa):");

        jTextFieldpVstup.setEditable(false);
        jTextFieldpVstup.setBackground(new java.awt.Color(255, 255, 255));
        jTextFieldpVstup.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N

        jLabel5.setText("Tlak na výstupu (Pa):");

        jTextFieldpVystup.setEditable(false);
        jTextFieldpVystup.setBackground(new java.awt.Color(255, 255, 255));
        jTextFieldpVystup.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N

        jLabel6.setText("Tlaková ztráta (Pa):");

        jTextFieldTlakZtr.setEditable(false);
        jTextFieldTlakZtr.setBackground(new java.awt.Color(255, 255, 255));
        jTextFieldTlakZtr.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N

        jLabel7.setText("Teplota na vstupu (°C):");

        jTextFieldtVstup.setEditable(false);
        jTextFieldtVstup.setBackground(new java.awt.Color(255, 255, 255));
        jTextFieldtVstup.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N

        jLabel8.setText("Teplota na výstupu (°C):");

        jTextFieldtVystup.setEditable(false);
        jTextFieldtVystup.setBackground(new java.awt.Color(255, 255, 255));
        jTextFieldtVystup.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jTextFieldtVystup.setToolTipText("");

        jTextAreaSlozeni.setColumns(20);
        jTextAreaSlozeni.setFont(new Font("monospaced", Font.BOLD,11));
        jTextAreaSlozeni.setRows(5);
        jScrollPane1.setViewportView(jTextAreaSlozeni);

        jLabel9.setText("Složení proudu:");

        jLabel10.setText("Report parametrů proudu/aparátu:");

        jTextAreaReport.setColumns(20);
        jTextAreaReport.setFont(new Font("monospaced", Font.BOLD,11));
        jTextAreaReport.setRows(5);
        jScrollPane2.setViewportView(jTextAreaReport);

        jLabel11.setText("Počet elementů:");

        jTextFieldPocElem.setEditable(false);
        jTextFieldPocElem.setBackground(new java.awt.Color(255, 255, 255));
        jTextFieldPocElem.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N

        jLabelSpocten.setText("Spočten:");

        jTextFieldSpocten.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jTextFieldSpocten.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextFieldSpocten.setText("NE");

        jLabel12.setText("Z aparátu:");

        jTextFieldZApar.setEditable(false);
        jTextFieldZApar.setBackground(new java.awt.Color(255, 255, 255));
        jTextFieldZApar.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N

        jLabel13.setText("Do aparátu:");

        jTextFieldDoApar.setEditable(false);
        jTextFieldDoApar.setBackground(new java.awt.Color(255, 255, 255));
        jTextFieldDoApar.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                .addGroup(layout.createSequentialGroup()
                                    .addGap(3, 3, 3)
                                    .addComponent(jLabel1)
                                    .addGap(18, 18, 18)
                                    .addComponent(jTextFieldcProud, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addGap(31, 31, 31)
                                    .addComponent(jLabel2)
                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                    .addComponent(jTextFieldNazevProudu))
                                .addGroup(layout.createSequentialGroup()
                                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                        .addGroup(layout.createSequentialGroup()
                                            .addComponent(jLabel6)
                                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                            .addComponent(jTextFieldTlakZtr, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                        .addGroup(layout.createSequentialGroup()
                                            .addComponent(jLabel3)
                                            .addGap(18, 18, 18)
                                            .addComponent(jTextFieldHmPrutok, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                    .addGap(78, 78, 78)
                                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                        .addGroup(layout.createSequentialGroup()
                                            .addComponent(jLabel4)
                                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                            .addComponent(jTextFieldpVstup, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                        .addGroup(layout.createSequentialGroup()
                                            .addComponent(jLabel7)
                                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                            .addComponent(jTextFieldtVstup, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel12)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(jTextFieldZApar, javax.swing.GroupLayout.DEFAULT_SIZE, 227, Short.MAX_VALUE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(jLabel13)))
                        .addGap(10, 10, 10)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jTextFieldDoApar)
                                .addContainerGap())
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                        .addComponent(jLabel5)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jTextFieldpVystup, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                        .addComponent(jLabel8)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jTextFieldtVystup, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                        .addComponent(jLabel11)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jTextFieldPocElem, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                .addGap(64, 64, 64))))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                .addComponent(jLabel10)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 124, Short.MAX_VALUE))
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                .addComponent(jLabel9)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(jLabelSpocten)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jTextFieldSpocten, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addGap(212, 212, 212))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jTextFieldcProud, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2)
                    .addComponent(jTextFieldNazevProudu, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel11)
                    .addComponent(jTextFieldPocElem, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabel13)
                        .addComponent(jTextFieldDoApar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(jTextFieldZApar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jLabel12))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(jTextFieldHmPrutok, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel4)
                    .addComponent(jTextFieldpVstup, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel5)
                    .addComponent(jTextFieldpVystup, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(jTextFieldTlakZtr, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel7)
                    .addComponent(jTextFieldtVstup, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel8)
                    .addComponent(jTextFieldtVystup, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel9)
                    .addComponent(jLabelSpocten)
                    .addComponent(jTextFieldSpocten, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(2, 2, 2)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 165, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jLabel10)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 199, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(21, 21, 21))
        );
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JLabel jLabelSpocten;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTextArea jTextAreaReport;
    private javax.swing.JTextArea jTextAreaSlozeni;
    private javax.swing.JTextField jTextFieldDoApar;
    private javax.swing.JTextField jTextFieldHmPrutok;
    private javax.swing.JTextField jTextFieldNazevProudu;
    private javax.swing.JTextField jTextFieldPocElem;
    private javax.swing.JTextField jTextFieldSpocten;
    private javax.swing.JTextField jTextFieldTlakZtr;
    private javax.swing.JTextField jTextFieldZApar;
    private javax.swing.JTextField jTextFieldcProud;
    private javax.swing.JTextField jTextFieldpVstup;
    private javax.swing.JTextField jTextFieldpVystup;
    private javax.swing.JTextField jTextFieldtVstup;
    private javax.swing.JTextField jTextFieldtVystup;
    // End of variables declaration//GEN-END:variables
}
