/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package cheminzlib;

import fydat.FydatGUI;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileNameExtensionFilter;



/**
 * Třída definuje technologické schema se stromovou linií aparátů,<br>
 * metodou <i>resitSchema</i> postupně prochází aparáty zahrnuté ve schematu<br>
 * a ty vyčíslitelné spočítá.
 * @author V.Hlubuček
 */
public class Schema {

    protected String nazev = "Schema";
    protected String VERZE = "V1.1";        // verze třídy
    protected String report = "Schema report";  // textový report schematu
    protected boolean nabizetVysledkyProudu = true; // na závěr nabídne zobrazení proudů
    protected boolean bezReportu = false;   // po výpočtu nezobrazovat reort výsledků
/**
 * kolekce aparátů ve schematu
 */    
    protected List<Aparat> aparaty;         // kolekce aparátů ve schematu

/**
 * Bezparametrový konstruktor
 */    
    public Schema() {
        
    }
/**
 * Konstruktor Schematu
 * @param nazev 
 */    
    public Schema(String nazev) {
        this.nazev = nazev;
    }
/**
 * Přidá do schematu aparát
 * @param ap 
 */    
    public void pridejAparat(Aparat ap) {
        boolean uzJe = false;
        if(aparaty == null) aparaty = new ArrayList();
        for(Aparat apr : aparaty) {
          if(ap == apr) uzJe = true;
        }
        if(!uzJe) {     // přidá jen neexistující aparáty
            aparaty.add(ap);
        } else {
              JOptionPane.showMessageDialog(null, "Schema - aparat " + ap.nazevAparatu + " už ve schematu je!",
                      "Schema", JOptionPane.INFORMATION_MESSAGE);
        }             
    }
/**
 * Odebere ze schematu aparát
 * @param ap 
 */    
    public void odeberAparat(Aparat ap) {
        boolean jeTam = false;
        for(Aparat apr : aparaty) {
          if(ap == apr) jeTam = true;
        }
        if(jeTam) {     // odebere jen existující aparát
            aparaty.remove(ap);
        } else {
              JOptionPane.showMessageDialog(null, "Schema - aparat " + ap.nazevAparatu + " není ve schematu!",
                      "Schema", JOptionPane.INFORMATION_MESSAGE);
        }            
    }
/**
 * Metoda počítá všechny řešitelné aparáty ve schematu<br>
 * prochází všechny aparáty schematu a ty, které je možno spočítat, spočítá.
 */    
    public void resitSchema() {
        int i = 0, ii, cislo;
        boolean lzeSpocist;
        Proud prLast =  null;
        do {
            lzeSpocist = false;
            for(Aparat ap : aparaty) {
//               System.out.println( ap.nazevAparatu+"  spočten: " + ap.spocten);
               if(ap.lzeSpocitatAparat() && !ap.spocten) {
                   cislo = ap.cApar;
                   ii = 0;  // kolikátý vstupní proud aparátu
                   for(Aparat a : aparaty) {
                      for(i = 0; i < a.pocetOutProudu;i++) { 
                      if(a.pocetOutProudu > a.getNavaznost().length)  {
                          JOptionPane.showMessageDialog(null,
                        "Zadání návaznosti č.ap. " + a.cApar + "  " + a.nazevAparatu + "\nPočet prvků na řádku matice menší, než počet výst.proudů. \nKončím!",
                         "SCHEMA", JOptionPane.WARNING_MESSAGE);
                        return;
                      }  
                      if(cislo == a.getNavaznost(i) && !(ap instanceof Okoli)) {         // zjištěn navazující aparát      
                          Proud pr = a.proudyOut.get(i);    // získán jeho navazující proud
                          pr.doUzlu = ap;
                          pr.zUzlu = a;
                          if(pr.tVystup != 0)pr.tVstup = pr.tVystup;    // přenesení hodnot
                          if(pr.pVystup != 0)pr.pVstup = pr.pVystup;
                          if(ap.proudyIn.isEmpty() || ap.proudyIn.size() <= ii ) {
                              ap.proudyIn.add(pr.kopirujProud(pr));  // dosud žádný vstupní proud
                          } else {
                              ap.proudyIn.set(ii, pr.kopirujProud(pr));  // nahradit existující proud
                          }
                          ii++;
                          break;    // ?
                      }
                    }
                   }   
                   ap.spoctiAparat();
                   prLast = ap.proudyOut.get(0);
                   if(lzeSpocist) {
                       report += "  ------------------------------------------------------\n";
                       report += ap.report;
                   }     // výsledek aparátu do reportu schematu
                   lzeSpocist = true;   // aspoň jeden aparát byl spočten v cyklu
               }                      
            }          
        } while(lzeSpocist);
        // zahrnout výsledkové proudy do okolí
        for(Aparat ap : aparaty) {
            if(!(ap instanceof Okoli)) break;
                   cislo = ap.cApar;
                   ii = 0;  // kolikátý vstupní proud aparátu
                   for(Aparat a : aparaty) {
                      for(i = 0; i < a.pocetOutProudu;i++)
                      if(cislo == a.navaznost[i] && !(a instanceof Okoli)) {         // zjištěno okolí                    
                          Proud pr = a.proudyOut.get(i);    // získán jeho navazující proud
                          pr.doUzlu = ap;
                          pr.zUzlu = a;
                          if(ap.proudyIn.isEmpty() || ap.proudyIn.size() <= ii ) {
                              ap.proudyIn.add(pr);  // dosud žádný vstupní proud
                          } else {
                              ap.proudyIn.set(ii, pr);  // nahradit existující proud
                          }
                          ii++;
                      }
                   }             
        }
        report = zapisSchema() + report;
//        System.out.println( report);
        // alternativně "poslední" proud
        int last = aparaty.size();
        prLast = aparaty.get(last-1).proudyOut.get(1);  // jen  specificky
        prLast.setVysledek(report);
//        new JDialogProud(null, nazev + "  výstupní proud (Schema Verze " 
//                        + VERZE + ")\n", prLast);     // výsledek posledního proudu 
        if(!bezReportu) new JDialogReport(null, nazev + " výsledky řešení schematu:",report);
        if(nabizetVysledkyProudu) zobrazujProudyAparatu();
    }
/**
 * Umožňuje řešit schema s volbou zobrazování
 * @param zobraz true-ano; false-ne
 */    
    public void resitSchema(boolean zobraz) {
        boolean bylo = bezReportu;
        boolean bylo2 = nabizetVysledkyProudu;
        if(zobraz) {
            bezReportu = false;
            nabizetVysledkyProudu = true;
        }else {
            bezReportu = true;
            nabizetVysledkyProudu = false;            
        }
        resitSchema();
        bezReportu = bylo;
        nabizetVysledkyProudu = bylo2;
    }
/**
 * Funkce řeší nabídku zobrazení výsledků proudů aparátů
 */    
    protected void zobrazujProudyAparatu() {
        // zobrazování výsledků jednotivých aparátů
        int nProud, ii = 0, j = 0;
        int[] iAp = new int[50];    // zapamatovává index aparátu
        int[] iPr = new int[50];    // zapamatovává inex proudu
        Object[] varianty = new Object[50];
        for(Aparat ap : aparaty) {
            j = 0;
            for(Proud pr : ap.proudyOut) {
               varianty[ii] = pr.nazProudu;
               iAp[ii] = ap.cApar;
               iPr[ii] = j;
               j++;
               ii++;
            }
        }
        nProud = ii;
        String s;
        do {
            s = (String)JOptionPane.showInputDialog(
                        null,
                        "Vyberte jaký výsledek zobrazit\n",
                        "SCHEMA - výsledky",
                        JOptionPane.QUESTION_MESSAGE ,
                        null,
                        varianty,
                        "reaktor");
            if (s == null || s.isEmpty())return;
            for(ii = 0; ii < nProud; ii++) {
                if(s.equals(varianty[ii])) new JDialogProud(null, aparaty.get(iAp[ii]).getNazevAparatu() + "  výstupní proud (CSTR Verze " 
                   + aparaty.get(iAp[ii]).getVERZE() + ")\n", aparaty.get(iAp[ii]).getProudyOut().get(iPr[ii]));
            }
        }while(!s.isEmpty());
                
    }
/**
 * Zapíše do reportu strukturu schematu
 */    
    protected String zapisSchema() {
        String report;
        report = "Schema: " + nazev +"\n";
        for(Aparat ap : aparaty) {
            report += "Aparát: " + ap.nazevAparatu + "  č. " + ap.cApar + "  ---------------------\n";
            for(Proud pr : ap.proudyIn) {
                pr.doUzlu = ap;
                report += " proudIn: " + pr.nazProudu + "  z ap.č. " + ((pr.zUzlu != null) ? pr.zUzlu.cApar : "") + " - " + ((pr.zUzlu != null) ? pr.zUzlu.nazevAparatu:"")  + "\n"
                        + "      do ap.č. " + ((pr.doUzlu != null) ? pr.doUzlu.cApar : "") +  " - " + ((pr.doUzlu != null) ? pr.doUzlu.nazevAparatu:"") + "\n"; 
            }
            for(Proud pr : ap.proudyOut) {
                pr.zUzlu = ap;
                report += " proudOut: " + pr.nazProudu + "  z ap.č. " + ((pr.zUzlu != null) ? pr.zUzlu.cApar : "") + " - " + ((pr.zUzlu != null) ? pr.zUzlu.nazevAparatu:"") + "\n"
                        + "      do ap.č. " + ((pr.doUzlu != null) ? pr.doUzlu.cApar : "") +  " - " + ((pr.doUzlu != null) ? pr.doUzlu.nazevAparatu:"") + "\n"; 
            }            
        }
        return report;
    }
/**
 * Zadání návaznosti aparátů pomocí matice návaznosti<br>
 * řádky aparáty, sloupce: do kterého aparátu směřuje proud<br>
 * definovat až po přiřazení aparátů do schematu!
 * @param mat - matice int[][]
 */    
    public void navaznostZMatice(int[][] mat) {
        for(int i = 0;i < mat.length;i++) {
//            for(int j = 0; j < mat[i].length; j++) {
                aparaty.get(i).setNavaznost(mat[i]);
//            }
        }
        int z=0;
    }
/**
 * Uložení textu do souboru, statická metoda
 * Volat jako: <b>Schema.doSouboru(text);</b><br>
 * nabídne volbu kodování (Win, Linux) a volbu umístění a názvu souboru
 */
    public static void doSouboru(String report) {
        int i;
        String curDir, filenam, vysledek, kodovani = "Cp1250";
        File soubor;
        JFileChooser fc;
        FileOutputStream fout = null;
        OutputStreamWriter osw;
        PrintWriter opw = null;
        vysledek = report;
        
        Object[] moznosti = {"Windows Cp1250", "UTF-8", "Linux ISO8859-2"};
        String s = (String)JOptionPane.showInputDialog(
                            null,
                            "Zvolte kódovní textu výsledků\n"
                            + "(Windows, UTF-8, Linux)",
                            "Uložení výsledků",
                            JOptionPane.QUESTION_MESSAGE,
                            null,
                            moznosti,
                            "Windows Cp1250");
        if ((s != null) && (s.length() > 0)) {
            if("UTF-8".equals(s)) kodovani = "UTF8"; 
            if("Linux ISO8859-2".equals(s)) kodovani = "ISO8859-2"; 
        } else {
            return;
        }
        if("Cp1250".equals(kodovani)) vysledek = zajistiCRLF(vysledek); // doplní CRLF
        curDir = System.getProperty("user.dir");    // běžný adresář aplikace 
        fc = new JFileChooser(curDir); 
        fc.setFileFilter(new FileNameExtensionFilter("Textový výsledek .txt, .res", "txt","TXT","res"));        
        fc.setDialogTitle("Uložení výsledků");
        fc.setFileSelectionMode(JFileChooser.FILES_ONLY);
        int res = fc.showSaveDialog(null);
        if (res == JFileChooser.APPROVE_OPTION) {
            soubor = fc.getSelectedFile();  
            filenam = soubor.getPath();     // textové plné jméno souboru
            i = filenam.lastIndexOf(".");
            if(i <= 0)filenam +=  ".txt";   // doplnění typu txt
            if(fout == null) {
                try {
                    fout = new FileOutputStream(filenam,true); // režim append souboru
                    osw = new OutputStreamWriter(fout, kodovani);
                    opw = new PrintWriter(osw);
                    opw.format("%s",vysledek);
                    JOptionPane.showMessageDialog(null, "Text uložen do souboru: "
                        + filenam + "\nKodování " + kodovani ,"Uložení výsledků", 
                        JOptionPane.INFORMATION_MESSAGE);
                } catch (FileNotFoundException ex) {
                    Logger.getLogger(FydatGUI.class.getName()).log(Level.SEVERE, null, ex);
                    ex.getLocalizedMessage();
                } catch (IOException ex) {
                    Logger.getLogger(FydatGUI.class.getName()).log(Level.SEVERE, null, ex);
                    ex.getLocalizedMessage();
                } finally {
                    try {
                        if(fout != null) { opw.close(); fout.close(); }
                    } catch (IOException ex) {
                        Logger.getLogger(FydatGUI.class.getName()).log(Level.SEVERE, null, ex);
                        ex.getLocalizedMessage();
                    }
                }         
            }                         
        }
        
    }

/**
 * Uložení textu do souboru zvoleného jména v adresáři aplikace, statická metoda<br>
 * Volat jako: <b>Schema.doSouboru(text, nazevSouboru, false);</b><br>
 * používá kodování (Win: "Cp1250")<br>
 * V textovém názvu souboru lze také uvést cestu do jiného adresáře ("d:\\vysl\\zkusebni.res")<br>
 * nebo místo \\ uveďte / ("d:/vysl/zkusebni.res")
 * @param report    zapisovaný text
 * @param filenam   jméno souboru
 * @param append    true-append; false-vždy přemazat soubor
 */
    public static void doSouboru(String report,String filenam, boolean append) {
        int i;
        String curDir,   kodovani = "Cp1250";
        File soubor;
        FileOutputStream fout = null;
        OutputStreamWriter osw;
        PrintWriter opw = null;      
        if("Cp1250".equals(kodovani)) report = zajistiCRLF(report); // doplní CRLF
        curDir = System.getProperty("user.dir");    // běžný adresář aplikace 
            soubor = new File(filenam);  
            filenam = soubor.getPath();     // textové plné jméno souboru
            i = filenam.lastIndexOf(".");
            if(i <= 0)filenam +=  ".txt";   // doplnění typu txt
            if(fout == null) {
                try {
                    fout = new FileOutputStream(filenam,append); // režim append souboru
                    osw = new OutputStreamWriter(fout, kodovani);
                    opw = new PrintWriter(osw);
                    opw.format("%s",report);
//                    JOptionPane.showMessageDialog(null, "Text uložen do souboru: "
//                        + filenam + "\nKodování " + kodovani ,"Uložení výsledků", 
//                        JOptionPane.INFORMATION_MESSAGE);
                } catch (FileNotFoundException ex) {
                    JOptionPane.showMessageDialog(null, "Systém nemůže nalézt uvedenou cestu:  "
                        + filenam ,"Uložení výsledků: doSouboru()", 
                        JOptionPane.ERROR_MESSAGE);                    
                } catch (IOException ex) {
                    Logger.getLogger(FydatGUI.class.getName()).log(Level.SEVERE, null, ex);
                    ex.getLocalizedMessage();
                } finally {
                    try {
                        if(fout != null) { opw.close(); fout.close(); }
                    } catch (IOException ex) {
                        Logger.getLogger(FydatGUI.class.getName()).log(Level.SEVERE, null, ex);
                        ex.getLocalizedMessage();
                    }
                }         
            }                         
//        }
        
    }
    
    /**
     * řeší otázku crlf pro zápis do souboru
     * @param tx zapisovaý text
     * @return 
     */
    protected static String zajistiCRLF(String tx) {
        int i, n;
        char c;
        String txnew = "";
        n = tx.length();
        for(i = 0; i < n; i++) {
            c = tx.charAt(i);
            if(c == '\n' && i > 0) {
                if(tx.charAt(i - 1) != '\r') txnew += '\r';
            }
            txnew += tx.substring(i, i + 1);            
        }
        return txnew;
    }    
    
// Gettery a settery  ----------------------------------------------------
    /**
     * Vrací výsledkový report schematu
     * @return 
     */
    public String getReport() {
        return report;
    }
    /**
     * Vrací seznam aparátů schematu
     * @return 
     */
    public List<Aparat> getAparaty() {
        return aparaty;
    }
    /**
     * Vrací název schematu
     * @return 
     */
    public String getNazev() {
        return nazev;
    }
    /**
     * Nastavuje název schematu
     * @param nazev 
     */
    public void setNazev(String nazev) {
        this.nazev = nazev;
    }
    /**
     * Vrací verzi schematu
     * @return 
     */
    public String getVERZE() {
        return VERZE;
    }
    /**
     * Vrací zda budou nabízeny výsledky jednotlivých prpudů
     * @return true-ano; false-ne
     */
    public boolean isNabizetVysledkyProudu() {
        return nabizetVysledkyProudu;
    }
    /**
     * Nastavuje, zda budou nabízeny výsledky jednotlivých prpudů
     * @param nabizetVysledkyProudu boolean
     */
    public void setNabizetVysledkyProudu(boolean nabizetVysledkyProudu) {
        this.nabizetVysledkyProudu = nabizetVysledkyProudu;
    }
    /**
     * Vrací nastavení bezReportu
     * @return 
     */
    public boolean isBezReportu() {
        return bezReportu;
    }
    /**
     * Nastavuje volbu bezReportu
     * @param bezReportu 
     */
    public void setBezReportu(boolean bezReportu) {
        this.bezReportu = bezReportu;
    }
    
}
