/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package fydat;

import fydatlib.Latka;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import javax.swing.JOptionPane;
import java.io.FileWriter;  
import java.io.IOException;  
import java.util.Enumeration;
import java.util.List;
import java.util.zip.ZipEntry;
import java.util.zip.ZipFile;
import java.util.zip.ZipInputStream;
import java.util.zip.ZipOutputStream;
import org.jdom2.Attribute;  
import org.jdom2.Document;  
import org.jdom2.Element;  
import org.jdom2.output.Format;  
import org.jdom2.output.XMLOutputter;
/**
 * Datový soubor fydat.drc jako xml soubor
 * Zipování a odzipování
 * @author V.Hlubucek
 */
public class FydatXML {

    static List<Latka> latkaList;   // načtený seznam všech látek 
    static final Element fydat = new Element("fydat");
    static final Document document = new Document(fydat);
    static  Element nazev,vzorec,synon, group, cas ;    
    static  Element bodvlast; // bodové vlastnosti
    static  Element molhmot, tkr, pkr, vkr, acent, gyr;        
    static  Element indLomu, tindLomu, dielektr, tdielektr;  
    static  Element dHtani, tdHtani, tTani, tnbv, rezerva1, rezerva2;   
    static  Element rozvoje; // teplotní rozvoje
    static  Element vlastnost; // teplotní vlastnost
    static  Element a0, a1, a2, a3, a4, a5, vztah,trida,iOd, iDo; 
    static final String[] vlastnosti = {"Visk(g)","Cp(g)","Vod(g)","Hust(l)","Visk(l)","Vod(l)","Cp(l)","dHvyp","Tenze","Povrch napětí","Rezerva"};

/**
 * Vytvoření xml souboru z fydat.drc, souboru s daty o látkách
 * @param jmenoSouboru 
 */    
    public static void vytvorXML(String jmenoSouboru) {
        int i = 0;
        latkaList = Latka.getLatkaList();   // načte data o látkách
        try {
            for(Latka xx: latkaList) {
                if(xx.getNazev().equals("")) continue;  // vynechat prázdné záznamy
                Element latka = new Element("latka");
                latka.setAttribute(new Attribute("id",String.format("%d",xx.getCislo())));
                nazev = new Element("nazev").setText(xx.getNazev());
                latka.addContent(nazev);
                vzorec = new Element("vzorec").setText(xx.getVzorec());
                latka.addContent(vzorec);
                synon = new Element("synon").setText(xx.getSynon());
                latka.addContent(synon);
                group = new Element("group").setText(String.format("%3.1f",(float)xx.getGroup()/10));
                latka.addContent(group);
                cas = new Element("cas").setText(String.format("%3d",xx.getCas()));
                latka.addContent(cas);
                bodvlast = new Element("bodvlast"); // subelement bodových vlastností
                latka.addContent(bodvlast);
                molhmot = new Element("molhmot").setText(String.format("%6.4f",xx.getMolHmot()));
                bodvlast.addContent(molhmot);
                tkr = new Element("tkr").setText(String.format("%6.1f",xx.gettKr()));
                bodvlast.addContent(tkr);
                pkr = new Element("pkr").setText(String.format("%8.6g",xx.getpKr()));
                bodvlast.addContent(pkr);
                vkr = new Element("vkr").setText(String.format("%8.6g",xx.getvKr()));
                bodvlast.addContent(vkr);
                acent = new Element("acent").setText(String.format("%8.6g",xx.getAcent()));
                bodvlast.addContent(acent);
                gyr = new Element("gyr").setText(String.format("%8.6g",xx.getGyr()));
                bodvlast.addContent(gyr);
                indLomu = new Element("indLomu").setText(String.format("%8.6g",xx.getIndLomu()));
                bodvlast.addContent(indLomu);
                tindLomu = new Element("tindLomu").setText(String.format("%6.1f",xx.gettIndLomu()));
                bodvlast.addContent(tindLomu);                indLomu = new Element("indLomu").setText(String.format("%8.6g",xx.getIndLomu()));
                dielektr = new Element("dielektr").setText(String.format("%8.6g",xx.getDielektr()));
                bodvlast.addContent(dielektr);
                tdielektr = new Element("tdielektr").setText(String.format("%6.1f",xx.gettDielektr()));
                bodvlast.addContent(tdielektr);                
                dHtani = new Element("dHtani").setText(String.format("%8.6g",xx.getdHtani()));
                bodvlast.addContent(dHtani);
//                tdHtani = new Element("tdHtani").setText(String.format("%6.1f",xx.getdHtani()));  // není použito
//                bodvlast.addContent(tdHtani);                
                tTani = new Element("tTani").setText(String.format("%6.1f",xx.gettTani()));
                bodvlast.addContent(tTani);                                
                tnbv = new Element("tnbv").setText(String.format("%6.1f",xx.gettNbv()));
                bodvlast.addContent(tnbv);
                rezerva1 = new Element("rezerva1").setText("");
                bodvlast.addContent(rezerva1);
                rezerva2 = new Element("rezerva2").setText("");
                bodvlast.addContent(rezerva2);
                rozvoje = new Element("rozvoje");   // subelement teplotních rozvojů
                latka.addContent(rozvoje);
                for(int j = 0; j < 11; j++) {
                    double[] a = xx.vlast[j].getA();    // pole konstant
                    vlastnost = new Element("vlastnost");
                    vlastnost.setAttribute(new Attribute("typ",vlastnosti[j]));
                    rozvoje.addContent(vlastnost);
                    a0 = new Element("a0").setText(String.format("%8.6g",a[0]));
                    vlastnost.addContent(a0);
                    a1 = new Element("a1").setText(String.format("%8.6g",a[1]));
                    vlastnost.addContent(a1);
                    a2 = new Element("a2").setText(String.format("%8.6g",a[2]));
                    vlastnost.addContent(a2);
                    a3 = new Element("a3").setText(String.format("%8.6g",a[3]));
                    vlastnost.addContent(a3); 
                    a4 = new Element("a4").setText(String.format("%8.6g",a[4]));
                    vlastnost.addContent(a4);
                    a5 = new Element("a5").setText(String.format("%8.6g",a[5]));
                    vlastnost.addContent(a5);
                    // parametry rozvoje
                    vztah = new Element("vztah").setText(String.format("%d",xx.vlast[j].getVztah()));
                    vlastnost.addContent(vztah);
                    trida = new Element("trida").setText(String.format("%d",xx.vlast[j].getTrida()));
                    vlastnost.addContent(trida); 
                    iOd = new Element("iOd").setText(String.format("%d",xx.vlast[j].getiOd()));
                    vlastnost.addContent(iOd);
                    iDo = new Element("iDo").setText(String.format("%d",xx.vlast[j].getiDo()));
                    vlastnost.addContent(iDo);                    
                }
                document.getRootElement().addContent(latka);
                i++;
//                if(i>60)break;       // ladicí omezení
            }
            // zapsat soubor xml
            System.out.println("Celkem vloženo záznamů: " + i);
            XMLOutputter xmlOutput = new XMLOutputter();
//            xmlOutput.output(document,System.out);    // na konzoli (neformátovaně)
            xmlOutput.setFormat(Format.getPrettyFormat());  // zajistí odsazení 
            xmlOutput.output(document, new FileWriter(jmenoSouboru));                 
        } catch (IOException io) {
            JOptionPane.showMessageDialog(null,
                "XML " + jmenoSouboru + " se nepodařilo vytvořit!",
                 "XML", JOptionPane.ERROR_MESSAGE);
        }
    }
/**
 * Extrakce zip souboru bez využití třídy ZipFile
 * @param jmenoSouboru zip soubor
 */      
    public static void unZip(String jmenoSouboru) {
      final int BUFFER = 2048;
      try {
         BufferedOutputStream dest = null;
         FileInputStream fis = new FileInputStream(jmenoSouboru);
         ZipInputStream zis = new ZipInputStream(new BufferedInputStream(fis));
         ZipEntry entry;
         while((entry = zis.getNextEntry()) != null) {
            System.out.println("Extrahuji: " +entry);
            int count;
            byte data[] = new byte[BUFFER];
            // write the files to the disk
            FileOutputStream fos = new FileOutputStream(entry.getName());
            dest = new BufferedOutputStream(fos, BUFFER);
            while ((count = zis.read(data, 0, BUFFER)) 
              != -1) {
               dest.write(data, 0, count);
            }
            dest.flush();
            dest.close();
         }
         zis.close();
      } catch(IOException e) {
//         e.printStackTrace();
            JOptionPane.showMessageDialog(null,
                "ZIP " + jmenoSouboru + " se nepodařilo dekodovat!",
                 "UnZip", JOptionPane.ERROR_MESSAGE);         
      }        
    }
/**
 * Extrakce zip souboru s využitím třídy ZipFile
 * @param jmenoSouboru zip soubor
 */    
    public static void unZipFile(String jmenoSouboru) {
      final int BUFFER = 2048;    
      try {
         BufferedOutputStream dest = null;
         BufferedInputStream is = null;
         ZipEntry entry;
         ZipFile zipfile = new ZipFile(jmenoSouboru);
         Enumeration e = zipfile.entries();
         while(e.hasMoreElements()) {
            entry = (ZipEntry) e.nextElement();
            System.out.println("Extrahuji: " +entry);
            is = new BufferedInputStream(zipfile.getInputStream(entry));
            int count;
            byte data[] = new byte[BUFFER];
            FileOutputStream fos = new FileOutputStream(entry.getName());
            dest = new BufferedOutputStream(fos, BUFFER);
            while ((count = is.read(data, 0, BUFFER)) 
              != -1) {
               dest.write(data, 0, count);
            }
            dest.flush();
            dest.close();
            is.close();
         }
      } catch(Exception e) {
            JOptionPane.showMessageDialog(null,
                "ZIP " + jmenoSouboru + " se nepodařilo dekodovat!",
                 "UnZipFile", JOptionPane.ERROR_MESSAGE);
      }
    }
    
    public static void zipFile(String jmenoSouboru) {
      final int BUFFER = 2048;
      try {
         // získat jméno souboru bez přípony
         String jmeno = jmenoSouboru.substring(0, jmenoSouboru.indexOf("."));
         jmeno = jmeno + ".zip";          
         BufferedInputStream origin = null;
         FileOutputStream dest = new FileOutputStream(jmeno);
         ZipOutputStream out = new ZipOutputStream(new 
           BufferedOutputStream(dest));
         //out.setMethod(ZipOutputStream.DEFLATED);
         byte data[] = new byte[BUFFER];
//         // get a list of files from current directory
//         File f = new File(".");
//         String files[] = f.list();
//         for (int i=0; i<files.length; i++) {
            System.out.println("Do zip komprese: "+jmenoSouboru);
//            FileInputStream fi = new FileInputStream(files[i]);
            FileInputStream fi = new FileInputStream(jmenoSouboru);
            origin = new BufferedInputStream(fi, BUFFER);
//            ZipEntry entry = new ZipEntry(files[i]);
            ZipEntry entry = new ZipEntry(jmenoSouboru);
            out.putNextEntry(entry);
            int count;
            while((count = origin.read(data, 0, 
              BUFFER)) != -1) {
               out.write(data, 0, count);
            }
            origin.close();
//         }    // konec cyklu
         out.close();
      } catch(Exception e) {
            JOptionPane.showMessageDialog(null,
                "ZIP " + jmenoSouboru + " se nepodařilo zakodovat!",
                 "ZipFile", JOptionPane.ERROR_MESSAGE);
      }      
    }
    public static void main(String[] args) throws IOException {
        String soubor = "fydat.xml";
        FydatXML.vytvorXML(soubor);
        FydatXML.zipFile(soubor);
    //    FydatXML.unZipFile("fydatC.zip");    
    //        JOptionPane.showMessageDialog(null,
    //            "XML " + jmenoSouboru + "  vytvořen. Končím!",
    //             "XML", JOptionPane.INFORMATION_MESSAGE);
    }    
}
