/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package fydat;

import java.awt.Color;
import java.awt.Component;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.ArrayList;
import java.util.List;
import javax.swing.AbstractCellEditor;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.TableCellEditor;
import javax.swing.table.TableCellRenderer;

/**
 * Uživatelský model pro JTable
 * @author V. Hlubuček
 */
public class TableModelSmes extends AbstractTableModel {

    public static final int COLUMN_CISLO = 0;
    public static final int COLUMN_NAZEV = 1;
    public static final int COLUMN_SLOZENI = 2;
    final String[] COLUMN_NAME = new String[]{"<html><b>Číslo<br>látky</b></html>",
        "<html><b>Název</b></html>",
         "<html><b>Složení<br>směsi</b></html>"};
    final Class[] COLUMN_CLASS = new Class[]{Integer.class, String.class, String.class};
    List<Slozka> slozkaList = new ArrayList();
/**
 * Odstraní složku s indexm i ze seznamu
 * @param index
 * @return 
 */
    public Slozka removeSlozka(int index) {
        Slozka ret = slozkaList.remove(index);
        fireTableDataChanged();
        return ret;
    }
/**
 * Přidá složku do seznamu
 * @param e
 * @return 
 */
    public boolean addSlozka(Slozka e) {
        boolean ret = slozkaList.add(e);
        fireTableDataChanged();
        return ret;
    }
/**
 * Odstraní všechny složky ze seznamu
 * a vyvolá událost TableDataChanged
 */
    public void removeAllSlozka() {
        slozkaList.clear();
        fireTableDataChanged();
    }
/**
 * Vrací počet řádek tabulky
 * @return počet
 */    
    public int getRowCount() {
        return slozkaList.size();
    }
/**
 * Vrací počet sloupců tabulky
 * @return 
 */
    public int getColumnCount() {
        return COLUMN_NAME.length;
    }
/**
 * Vrací hodnotu z tabulky z buňky (i,j)
 * @param rowIndex
 * @param columnIndex
 * @return Object
 */
    public Object getValueAt(int rowIndex, int columnIndex) {
        Slozka slozka = slozkaList.get(rowIndex);
        switch (columnIndex) {
            case COLUMN_CISLO:
                return slozka.getCislo();
            case COLUMN_NAZEV:
                return slozka.getNazev();
            case COLUMN_SLOZENI:
                return slozka.getSlozeni();
        }
        return null;
    }

    @Override
    public Class<?> getColumnClass(int columnIndex) {
        return COLUMN_CLASS[columnIndex];
    }

    @Override
    public String getColumnName(int column) {
        return COLUMN_NAME[column];
    }

    @Override
    public boolean isCellEditable(int rowIndex, int columnIndex) {
        return columnIndex == COLUMN_SLOZENI;
    }

    @Override
/**
 * Nastavuje hodnotu v tabulce
 * @ param Object hodnota
 * @ param int řádek
 * @ param int sloupec
 */
    public void setValueAt(Object value, int rowIndex, int columnIndex) {
        Slozka slozka = slozkaList.get(rowIndex);
        switch (columnIndex) {
            case COLUMN_CISLO:
                return;     // změnu čísla nepřipustit
            case COLUMN_NAZEV:
                slozka.setNazev((String) value);
                break;
            case COLUMN_SLOZENI:
                slozka.setSlozeni((String) value);
                break;
        }
    }


// ---------------------------------------------------------------













}

