/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package fydat;

import cheminzlib.CSTRReaktor;
import cheminzlib.Proud;
import cheminzlib.Reakce;
import cheminzlib.Trubka;
import fydatlib.Smes;
import java.io.IOException;
import javax.swing.JOptionPane;
import org.jdom2.JDOMException;

/**
 * Zkušební program pro ladění modulu CSTR
 * @author V. Hlubuček
 */
public class ZkCSTR {
    
    public static void main(String[] args) throws IOException, JDOMException {
        int n=3;
        boolean interaktivne;
        interaktivne = false;        // zadání myProud interaktivně
        double t, tC, p, pom;       // teplota (K, °C), tlak (Pa)
        double[] x ={1,3,3};        // složení směsi
        CSTRReaktor reaktor = null; // -----------------------------------
        Proud myProud = null, myProud2 = null;
        Smes mySmes = new Smes("Moje",1,140,141);
        Smes mySmes2 = new Smes("Druhá",141,140,143);
        tC = 60;           // kapalina 70;   parní fáze 120
        t = tC + 273.15;    // absolutní teplota (K)
        p = 200000;
        mySmes.zadatSloz(true, x);    // // složení hmotově  (true), molárně (false) 
        double[]x1 = {2,3,1};
        mySmes2.zadatSloz(false,x1 );  // složení molárně   
        // --- rozhodování o vstupu -----------------------
        Object[] varianty = {"výpočet z uložených dat", "interaktivně zadat nová data"};
        String s = (String)JOptionPane.showInputDialog(
                    null,
                    "Vyberte způsob zadání dat\n",
                    "Zadání dat",
                    JOptionPane.QUESTION_MESSAGE ,
                    null,
                    varianty,
                    "výpočet z uložených dat");
        if ((s != null) && (s.equals("interaktivně zadat nová data"))) interaktivne = true;
        if(interaktivne) {
            // interaktivní zadání proudu:      ------------------------------------
            // proudy musí směřovat do stejného aparátu (číslo) aby byly vstupní
            myProud = new Proud();
//            JDialogProudInp jdpi = new JDialogProudInp(null,myProud, true); // interaktivní vstup dat proudu
//            JDialogProudInp jdpi = new JDialogProudInp(null, true); // interaktivní vstup dat proudu
//            jdpi.setVisible(true); 
//            myProud = jdpi.getProud();
            myProud.zadejParametryInteraktivne();  
            //  --------------------------------------------             
        } else {    // softwarové zadání
    //        Proud myProud = new Proud(33,"Zkušební proud");
            myProud = new Proud(33,null,reaktor,"Zkušební proud");

    //        myProud.setHmotPrutok(0.05);    // parní fáze
            myProud.setHmotPrutok(1.0);    // kapalina
            myProud.setSmes(mySmes);
            myProud.setpVstup(p);   // vstupní tlak (Pa)
            myProud.setpVystup(0.9*p);        
            myProud.settVstup(tC);  // vstupní teplota (°C)            
        }
    
        Trubka trub = new Trubka(myProud,"Trubka 1");
        Trubka trub21 = new Trubka(myProud,"Trubka 21"); 
        myProud2 = new Proud(46,null,reaktor,"Druhý proud");        
        myProud2.zadejParametryProudu(46, "Druhý proud", null,reaktor, 0.5, tC - 30, p);
        myProud2.setSmes(mySmes2);
        myProud2.setpVystup(0.9*p);
        myProud.setTisk(true);
        myProud2.setTisk(true);
        trub.setPrumerTrubky(0.05);
        trub.setDelkaTrubky(10);
        trub.setDrsnost(0.0002);
        trub.setVyskovyRozdil(0.0);
        trub.setAdiab(true);     
        trub21.setVyskovyRozdil(0.0);
        trub21.setPrumerTrubky(0.04);
        trub21.setDelkaTrubky(10);
        trub21.setDrsnost(0.0002);
        trub21.setVyskovyRozdil(0.0);
        trub21.setAdiab(true);             
        myProud.pridatElement(trub);
        myProud2.pridatElement(trub21);
//        Proud smesnyPr;
//        SmesovacIdeal smesovacId = new SmesovacIdeal(777,"Ideální směšovač");
//        smesovacId.pridejProud(myProud);
//        smesovacId.pridejProud(myProud2);
//        smesnyPr = smesovacId.smisitProudy();
        // (pozn.)hypotetická nesmyslná reakce z hlediska složek        
        int[] iSlozky = {206,146,-140,-141};
        int[] iStech = {1,2,-1,-1}; // stechiometrické koeficienty reagujících složek
        int[] iKinSloz = {140,141}; // čísla látek z kinetické rovnice
        double[] radSloz = {1.2,0.8};   // řád k složkám kinetické rovnice
        //   ... k0,T0(K),Eakt(J/mol),dH(J/mol),Krovn,TKrovn ...
        Object[] varReak = {"reakce z uložených dat", "reakce zadat interaktivně"};
        s = (String)JOptionPane.showInputDialog(
                    null,
                    "Vyberte způsob zadání dat\n",
                    "Zadání dat reakce",
                    JOptionPane.QUESTION_MESSAGE ,
                    null,
                    varReak,
                    "reakce z uložených dat");
        if ((s != null) && (s.equals("reakce zadat interaktivně"))) interaktivne = true; else interaktivne = false;
        Reakce reak = null;
        if(interaktivne) {        
            reak = new Reakce();
            reak.zadejParametryInteraktivne();  // interaktivní zadání -----------------------------
        } else {
            reak = new Reakce(iSlozky, iStech, 2.25e-6, 310, 22000.14, -31210.3,1e4, 60. + 273.15,1, iKinSloz,radSloz);
        }
        reaktor = new CSTRReaktor(2,"Míchaný CSTR");
        reaktor.setObjemReaktoru(1.05);
        //   ... plocha(m2),Kprostup(W/m2/K),tchlad(°C)
        reaktor.paramPrestupuTepla(4, 800, 30);
        reaktor.zadejParametryInteraktivne();   // možnost zadat parametry interaktivně
        reaktor.pridejProud(myProud);
        reaktor.pridejProud(myProud2);
//        reaktor.setReakPr(smesnyPr);
//        reaktor.smisitProudy();
        reaktor.pridejReakci(reak); // přiřadí reakci k aparátu
        reaktor.setRezim(2);
        reaktor.setZobrazujVysledky(true);  // zobrazí výsledky po výpočtu
        reaktor.spoctiAparat();
//        reaktor.reakce(); // alternativní spuštění výpočtu
    }        
    
}
