/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package fydat;

import cheminzlib.CSTRReaktor;
import cheminzlib.JDialogProud;
import cheminzlib.Okoli;
import cheminzlib.Proud;
import cheminzlib.Reakce;
import cheminzlib.Schema;
import cheminzlib.SmithBrinkley;
import cheminzlib.TepelnyVymenik;
import fydatlib.Smes;
import java.io.IOException;
import javax.swing.JOptionPane;
import org.jdom2.JDOMException;

/**
 * Zkušební program pro ladění modulu Schema
 * @author V. Hlubuček
 */
public class ZkSchema {

    public static void main(String[] args) throws IOException, JDOMException {
        int n=4;
        double t, tC, tchl, p;        // teplota (K, °C), tlak (Pa)
        double[] x ={1,3,3,3};        // složení směsi  
        double[] xchl = {1};
        tC = 50;  t = tC + 273.15;  tchl = 20;
        p = 130000;
        // Deklarace aparátů
        Schema sch = new Schema(); 
        Okoli okol = null;
        CSTRReaktor reaktor = null;
        Reakce reak = null;
        SmithBrinkley sb = null;
        TepelnyVymenik vym = null;
        TepelnyVymenik vym2 = null;
        // Deklarace proudů a směsí
        Proud myProud = null, chladPr = null, pr = null, pr1 = null;
        Smes mySmes = new Smes("Reak_směs",1,140,141,143);
        Smes chladSmes = new Smes("Chlad_směs: voda",1);
        chladPr = new Proud(5,null,vym,"chladicí proud");
        chladSmes.zadatSloz(true,xchl);        
        chladPr.setSmes(chladSmes);
        chladPr.settVstup(tchl);
        chladPr.setpVstup(300000);
        chladPr.vystupJakoVstup();
        chladPr.setHmotPrutok(2.1);
        chladPr = new Proud(5,20.2,2.213);  // jednodušší zadání chladicího proudu (č.,teplota, průtok) jedním příkazem
        mySmes.zadatSloz(true, x);      // složení hmotově  (true), molárně (false)
        myProud = new Proud(1,null,reaktor,"Proud do reakce");
        myProud.setSmes(mySmes);        
        myProud.setHmotPrutok(1.05);
        myProud.settVstup(tC);
        myProud.setpVstup(p);
        // Vytváření schematu a návazností
        okol = new Okoli();
        okol.pridejProudOut(myProud);   //  reakčníproud vystupující z okolí do reaktoru
        okol.pridejProudOut(chladPr);   // chladicí proud vystupující z okolí do výměníku
        okol.pridejProudOut(chladPr.kopirujProud(chladPr));   // chladicí proud vystupující z okolí do výměníku2
        reaktor = new CSTRReaktor(2,"Míchaný CSTR");
        reaktor.setcApar(1);    // nastavení čísla aparátu
//        okol.setNavaznost(0, reaktor.getcApar());  // návaznost proudu z okolí do reaktoru      
        reaktor.setObjemReaktoru(1.05);
        //   ... plocha(m2),Kprostup(W/m2/K),tchlad(°C)
        reaktor.paramPrestupuTepla(4, 800, 30);
        // (pozn.)hypotetická nesmyslná reakce z hlediska složek        
        int[] iSlozky = {206,146,-140,-141};
        int[] iStech = {1,2,-1,-1}; // stechiometrické koeficienty reagujících složek
        int[] iKinSloz = {140,141}; // čísla látek z kinetické rovnice
        double[] radSloz = {1.2,0.8};   // řád k složkám kinetické rovnice
        //   ... k0,T0(K),Eakt(J/mol),dH(J/mol),Krovn,TKrovn ...        
        reak = new Reakce(iSlozky, iStech, 2.25e-6, 310, 22000.14, -31210.3,1e4, 60. + 273.15,1, iKinSloz,radSloz);
        reaktor.pridejReakci(reak); // přiřadí reakci k aparátu 
        // konec definice reaktoru  --------------
        sb = new SmithBrinkley(15, 6, 4.5, 0, 15);      // proud, pater, pod nástřikem, reflux, v/Fnástř, destilát %z nástřiku
        sb.setcApar(2);
//        reaktor.setNavaznost(0, sb.getcApar()); // nultý výstupní proud z reaktoru jde do kolony jako nástřik. Přímé nastavení
        vym = new TepelnyVymenik("Chl.zbytku C52",6.5, 250,1);  // název, A,k, indexPP)
        vym.setcApar(3);
//        sb.setNavaznost(1, vym.getcApar());    // první výstupní proud kolony (zbytek) jde do výměníku
//        okol.setNavaznost(1, vym.getcApar());   // chladicí proud z okolí do výměníku
        vym2 = new TepelnyVymenik("Chl.destil C15",5.2, 250,1);  // název, A,k, indexPP)
        vym2.setcApar(4); 
//        okol.setNavaznost(2, vym2.getcApar());   // chladicí proud z okolí do výměníku2
//        sb.setNavaznost(0, vym2.getcApar());    // nultý výstupní proud kolony (destilát) jde do výměníku2
        vym.setNavaznost(0, okol.getcApar());
        vym.setNavaznost(1, okol.getcApar());
        vym2.setNavaznost(0, okol.getcApar());
        vym2.setNavaznost(1, okol.getcApar());

        // přiřazení do schematu technologie
        sch.pridejAparat(okol);     // vstup z okolí
        sch.pridejAparat(reaktor);
        sch.pridejAparat(sb);
        sch.pridejAparat(vym);
        sch.pridejAparat(vym2);
        // alternativní zadání návaznosti maticí(řádky aparáty, sloupce: do kterého aparátu směřuje proud) :
        //  aparát 0 obvykle okolí; počet na řádku musí korespondovat s počtem výstupních prpudů!
        // Návaznost se musí zadávat až po přiřazení aparátů do schematu!
        int[][] maticeNavaznosti = {{1,3,4},{2},{3,4},{0,0},{0,0}};
        sch.navaznostZMatice(maticeNavaznosti);    // návaznost zadána maticí (snadnější) 
//        sch.setNabizetVysledkyProudu(false);    // zruší generalizovanou nabídku výsledků proudů 
        sch.resitSchema(true);  // začne řešit technologické schema
        // konec zkušebního programu Schema
//  ---------------------------------------------------------------------------
        // případné zobrazování výsledků jednotivých aparátů uživatelem (jen z didaktických důvodů)
        // pak je třeba před výpočtem zrušit generalizovanou nabídku: sch.setNabizetVysledkyProudu(false);
        // nechte raději tu generalizovanou
        String s;
        Object[] varianty = {"reaktor", "kolona-destilát", "kolona-zbytek","chladič-dest", "chladič-zbytku"};
        do {
            s = (String)JOptionPane.showInputDialog(
                        null,
                        "Vyberte jaký výsledek zobrazit\n",
                        "SCHEMA - výsledky",
                        JOptionPane.QUESTION_MESSAGE ,
                        null,
                        varianty,
                        "reaktor");
            if (s == null || s.isEmpty())return;
            if (s.equals("reaktor"))new JDialogProud(null, sch.getAparaty().get(1).getNazevAparatu() + "  výstupní proud (CSTR Verze " 
                   + sch.getAparaty().get(1).getVERZE() + ")\n", sch.getAparaty().get(1).getProudyOut().get(0)); // modálně vyskakovací okno s výsledky              
            if (s.equals("kolona-destilát"))new JDialogProud(null, sch.getAparaty().get(2).getNazevAparatu() + "  výstupní proud (CSTR Verze " 
                   + sch.getAparaty().get(2).getVERZE() + ")\n", sch.getAparaty().get(2).getProudyOut().get(0));               
            if (s.equals("kolona-zbytek"))new JDialogProud(null, sch.getAparaty().get(2).getNazevAparatu() + "  výstupní proud (CSTR Verze " 
                   + sch.getAparaty().get(2).getVERZE() + ")\n", sch.getAparaty().get(2).getProudyOut().get(1));               
            if (s.equals("chladič-dest"))new JDialogProud(null, sch.getAparaty().get(4).getNazevAparatu() + "  výstupní proud (CSTR Verze " 
                   + sch.getAparaty().get(4).getVERZE() + ")\n", sch.getAparaty().get(4).getProudyOut().get(1));               
            if (s.equals("chladič-zbytku"))new JDialogProud(null, sch.getAparaty().get(3).getNazevAparatu() + "  výstupní proud (CSTR Verze " 
                   + sch.getAparaty().get(3).getVERZE() + ")\n", sch.getAparaty().get(3).getProudyOut().get(1));   
        }while(!s.isEmpty());
        
    }
}
