/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package fydat;

import cheminzlib.JDialogProud;
import cheminzlib.Proud;
import cheminzlib.Reakce;
import cheminzlib.TrubReaktor;
import cheminzlib.Trubka;
import fydatlib.Smes;
import java.io.IOException;
import org.jdom2.JDOMException;
/**
 * Zkušební program pro ladění modulu TrubReaktor
 * @author V. Hlubuček
 */
public class ZkTrub {
    
    public static void main(String[] args) throws IOException, JDOMException {
        int n=3;
        double t, tC, p, pom;       // teplota (K, °C), tlak (Pa)
        double[] x ={1,3,3};    // složení směsi
        TrubReaktor reaktor = null;
        Smes mySmes = new Smes("Moje",1,140,141);
        Smes mySmes2 = new Smes("Druhá",141,140,143);
//        Proud myProud = new Proud(33,"Zkušební proud");
        Proud myProud = new Proud(33,null,reaktor,"Zkušební proud");
        Trubka trub = new Trubka(myProud,"Trubka 1");
        Proud myProud2 = new Proud(46,null,reaktor,"Druhý proud");
        Trubka trub21 = new Trubka(myProud,"Trubka 21");      
        tC = 60;           // kapalina 70;   parní fáze 120
        t = tC + 273.15;    // absolutní teplota (K)
        p = 200000;
        mySmes.zadatSloz(true, x);    // // složení hmotově  (true), molárně (false) 
        double[]x1 = {2,3,1};
        mySmes2.zadatSloz(false,x1 );  // složení molárně      
//        myProud.setHmotPrutok(0.05);    // parní fáze
        myProud.setHmotPrutok(1.0);    // kapalina
        myProud.setSmes(mySmes);
        myProud.setpVstup(p);   // vstupní tlak (Pa)
        myProud.setpVystup(0.9*p);        
        myProud.settVstup(tC);  // vstupní teplota (°C)
        myProud2.zadejParametryProudu(46, "Druhý proud", null, reaktor, 0.5, tC - 30, p);
        myProud2.setSmes(mySmes2);
        myProud2.setpVystup(0.9*p);
        myProud.setTisk(true);
        myProud2.setTisk(true);
        trub.setPrumerTrubky(0.05);
        trub.setDelkaTrubky(10);
        trub.setDrsnost(0.0002);
        trub.setVyskovyRozdil(0.0);
        trub.setAdiab(true);     
        trub21.setVyskovyRozdil(0.0);
        trub21.setPrumerTrubky(0.04);
        trub21.setDelkaTrubky(10);
        trub21.setDrsnost(0.0002);
        trub21.setVyskovyRozdil(0.0);
        trub21.setAdiab(true);             
        myProud.pridatElement(trub);
        myProud2.pridatElement(trub21);
        // (pozn.)hypotetická nesmyslná reakce z hlediska složek
        int[] iSlozky = {206,146,-140,-141};
        int[] iStech = {1,2,-1,-1}; // stechiometrické koeficienty reagujících složek
        int[] iKinSloz = {140,141}; // čísla látek z kinetické rovnice
        double[] radSloz = {1.2,0.8};   // řád k složkám kinetické rovnice
        //   ... k0,T0(K),Eakt(J/mol),dH(J/mol) ...(iSlozky, iStech, 2.25e-7, 310, 22000.14, -31210.3,iKinSloz,radSloz)
        Reakce reak = new Reakce(iSlozky, iStech, 1.53e-7, 310, 22000.14, -39100.3, 0, 0, 1, iKinSloz,radSloz);
        reaktor = new TrubReaktor(2,"Trubkový reaktor");
        reaktor.setPrumerTrubky(0.03);
        reaktor.setDelkaTrubky(4.0);
        reaktor.setPocetTrubek(660);
        //   ... plocha(m2),Kprostup(W/m2/K),tchlad(°C)(4, 250, 50)
        reaktor.paramPrestupuTepla(4,200, 60);
        reaktor.pridejProud(myProud);
        reaktor.pridejProud(myProud2);
        reaktor.pridejReakci(reak); // přiřadí reakci k aparátu
        reaktor.setRezim(2);
//        reaktor.zadejParametryInteraktivne();   // možnost zadat parametry interaktivně
        reaktor.setZobrazujVysledky(true);  // zobrazení výsledků po výpočtu
        reaktor.reakce();   // vlastní řešení aparátu
//        JDialogProud frmProud = new JDialogProud(null, "Trubkový reaktor - Reakční spojený proud  (Verze " 
//                + reaktor.getVERZE() + ")\n", reaktor.getReakPr());    // modálně vyskakovací 
//        reaktor.zobrazVystupniProud();      // opakované zobrazení výsledků
    }        
    
    
}
