/**
 * Package fydatlib - prvky pro práci s fyzikálními daty látek
 * and open the template in the editor.
 */
package fydatlib;

import fydat.CenterRenderer;
import fydat.CenterRendererSloz;
import fydat.Slozka;
import fydat.TableModelSmes;
import java.awt.Color;
import java.awt.Font;
import java.awt.event.KeyEvent;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.DefaultListModel;
import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableColumn;
import javax.swing.table.TableColumnModel;
import org.jdom2.JDOMException;

/**
 * Panel pro výběr složek směsi ze seznamu látek
 * a současně zadání složení směsi. Lze použít samostatně v uživatelském 
 * programu. Používá ho JDialogSlozKom.
 * @author V. Hlubuček
 */
public class JPanelSlozKom extends javax.swing.JPanel {

    private int jVyber;                     // počet vybraných složek
    private int[] jCisla = new int[50];     // čísla vybraných složek
    private boolean nastaveno = false;
    private Smes mySmes;                        // instance dané směsi látek   
    List<Latka> slozky = new ArrayList();   // seznam látek dané směsi    
    DefaultListModel listModel = new DefaultListModel();   
    List<SlozeniListener> listenerListS = new ArrayList();
    TableModelSmes smesModel = new TableModelSmes();    
    /**
     * Creates new form JPanelSlozKom
     */
    public JPanelSlozKom() {
        initComponents();
        myInit();
    }
    /**
     * Inicializace uživatelských prvků panelu (jTable a pod.)
     */
    public final void myInit() {
        try {
            // Naplnit seznam
            naplnSeznam();
        } catch (JDOMException ex) {
            Logger.getLogger(JPanelSlozKom.class.getName()).log(Level.SEVERE, null, ex);            
        } catch (IOException ex) {
            Logger.getLogger(JPanelSlozKom.class.getName()).log(Level.SEVERE, null, ex);
        }
        // Formátování tabulky
        jTableSmes.setModel(smesModel);
        JTableHeader header = jTableSmes.getTableHeader();
        header.setBackground(new Color(0xA0CCFF));
        jTableSmes.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
        int vColIndex = 0;
        TableColumn col = jTableSmes.getColumnModel().getColumn(vColIndex);
        int width = 50;
        col.setPreferredWidth(width);
        TableColumn col2 = jTableSmes.getColumnModel().getColumn(1);
        col2.setPreferredWidth(225);
        TableColumn col3 = jTableSmes.getColumnModel().getColumn(2);
        col3.setPreferredWidth(80);
        TableColumnModel tcm = jTableSmes.getColumnModel();
        TableColumn tc = tcm.getColumn(TableModelSmes.COLUMN_CISLO);
        tc.setCellRenderer(new CenterRenderer());
        TableColumnModel tcmSl = jTableSmes.getColumnModel();
        TableColumn tcSl = tcmSl.getColumn(TableModelSmes.COLUMN_SLOZENI);
        tcSl.setCellRenderer(new CenterRendererSloz());
        jTableSmes.getSelectionModel().addListSelectionListener(new ListSelectionListener() {

            public void valueChanged(ListSelectionEvent e) {
                int row = jTableSmes.getSelectedRow();
                if (row != -1) {
                    Object o = jTableSmes.getModel().getValueAt(row, 2);
                    Object o1 = jTableSmes.getModel().getValueAt(row, 0);
                    System.out.println("INDEX:" + e.getLastIndex() + "   c= " + o1 + "   x= " + o);
                    int cislo = Integer.parseInt("" + o1);
//                    zobrazLatku(cislo - 1);
                }
            }
        });
    }

    protected void naplnTabSloz() {
        int cLatky;
            //  Smazání obsahu předchozí tabulky
            smesModel.removeAllSlozka();
//            jTableSmes.repaint();
            
            for (int i = 0; i < mySmes.getnSloz(); i++) {
//                cLatky = mySmes.getLatka(i).getCislo(); // dává jen pořadové číslo !!!!
                cLatky = mySmes.getSlozka(i).getCislo();
                System.out.println("č. látky: "+cLatky);
                smesModel.addSlozka(new Slozka(cLatky,
                        mySmes.getSlozka(i).getNazev(), ""));
            }
            if (jTableSmes.getRowCount() > 0) {
                jTableSmes.getSelectionModel().setSelectionInterval(0, 0);
                jTableSmes.getColumnModel().getSelectionModel().setSelectionInterval(2, 2);
                jTableSmes.requestFocus();
            }          
    } 
  
    /**
     * Naplnění seznamu látek do listBoxu pro výběr látek
     * @throws IOException
     */
    final void naplnSeznam() throws IOException, JDOMException {
        String[] s;       // původně: musel být přesně 533 jinak chyby!
//        Font fontCur = new Font("Courier", Font.BOLD,  12);
        int nLat;
        s = Latka.seznamLatek(true);  // true - dle abecedy
        nLat = s.length;
        for (int i = 0; i < nLat; i++) {
            listModel.addElement(s[i]);  // vkládání přes model 
        }
    }    
    
    /**
     * Předá posluchače složení do seznamu 
     * @param SlozeniListener l  
     */
    public void addSlozeniListener(SlozeniListener l) {
        listenerListS.add(l);
    }
    /**
     * Odstraní posluchače složení ze seznamu
     * @param SlozeniListener l
     */
    public void removeSlozeniListener(SlozeniListener l) {
        listenerListS.remove(l);
    }
   

    /**
     * Zpřístupňuje aktuální směs z JPanelSlozKom
     * @return Smes
     */
    public Smes getSmes() {
        return mySmes;
    }

    /**
     * Nastavuje směs pro JPanelSlozKom
     * @param mySmes
     */
    public void setSmes(Smes mySmes) {
        this.mySmes = mySmes;
    }
        
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane4 = new javax.swing.JScrollPane();
        jTableSmes = new javax.swing.JTable();
        jLabel1 = new javax.swing.JLabel();
        jLabelSeznam = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jScrollPaneSeznam = new javax.swing.JScrollPane();
        jList1 = new javax.swing.JList();
        jButtonDo = new javax.swing.JButton();
        jButtonLatBack = new javax.swing.JButton();
        jLabel15 = new javax.swing.JLabel();
        jTextFieldCislem = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jButtonSmaz = new javax.swing.JButton();
        jButtonVybrano = new javax.swing.JButton();
        jPanel9 = new javax.swing.JPanel();
        jRadioButtonHmot = new javax.swing.JRadioButton();
        jRadioButtonMol = new javax.swing.JRadioButton();
        jLabelInfoSloz = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        jTextFieldNazSmesi = new javax.swing.JTextField();
        jButton1 = new javax.swing.JButton();

        jTableSmes.setModel(new TableModelSmes());
        jScrollPane4.setViewportView(jTableSmes);

        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jLabel1.setText("Výběr složek a složení");

        jLabelSeznam.setText("Látky obsažené v databázi:");

        jLabel2.setText("<html>Na požadovanou látku najeďte šipkami nebo myší a vyberte dvojklikem nebo stiskem <i>Enter</i>.<br>Při stisknutém <i>Ctrl</i>  můžete provádět vícenásovný výběr a uplatnit ho najednou kliknutím na buttonu uprostřed s šipkou. Stisk jednoho písmene nastaví na látky od tohoto písmene.</html>");
        jLabel2.setVerticalAlignment(javax.swing.SwingConstants.TOP);

        jScrollPaneSeznam.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N

        jList1.setFont(new Font("monospaced", Font.BOLD,11));
        jList1.setModel(listModel);
        jList1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jList1MouseClicked(evt);
            }
        });
        jList1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jList1KeyTyped(evt);
            }
        });
        jScrollPaneSeznam.setViewportView(jList1);

        jButtonDo.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fydat/data/next24.png"))); // NOI18N
        jButtonDo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonDoActionPerformed(evt);
            }
        });

        jButtonLatBack.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fydat/data/back24.png"))); // NOI18N
        jButtonLatBack.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonLatBackActionPerformed(evt);
            }
        });

        jLabel15.setText("Sem zadávejte látky číslem:");

        jTextFieldCislem.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jTextFieldCislem.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextFieldCislem.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jTextFieldCislemKeyTyped(evt);
            }
        });

        jLabel3.setText("Látky vybrané do směsi:");

        jButtonSmaz.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fydat/data/delete16.png"))); // NOI18N
        jButtonSmaz.setText("Smaž dosud vybrané");
        jButtonSmaz.setIconTextGap(8);
        jButtonSmaz.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSmazActionPerformed(evt);
            }
        });

        jButtonVybrano.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jButtonVybrano.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fydat/data/next24.png"))); // NOI18N
        jButtonVybrano.setMnemonic('s');
        jButtonVybrano.setText("Směs zadána");
        jButtonVybrano.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        jButtonVybrano.setIconTextGap(8);
        jButtonVybrano.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonVybranoActionPerformed(evt);
            }
        });

        jPanel9.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jRadioButtonHmot.setSelected(true);
        jRadioButtonHmot.setText("Hmotové zadání složení");
        jRadioButtonHmot.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonHmotActionPerformed(evt);
            }
        });

        jRadioButtonMol.setText("Molární zadání složení");
        jRadioButtonMol.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonMolActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel9Layout = new javax.swing.GroupLayout(jPanel9);
        jPanel9.setLayout(jPanel9Layout);
        jPanel9Layout.setHorizontalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel9Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jRadioButtonMol)
                    .addComponent(jRadioButtonHmot))
                .addContainerGap(48, Short.MAX_VALUE))
        );
        jPanel9Layout.setVerticalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel9Layout.createSequentialGroup()
                .addComponent(jRadioButtonHmot)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jRadioButtonMol))
        );

        jLabelInfoSloz.setText("<html>Složení je možno vkládat hmotově nebo molárně (viz volba). Vkládat můžete zlomky nebo i jen poměrové díly. Složení bude následně normalizováno. Jednotlivé již zadané složení smažete pomocí <i>Del</i>.</html>");
        jLabelInfoSloz.setMaximumSize(new java.awt.Dimension(300, 28));
        jLabelInfoSloz.setVerticalTextPosition(javax.swing.SwingConstants.TOP);

        jLabel10.setText("Možno vložit uživatelský název směsi:");

        jButton1.setText("Zrušit");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jScrollPaneSeznam, javax.swing.GroupLayout.PREFERRED_SIZE, 398, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jButtonDo)
                            .addComponent(jButtonLatBack))
                        .addGap(16, 16, 16)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(jLabel15)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                        .addComponent(jTextFieldCislem, javax.swing.GroupLayout.PREFERRED_SIZE, 61, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(layout.createSequentialGroup()
                                        .addGap(2, 2, 2)
                                        .addComponent(jScrollPane4, javax.swing.GroupLayout.PREFERRED_SIZE, 362, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 3, Short.MAX_VALUE)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                .addComponent(jLabelInfoSloz, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 195, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(jPanel9, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                        .addComponent(jButtonSmaz, javax.swing.GroupLayout.Alignment.TRAILING)
                                        .addComponent(jButtonVybrano, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addComponent(jButton1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                    .addGap(12, 12, 12)))
                            .addComponent(jLabel10)
                            .addComponent(jTextFieldNazSmesi, javax.swing.GroupLayout.PREFERRED_SIZE, 213, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addContainerGap(31, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel1)
                            .addComponent(jLabelSeznam, javax.swing.GroupLayout.PREFERRED_SIZE, 187, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(18, 18, 18)
                        .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 535, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(23, 23, 23))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addGap(32, 32, 32)
                        .addComponent(jLabelSeznam))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(10, 10, 10)
                        .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 58, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                        .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                            .addGap(170, 170, 170)
                            .addComponent(jButtonDo)
                            .addGap(18, 18, 18)
                            .addComponent(jButtonLatBack))
                        .addComponent(jScrollPaneSeznam, javax.swing.GroupLayout.PREFERRED_SIZE, 473, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                            .addComponent(jPanel9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                            .addComponent(jLabelInfoSloz, javax.swing.GroupLayout.PREFERRED_SIZE, 111, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGap(31, 31, 31)
                            .addComponent(jLabel10)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(jTextFieldNazSmesi, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGap(61, 61, 61)
                            .addComponent(jButtonSmaz)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(jButtonVybrano)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                            .addComponent(jButton1)))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jTextFieldCislem, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel15))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabel3)
                        .addGap(18, 18, 18)
                        .addComponent(jScrollPane4, javax.swing.GroupLayout.PREFERRED_SIZE, 320, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

    private void jList1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jList1MouseClicked
        // Výběr látky ze seznamu dvojklikem myší
        String s;
        int k;
        if (evt.getClickCount() == 2) {
            s = (String) jList1.getSelectedValue();
            k = Integer.valueOf(s.substring(0, 3).trim()); // první znaky č. látky
            jCisla[jVyber] = k;
            //            System.out.println("mCislo: " + jVyber + " " + jCisla[jVyber]);
            jVyber++;
            smesModel.addSlozka(new Slozka(k,Latka.getLatka(k).getNazev(),""));
        }
    }//GEN-LAST:event_jList1MouseClicked

    private void jList1KeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jList1KeyTyped
        // Výběr látky ze seznamu Entrem a hledání podle prvního písmene
        String s, c;
        char ch;
        int k;
        int[] iSel;
        if (evt.getKeyChar() == KeyEvent.VK_ENTER) {
            iSel = jList1.getSelectedIndices();
            for (int i=0; i<iSel.length; i++) {
                s = (String) jList1.getModel().getElementAt(iSel[i]);
                k = Integer.valueOf(s.substring(0, 3).trim()); // první znaky č. látky
                jCisla[jVyber] = k;
                jVyber++;
                smesModel.addSlozka(new Slozka(k,Latka.getLatka(k).getNazev(),""));                                    
            }
        }
        if (evt.getKeyChar() >= 'A' && evt.getKeyChar() <= 'z') {  // nastaví list na stisk písmene
            //            System.out.println("bylo písmeno " +evt.getKeyChar());
            for (k = 0; k < jList1.getModel().getSize(); k++) {
                s = (String) ((DefaultListModel) jList1.getModel()).getElementAt(k);
                s = s.toLowerCase();
                if (evt.getKeyChar() <= s.charAt(4)) {
                    jList1.ensureIndexIsVisible(530);    // aby nejprve zajel na konec
                    jList1.ensureIndexIsVisible(k);
                    break;
                }
            }
        }
    }//GEN-LAST:event_jList1KeyTyped

    private void jButtonDoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonDoActionPerformed
        // Multiselection látek vybrána
        String s;
        int k;
        int[] iSel;
        iSel = jList1.getSelectedIndices();
        for (int i=0; i<iSel.length; i++) {
            //                s = (String) jList1.getSelectedValue();
            s = (String) jList1.getModel().getElementAt(iSel[i]);
            k = Integer.valueOf(s.substring(0, 3).trim()); // první znaky č. látky
            jCisla[jVyber] = k;
            jVyber++;
            smesModel.addSlozka(new Slozka(k,Latka.getLatka(k).getNazev(),""));
        }
    }//GEN-LAST:event_jButtonDoActionPerformed

    private void jButtonLatBackActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonLatBackActionPerformed
        // Odebrat vybranou látku
        int i = 0, j;
//        i = jListVybrano.getSelectedIndex();
//        ((DefaultListModel) jListVybrano.getModel()).removeElementAt(i);
        for (j=i; j<jVyber; j++) {
            jCisla[j] =  jCisla[j+1];
        }
        jVyber--;
    }//GEN-LAST:event_jButtonLatBackActionPerformed

    private void jTextFieldCislemKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextFieldCislemKeyTyped
        // Enter za složkou směsi zadané přímo číslem
        int i;
        String s;
        if (evt.getKeyChar() == KeyEvent.VK_ENTER) {
            if (jTextFieldCislem.getText().equals("")) {
                //                    JOptionPane.showMessageDialog(this,
                    //                            "Nemůžete zadat 'prázdné' číslo látky !",
                    //                            "Zadej složky směsi", JOptionPane.WARNING_MESSAGE);
                return;
            }
            try {
                i = Integer.parseInt(jTextFieldCislem.getText());   // číslo zadané látky
                s = String.format("%3d ", i)
                + ((Latka.getLatka(i) == null) ? "mimo rozsah" : Latka.getLatka(i).getNazev());
                if (s.indexOf("mimo rozsah") > 0 || i > 700) {
                    JOptionPane.showMessageDialog(this,
                        "Číslo látky musí být kladné a maximálně 700 !",
                        "Zadej složky směsi", JOptionPane.WARNING_MESSAGE);
                    jTextFieldCislem.setText("");
                    return;
                }
                if (Latka.getLatka(i).getNazev().equals("")) {
                    JOptionPane.showMessageDialog(this,
                        "Látka s tímto číslem (" + i + ") neexistuje !",
                        "Zadej složky směsi", JOptionPane.WARNING_MESSAGE);
                    jTextFieldCislem.setText("");
                    return;
                } else {
//                    ((DefaultListModel) jListVybrano.getModel()).addElement(s);
                    jCisla[jVyber] = i;
                    jVyber++;
                    smesModel.addSlozka(new Slozka(i,Latka.getLatka(i).getNazev(),""));
                }
            } catch (NumberFormatException e) {
                JOptionPane.showMessageDialog(this,
                    "Číslo " + e.getMessage() + " nebylo zadáno správně! !",
                    "Zadej látku číslem", JOptionPane.WARNING_MESSAGE);
                // e.printStackTrace();
            }
            jTextFieldCislem.setText("");   // smazání zadávacího pole
        }
    }//GEN-LAST:event_jTextFieldCislemKeyTyped

    private void jButtonSmazActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSmazActionPerformed
            //  Smazání obsahu předchozí tabulky
            smesModel.removeAllSlozka();        
        jVyber = 0;
        jCisla = new int[50];
    }//GEN-LAST:event_jButtonSmazActionPerformed

    private void jButtonVybranoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonVybranoActionPerformed
        // Tlačítko ukončeno zadání směsi a jejího složení a je třeba ho předat dál přes posluchače
        int i;
        if (jVyber == 0) {
                JOptionPane.showMessageDialog(this,
                    "Nebyly vybrány složky směsi!",
                    "Panel JSlozKom", JOptionPane.WARNING_MESSAGE); 
                jList1.requestFocus();
                return;
        }
        try {
            mySmes = new Smes(jVyber, jCisla);  // vytvoření směsi z dat z panelu
        } catch (JDOMException ex) {
            Logger.getLogger(JPanelSlozKom.class.getName()).log(Level.SEVERE, null, ex);                        
        } catch (IOException e) {
            Logger.getLogger(JPanelSlozky.class.getName()).log(Level.SEVERE, null, e);
        }
        // zadání a zpracování složení
        if (jVyber>0) nastaveno = true;
        double sum;
        double[] x = new double[mySmes.getnSloz()];
        String s;
        SlozeniEvent e = new SlozeniEvent();        
        boolean isSlozeni = true;
            for (i = 0; i < smesModel.getRowCount(); i++) {
                if (smesModel.getValueAt(i, 2).equals("")) {
                    isSlozeni = false;
                }
            }
            if (isSlozeni) {
                sum = 0;
                for (i = 0; i < smesModel.getRowCount(); i++) {
//                    x[i] = Double.parseDouble((smesModel.getRowCount()).replace(',', '.'));
                    s = (String) smesModel.getValueAt(i, 2);
                    x[i] = Double.parseDouble(s.replace(',', '.'));
                    sum += x[i];
                    System.out.println("" + i + 1 + " : " + x[i]);
                }
                if (sum > 0) {
                    try {
                        mySmes.zadatSloz(jRadioButtonHmot.isSelected(), x);
                    } catch (IOException ex) {
                        Logger.getLogger(JPanelSlozeni.class.getName()).log(Level.SEVERE, null, ex);
                    }
                }
                System.out.println("ze zadání složení");
                e.setSmes(mySmes);        // načtená směs
                e.setnSloz(mySmes.getnSloz()); // počet složek směsi (optonal)
//                e.setPor(jCisla);   // int[] s čísly složek  (optional)
                e.setVybráno(true);
                for( SlozeniListener listener : listenerListS ) {
                    listener.slozeniZadano(e);   // ohlášení akce posluchačům
                }
                
            } else {
                JOptionPane.showMessageDialog(this,
                    "Nebylo zadáno složení vybrané směsi, nebo ne úplně!",
                    "Panel JSlozKom", JOptionPane.WARNING_MESSAGE); 
                jTableSmes.changeSelection(0, 2, false, false);
                jTableSmes.requestFocus();    // nastaví fokus na první složení            
            }   
    }//GEN-LAST:event_jButtonVybranoActionPerformed

    private void jRadioButtonHmotActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonHmotActionPerformed
        // hmotové složení
        jRadioButtonMol.setSelected(false);
    }//GEN-LAST:event_jRadioButtonHmotActionPerformed

    private void jRadioButtonMolActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonMolActionPerformed
        // molární složení
        jRadioButtonHmot.setSelected(false);
    }//GEN-LAST:event_jRadioButtonMolActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        // Cancel
        SlozeniEvent e = new SlozeniEvent();        
        e.setVybráno(false);
        for( SlozeniListener listener : listenerListS ) {
            listener.slozeniZadano(e);   // ohlášení akce posluchačům
        }        
    }//GEN-LAST:event_jButton1ActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButtonDo;
    private javax.swing.JButton jButtonLatBack;
    private javax.swing.JButton jButtonSmaz;
    private javax.swing.JButton jButtonVybrano;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabelInfoSloz;
    private javax.swing.JLabel jLabelSeznam;
    private javax.swing.JList jList1;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JRadioButton jRadioButtonHmot;
    private javax.swing.JRadioButton jRadioButtonMol;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPaneSeznam;
    private javax.swing.JTable jTableSmes;
    private javax.swing.JTextField jTextFieldCislem;
    private javax.swing.JTextField jTextFieldNazSmesi;
    // End of variables declaration//GEN-END:variables
}
