/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package fydatlib;

import java.awt.Font;
import java.awt.event.KeyEvent;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.DefaultListModel;
import javax.swing.JOptionPane;
import org.jdom2.JDOMException;

/**
 * Panel pro zadávání složek směsi výběrem látek ze seznamu nebo i zadáváním čísel.
 * Panel použijte v uživatelském frame. Po zadání volá metodu posluchače slozkyZadany().
 * Používá ho modální vyskakovací JDialogSlozky.
 * @author V. Hlubuček
 */
public class JPanelSlozky extends javax.swing.JPanel {

    private int jVyber;                     // počet vybraných složek
    private int[] jCisla = new int[50];     // čísla vybraných složek
    private boolean nastaveno = false;
    private Smes sm;                        // instance dané směsi látek   
    List<Latka> slozky = new ArrayList();   // seznam látek dané směsi    
    DefaultListModel listModel = new DefaultListModel();   
    List<SlozkyListener> listenerList = new ArrayList();
    /**
     * Creates new form JPanelSlozky - konstruktor
     */
    public JPanelSlozky() {
        initComponents();
        nastaveno = false;
        jVyber = 0;
        try {
            naplnSeznam();
        } catch (JDOMException ex) {
            Logger.getLogger(JPanelSlozKom.class.getName()).log(Level.SEVERE, null, ex);                        
        } catch (IOException ex) {
            Logger.getLogger(JPanelSlozky.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    /**
     * Naplnění seznamu látek do listBoxu pro výběr látek
     * @throws IOException
     */
    final void naplnSeznam() throws IOException, JDOMException {
        String[] s;       // původně: musel být přesně 533 jinak chyby!
//        Font fontCur = new Font("Courier", Font.BOLD,  12);
        int nLat;
        s = Latka.seznamLatek(true);  // true - dle abecedy
        nLat = s.length;
        for (int i = 0; i < nLat; i++) {
            listModel.addElement(s[i]);  // vkládání přes model 
        }
    }
/*
 * Touto metodou napojíte směs  z JPanelSlozky
 */
    public void setSmes(Smes sm) {
        this.sm = sm;
    }
/*
 * Touto metodou se vrací načtená směs z JPanelSlozky
 * return Smes
 */
    public Smes getSmes() {
        return sm;
    }

//    public boolean isNastaveno() {
//        return nastaveno;
//    }
 /*
  *  Přidá ListenerSlozky do seznamu v z JPanelSlozky
  */   
    public void addSlozkyListener(SlozkyListener l) {
        listenerList.add(l);
    }
    /**
     * Odstraní ListenerSlozky ze seznamu v z JPanelSlozky
     * @param l 
     */
    public void removeSlozkyListener(SlozkyListener l) {
        listenerList.remove(l);
    }
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabelSeznam = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        jScrollPaneSeznam = new javax.swing.JScrollPane();
        jList1 = new javax.swing.JList();
        jLabel15 = new javax.swing.JLabel();
        jTextFieldCislem = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jButtonDo = new javax.swing.JButton();
        jButtonLatBack = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        jListVybrano = new javax.swing.JList();
        jButtonSmaz = new javax.swing.JButton();
        jButtonVybrano = new javax.swing.JButton();
        jButton1 = new javax.swing.JButton();

        setPreferredSize(new java.awt.Dimension(800, 574));

        jLabelSeznam.setText("Látky obsažené v databázi:");

        jLabel2.setText("<html>Na požadovanou látku najeďte šipkami nebo myší a vyberte dvojklikem nebo stiskem <i>Enter</i>.<br>Při stisknutém <i>Ctrl</i>  můžete provádět vícenásovný výběr a uplatnit ho najednou kliknutím na buttonu uprostřed s šipkou. Stisk jednoho písmene nastaví na látky od tohoto písmene.</html>");
        jLabel2.setVerticalAlignment(javax.swing.SwingConstants.TOP);

        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jLabel1.setText("Výběr složek");

        jScrollPaneSeznam.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N

        jList1.setFont(new Font("monospaced", Font.BOLD,11));
        jList1.setModel(listModel);
        jList1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jList1MouseClicked(evt);
            }
        });
        jList1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jList1KeyTyped(evt);
            }
        });
        jScrollPaneSeznam.setViewportView(jList1);

        jLabel15.setText("Sem zadávejte látky číslem:");

        jTextFieldCislem.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jTextFieldCislem.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextFieldCislem.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jTextFieldCislemKeyTyped(evt);
            }
        });

        jLabel3.setText("Látky vybrané do směsi:");

        jButtonDo.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fydat/data/next24.png"))); // NOI18N
        jButtonDo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonDoActionPerformed(evt);
            }
        });

        jButtonLatBack.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fydat/data/back24.png"))); // NOI18N
        jButtonLatBack.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonLatBackActionPerformed(evt);
            }
        });

        jListVybrano.setFont(new java.awt.Font("Lucida Sans Typewriter", 1, 11)); // NOI18N
        jListVybrano.setModel(new DefaultListModel());
        jListVybrano.setAutoscrolls(false);
        jScrollPane2.setViewportView(jListVybrano);

        jButtonSmaz.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fydat/data/delete16.png"))); // NOI18N
        jButtonSmaz.setText("Smaž dosud vybrané");
        jButtonSmaz.setIconTextGap(8);
        jButtonSmaz.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSmazActionPerformed(evt);
            }
        });

        jButtonVybrano.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jButtonVybrano.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fydat/data/next24.png"))); // NOI18N
        jButtonVybrano.setMnemonic('s');
        jButtonVybrano.setText("Směs vybrána");
        jButtonVybrano.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        jButtonVybrano.setIconTextGap(8);
        jButtonVybrano.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonVybranoActionPerformed(evt);
            }
        });

        jButton1.setText("Zrušit");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jScrollPaneSeznam, javax.swing.GroupLayout.PREFERRED_SIZE, 398, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(31, 31, 31)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jButtonDo)
                            .addComponent(jButtonLatBack))
                        .addGap(26, 26, 26)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                .addGroup(layout.createSequentialGroup()
                                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addGroup(layout.createSequentialGroup()
                                            .addComponent(jLabel15)
                                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                            .addComponent(jTextFieldCislem, javax.swing.GroupLayout.PREFERRED_SIZE, 61, javax.swing.GroupLayout.PREFERRED_SIZE))
                                        .addComponent(jLabel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                    .addGap(8, 8, 8))
                                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 237, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(layout.createSequentialGroup()
                                .addGap(8, 8, 8)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 149, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jButtonSmaz)
                                    .addComponent(jButtonVybrano))
                                .addGap(72, 72, 72)))
                        .addGap(66, 66, 66))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel1)
                            .addComponent(jLabelSeznam, javax.swing.GroupLayout.PREFERRED_SIZE, 187, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(18, 18, 18)
                        .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 535, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 0, Short.MAX_VALUE))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jLabel1)
                        .addGap(32, 32, 32)
                        .addComponent(jLabelSeznam))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(21, 21, 21)
                        .addComponent(jLabel2, javax.swing.GroupLayout.DEFAULT_SIZE, 58, Short.MAX_VALUE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPaneSeznam, javax.swing.GroupLayout.PREFERRED_SIZE, 473, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(133, 133, 133)
                        .addComponent(jButtonDo)
                        .addGap(18, 18, 18)
                        .addComponent(jButtonLatBack))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jTextFieldCislem, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel15))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabel3)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 196, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jButtonSmaz)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButtonVybrano)
                        .addGap(18, 18, 18)
                        .addComponent(jButton1)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void jList1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jList1MouseClicked
        // Výběr látky ze seznamu dvojklikem myší
        String s;
        int k;
        if (evt.getClickCount() == 2) {
            s = (String) jList1.getSelectedValue();
            k = Integer.valueOf(s.substring(0, 3).trim()); // první znaky č. látky
            jCisla[jVyber] = k;
            //            System.out.println("mCislo: " + jVyber + " " + jCisla[jVyber]);
            jVyber++;
            ((DefaultListModel) jListVybrano.getModel()).addElement(s.substring(0, 33));
        }
    }//GEN-LAST:event_jList1MouseClicked

    private void jList1KeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jList1KeyTyped
        // Výběr látky ze seznamu Entrem a hledání podle prvního písmene
        String s, c;
        char ch;
        int k;
        int[] iSel;
        if (evt.getKeyChar() == KeyEvent.VK_ENTER) {
            iSel = jList1.getSelectedIndices();
            for (int i=0; i<iSel.length; i++) {
                s = (String) jList1.getModel().getElementAt(iSel[i]);
                k = Integer.valueOf(s.substring(0, 3).trim()); // první znaky č. látky
                jCisla[jVyber] = k;
                jVyber++;
                ((DefaultListModel) jListVybrano.getModel()).addElement(s.substring(0, 33));
            }
        }
        if (evt.getKeyChar() >= 'A' && evt.getKeyChar() <= 'z') {  // nastaví list na stisk písmene
            //            System.out.println("bylo písmeno " +evt.getKeyChar());
            for (k = 0; k < jList1.getModel().getSize(); k++) {
                s = (String) ((DefaultListModel) jList1.getModel()).getElementAt(k);
                s = s.toLowerCase();
                if (evt.getKeyChar() <= s.charAt(4)) {
                    jList1.ensureIndexIsVisible(530);    // aby nejprve zajel na konec
                    jList1.ensureIndexIsVisible(k);
                    break;
                }
            }
        }
    }//GEN-LAST:event_jList1KeyTyped

    private void jTextFieldCislemKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextFieldCislemKeyTyped
        // Enter za složkou směsi zadané přímo číslem
        int i;
        String s;
        if (evt.getKeyChar() == KeyEvent.VK_ENTER) {
            if (jTextFieldCislem.getText().equals("")) {
//                    JOptionPane.showMessageDialog(this,
//                            "Nemůžete zadat 'prázdné' číslo látky !",
//                            "Zadej složky směsi", JOptionPane.WARNING_MESSAGE);
                return;
            }
            try {
                i = Integer.parseInt(jTextFieldCislem.getText());   // číslo zadané látky
                s = String.format("%3d ", i)
                + ((Latka.getLatka(i) == null) ? "mimo rozsah" : Latka.getLatka(i).getNazev());
                if (s.indexOf("mimo rozsah") > 0 || i > 700) {
                    JOptionPane.showMessageDialog(this,
                        "Číslo látky musí být kladné a maximálně 700 !",
                        "Zadej složky směsi", JOptionPane.WARNING_MESSAGE);
                    jTextFieldCislem.setText("");
                    return;
                }
                if (Latka.getLatka(i).getNazev().equals("")) {
                    JOptionPane.showMessageDialog(this,
                        "Látka s tímto číslem (" + i + ") neexistuje !",
                        "Zadej složky směsi", JOptionPane.WARNING_MESSAGE);
                    jTextFieldCislem.setText("");
                    return;
                } else {
                    ((DefaultListModel) jListVybrano.getModel()).addElement(s);
                    jCisla[jVyber] = i;
                    jVyber++;
                }
            } catch (NumberFormatException e) {
                JOptionPane.showMessageDialog(this,
                    "Číslo " + e.getMessage() + " nebylo zadáno správně! !",
                    "Zadej látku číslem", JOptionPane.WARNING_MESSAGE);
                // e.printStackTrace();
            }
            jTextFieldCislem.setText("");   // smazání zadávacího pole
        }
    }//GEN-LAST:event_jTextFieldCislemKeyTyped

    private void jButtonDoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonDoActionPerformed
        // Multiselection látek vybrána
        String s;
        int k;
        int[] iSel;
        iSel = jList1.getSelectedIndices();
        for (int i=0; i<iSel.length; i++) {
            //                s = (String) jList1.getSelectedValue();
            s = (String) jList1.getModel().getElementAt(iSel[i]);
            k = Integer.valueOf(s.substring(0, 3).trim()); // první znaky č. látky
            jCisla[jVyber] = k;
            jVyber++;
            ((DefaultListModel) jListVybrano.getModel()).addElement(s.substring(0, 33));
        }
    }//GEN-LAST:event_jButtonDoActionPerformed

    private void jButtonLatBackActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonLatBackActionPerformed
        // Odebrat vybranou látku
        int i, j;
        i = jListVybrano.getSelectedIndex();
        ((DefaultListModel) jListVybrano.getModel()).removeElementAt(i);
        for (j=i; j<jVyber; j++) {
            jCisla[j] =  jCisla[j+1];
        }
        jVyber--;
    }//GEN-LAST:event_jButtonLatBackActionPerformed

    private void jButtonSmazActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSmazActionPerformed
        // Smaže dosud vybrané látky:
        //        jListVybrano.removeAll(); // nefunguje !
        ((DefaultListModel) jListVybrano.getModel()).removeAllElements();
        jVyber = 0;
        jCisla = new int[50];
    }//GEN-LAST:event_jButtonSmazActionPerformed

    private void jButtonVybranoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonVybranoActionPerformed
        // Tlačítko ukončen výběr směsi a je třeba ho předat dál přes posluchače
        int i;
        try {
            sm = new Smes(jVyber, jCisla);  // vytvoření směsi z dat z panelu
        } catch (JDOMException ex) {
            Logger.getLogger(JPanelSlozKom.class.getName()).log(Level.SEVERE, null, ex);                        
        } catch (IOException e) {
            Logger.getLogger(JPanelSlozky.class.getName()).log(Level.SEVERE, null, e);
        }
        // předat výsledky listenerem
        if (jVyber>0) nastaveno = true;
        SlozkyEvent e = new SlozkyEvent();
        e.setSmes(sm);        // načtená směs
        e.setnSloz(jVyber); // počet složek směsi (optonal)
        e.setPor(jCisla);   // int[] s čísly složek  (optional)
        e.setVybráno(nastaveno);
        for( SlozkyListener listener : listenerList ) {
            listener.slozkyZadany(e);   // ohlášení akce posluchačům
        }
    }//GEN-LAST:event_jButtonVybranoActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
//        Tlačítko Cancel
        SlozkyEvent e = new SlozkyEvent();
        e.setVybráno(false);
        for( SlozkyListener listener : listenerList ) {
            listener.slozkyZadany(e);   // ohlášení akce posluchačům
        }                
    }//GEN-LAST:event_jButton1ActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButtonDo;
    private javax.swing.JButton jButtonLatBack;
    private javax.swing.JButton jButtonSmaz;
    private javax.swing.JButton jButtonVybrano;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabelSeznam;
    private javax.swing.JList jList1;
    private javax.swing.JList jListVybrano;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPaneSeznam;
    private javax.swing.JTextField jTextFieldCislem;
    // End of variables declaration//GEN-END:variables
}
