/**
 * Package fydatlib
 * Knihovna metod pro fyzikální vlastnosti org. látek a technických plynů
 * a jejich směsí
 */

package fydatlib;

/**
 *  Vlastnost formou korelačního vztahu, typ vztahu (int),
 *  třída přesnosti(int) a dolní a horní meze platnosti korelačního vztahu (double, K)
 * a[] jsou konstanty korelačního vztahu
 * @author V.Hlubuček
 */
public class Vlastnost {
    /**
     * typ korelačního vztahu (polynom, exp, ln ....)
     */
    protected int vztah;          // typ korelačního vztahu (polynom, exp, ln ....)
    /**
     * třída přesnosti
     */
    protected int trida;          // třída přesnosti
    /**
     * spodní teplotní mez platnosti (K)
     */
    protected int iOd;            // spodní teplotní mez platnosti (K)
    /**
     * horní teplotní mez platnosti (K)
     */
    protected int iDo;            // horní teplotní mez platnosti (K)
    /**
     * Pole konstant korelačních vztahů
     */    
    protected double[] a = new double[6];     // konstanty korelačního vztahu 

    public int getVztah() {
        return vztah;
    }

    public int getTrida() {
        return trida;
    }

    public int getiOd() {
        return iOd;
    }

    public int getiDo() {
        return iDo;
    }

    public double[] getA() {
        return a;
    }
    
    
}
