/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * FydatGUI.java
 * F Y D A T   databáze fyzikálních vlastností
 * org. látek a technických plynů a jejich směsí
 * Tabelační aplikační program - slouží k výpočtu
 * fyzikálních vlastností zadané směsi, porovnávání 
 * vlastností látek a dalším výpočtům
 * @ autor Ing. Vratislav Hlubuček, CSc.
 * Created on 27.4.2010, 13:00:59
 * Modified on 30.12.2013 přidána tabelace fcí (l i g), Save s kodováním
 * Modified on 6.5.2014 zajištěny neproporciální fonty (UserCode new Font)
 * Modified on 27.5.2014 zajištěn fokus na tabelaci směsi
 * Modified on 18.7.2014 zajištěn přidáno čtení dat z fydat.xml (V3.21)
 * Modified on 22.7.2014 načtení dodatečných látek z vlastního .xml (V3.22)
 */
package fydat;

import fydatlib.Latka;
import fydatlib.Smes;
import fydatlib.ZkJFrame;
import java.awt.BasicStroke;
import java.awt.Canvas;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.Stroke;
import java.awt.Toolkit;
import java.awt.event.KeyEvent;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.URL;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Locale;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.DefaultListModel;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableColumn;
import javax.swing.table.TableColumnModel;
import org.jdom2.JDOMException;
import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.plot.XYPlot;
import org.jfree.data.xy.XYDataset;
import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection;

/**
 * Grafické tabelační prostředí pro tabelaci
 * vlastností vybraných látek z báze
 * @author V. Hlubuček
 */
public class FydatGUI extends javax.swing.JFrame implements I_Fmin {

    int zvolenaCinnost;
    int jVyber = 0;
    static int nastavVzhled = 0;  // 0 až 4 volba čísla vzhledu aplikace
    static String[] vzhled = {"Metal", "Nimbus","CDE/Motif","Windows","Windows Clasic"};
    static int iZobrazLatku;
    static final String VERZE = "V3.22";
    static final String OWNER = "nekomerční užití";
    static final String NAPOVEDA = "fydat.pdf";    // soubor v adresáři s návodem
    static final double TABS = 273.15;
    static boolean lookNimbus = true;  // nastavuje jiný vzhled aplikace    
    static boolean tabDleTepl = true;
    static boolean bylaTabelace = false;
    static boolean adiabFlash = false;  // identifikace zadání pro flash
    static boolean pocatek = false;       // příznak výp. výchozího stavu flashe
    static double tPom, pPom, hPom;
    static String vlPom;
    static double[] zz, xx, yy;
    private boolean zmenaSloz = false;  // přepínač nového složení
    private int cinnost;   // vybraná činnost
    private double t, p;  // běžná teplota  a tlak
    private double tabPoc;  // počáteční hodnota tabelace
    private double tabKon;  // koncová hodnota tabelace
    private double tabKrok;  // krok tabelace
    private double Ptab, Ttab;  // tabelace "při" tlaku(MPa), teplotě(°C)
    private String[] zkratky = new String[80];  // zkratky vlastností
    private int[] vybrVla = new int[50];    // indexy vybraných vlastností
    private int nVybrVla = 0;       // počet vybraných vlastností
    private String tabelace = "";     // tabelační string výsledný
    private double[] x;     // pomocné pole složení
    private double T1, T2, T3;      // teploty pro porovnání
    int[] jCisla = new int[50];
    private String VlaGraf = "";
    int iGraf = -1;
    Platno pl = new Platno();
    Toolkit tlk = this.getToolkit();
    DefaultListModel listModel = new DefaultListModel();
    Latka lt;
    Smes sm;        // směs pro tabelaci
    Smes[] smPor;   // pole směsí pro porovnávání
    protected XYDataset data;
    TableModelSmes smesModel = new TableModelSmes();

    /**
     * Zobrazení aktuálního tlaku
     * @return double tlak (Pa)
     */
    public double getP() {
        return p;
    }

    /**
     * Nastavení aktuálního tlaku
     * @param double p (Pa)
     */
    public void setP(double p) {
        this.p = p;
    }

    /**
     * Zobrazení aktuální abs. teploty
     * @return double T (K)
     */
    public double getT() {
        return t;
    }

    /**
     * Nastavení aktuální abs. teploty (K)
     * @param t
     */
    public void setT(double t) {
        this.t = t;
    }

    /** Creates new form FydatGUI */
    public FydatGUI() {
        initComponents();
        myInit();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroupFlash = new javax.swing.ButtonGroup();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel2 = new javax.swing.JPanel();
        jPanelObr1 = new fydat.JPanelObr();
        jLabelNadpis = new javax.swing.JLabel();
        jLabelText = new javax.swing.JLabel();
        jLabelAutor = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabelCinnosti = new javax.swing.JLabel();
        jScrollPane5 = new javax.swing.JScrollPane();
        jList3 = new javax.swing.JList();
        jLabel1 = new javax.swing.JLabel();
        jButtonKonec = new javax.swing.JButton();
        jLabel17 = new javax.swing.JLabel();
        jButtonVlastni = new javax.swing.JButton();
        jPanel4 = new javax.swing.JPanel();
        jLabelSeznam = new javax.swing.JLabel();
        jScrollPaneSeznam = new javax.swing.JScrollPane();
        jList1 = new javax.swing.JList();
        jLabel2 = new javax.swing.JLabel();
        jButtonVybrano = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        jListVybrano = new javax.swing.JList();
        jLabel3 = new javax.swing.JLabel();
        jLabel15 = new javax.swing.JLabel();
        jTextFieldCislem = new javax.swing.JTextField();
        jButtonSmaz = new javax.swing.JButton();
        jButtonDo = new javax.swing.JButton();
        jButtonLatBack = new javax.swing.JButton();
        jPanel5 = new javax.swing.JPanel();
        jLabelInfoSloz = new javax.swing.JLabel();
        jPanel9 = new javax.swing.JPanel();
        jRadioButtonHmot = new javax.swing.JRadioButton();
        jRadioButtonMol = new javax.swing.JRadioButton();
        jButton1 = new javax.swing.JButton();
        jLabel6 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        jTextFieldNazSmesi = new javax.swing.JTextField();
        jButtonSmazSloz = new javax.swing.JButton();
        jScrollPane4 = new javax.swing.JScrollPane();
        jTableSmes = new javax.swing.JTable();
        jPanelLatka = new javax.swing.JPanel();
        jLabel26 = new javax.swing.JLabel();
        jTextFieldLNaz = new javax.swing.JTextField();
        jLabel27 = new javax.swing.JLabel();
        jTextFieldLVz = new javax.swing.JTextField();
        jLabel31 = new javax.swing.JLabel();
        jTextFieldLCAS = new javax.swing.JTextField();
        jLabel32 = new javax.swing.JLabel();
        jTextFieldLCis = new javax.swing.JTextField();
        jLabel33 = new javax.swing.JLabel();
        jTextFieldLMol = new javax.swing.JTextField();
        jLabel34 = new javax.swing.JLabel();
        jTextFieldLTkr = new javax.swing.JTextField();
        jLabel35 = new javax.swing.JLabel();
        jTextFieldLTkrC = new javax.swing.JTextField();
        jLabel36 = new javax.swing.JLabel();
        jTextFieldLPkr = new javax.swing.JTextField();
        jLabel37 = new javax.swing.JLabel();
        jTextFieldLVkr = new javax.swing.JTextField();
        jLabel38 = new javax.swing.JLabel();
        jTextFieldLAc = new javax.swing.JTextField();
        jLabel39 = new javax.swing.JLabel();
        jTextFieldLGyr = new javax.swing.JTextField();
        jLabel40 = new javax.swing.JLabel();
        jTextFieldLInd = new javax.swing.JTextField();
        jLabel41 = new javax.swing.JLabel();
        jTextFieldLTInd = new javax.swing.JTextField();
        jLabel42 = new javax.swing.JLabel();
        jTextFieldLDip = new javax.swing.JTextField();
        jLabel43 = new javax.swing.JLabel();
        jTextFieldLDiel = new javax.swing.JTextField();
        jLabel44 = new javax.swing.JLabel();
        jTextFieldLHt = new javax.swing.JTextField();
        jLabel45 = new javax.swing.JLabel();
        jTextFieldLTt = new javax.swing.JTextField();
        jLabel46 = new javax.swing.JLabel();
        jTextFieldLTnbv = new javax.swing.JTextField();
        jToggleButtonDocas = new javax.swing.JToggleButton();
        jPanel6 = new javax.swing.JPanel();
        label1 = new java.awt.Label();
        label2 = new java.awt.Label();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jButtonSmazat = new javax.swing.JButton();
        jPanel10 = new javax.swing.JPanel();
        jRadioButtonT = new javax.swing.JRadioButton();
        jRadioButtonP = new javax.swing.JRadioButton();
        jLabelPorov = new javax.swing.JLabel();
        jScrollPane8 = new javax.swing.JScrollPane();
        jListVlast = new javax.swing.JList();
        jButtonVlDo = new javax.swing.JButton();
        jScrollPane9 = new javax.swing.JScrollPane();
        jListVybrVl = new javax.swing.JList();
        jButtonBack = new javax.swing.JButton();
        jPanel11 = new javax.swing.JPanel();
        jLabelPodleCeho = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        jTextFieldPoc = new javax.swing.JTextField();
        jLabel12 = new javax.swing.JLabel();
        jTextFieldKon = new javax.swing.JTextField();
        jLabel13 = new javax.swing.JLabel();
        jTextFieldKrok = new javax.swing.JTextField();
        jLabelPri = new javax.swing.JLabel();
        jTextFieldPri = new javax.swing.JTextField();
        jLabel14 = new javax.swing.JLabel();
        jCheckBoxPridSloz = new javax.swing.JCheckBox();
        jButtonTabel = new javax.swing.JButton();
        jPanel14 = new javax.swing.JPanel();
        jLabel18 = new javax.swing.JLabel();
        jTextFieldT1 = new javax.swing.JTextField();
        jLabel19 = new javax.swing.JLabel();
        jTextFieldT2 = new javax.swing.JTextField();
        jLabel20 = new javax.swing.JLabel();
        jTextFieldT3 = new javax.swing.JTextField();
        jLabel21 = new javax.swing.JLabel();
        jTextFieldP = new javax.swing.JTextField();
        jPanel8 = new javax.swing.JPanel();
        jLabel16 = new javax.swing.JLabel();
        jScrollPane3 = new javax.swing.JScrollPane();
        jTextAreaTab = new javax.swing.JTextArea();
        jPanel12 = new javax.swing.JPanel();
        jTabbedPane2 = new javax.swing.JTabbedPane();
        jScrollPane6 = new javax.swing.JScrollPane();
        jListGr = new javax.swing.JList();
        jLabel22 = new javax.swing.JLabel();
        jPanel15 = new javax.swing.JPanel();
        jLabel24 = new javax.swing.JLabel();
        jButtonNab = new javax.swing.JButton();
        jCheckBoxOdNuly = new javax.swing.JCheckBox();
        jLabelNoGraf = new javax.swing.JLabel();
        jPanelVyber = new javax.swing.JPanel();
        jScrollPane7 = new javax.swing.JScrollPane();
        jList4 = new javax.swing.JList();
        jLabel23 = new javax.swing.JLabel();
        jLabelVyber1 = new javax.swing.JLabel();
        jLabel25 = new javax.swing.JLabel();
        jCheckBox1 = new javax.swing.JCheckBox();
        jLabelSoubor = new javax.swing.JLabel();
        jPanel13 = new javax.swing.JPanel();
        jPanelFlash = new javax.swing.JPanel();
        jLabel9 = new javax.swing.JLabel();
        jLabelFbv = new javax.swing.JLabel();
        jLabelFrb = new javax.swing.JLabel();
        jRadioButtonAd = new javax.swing.JRadioButton();
        jRadioButtonIzo = new javax.swing.JRadioButton();
        jLabel28 = new javax.swing.JLabel();
        jTextFieldFPpoc = new javax.swing.JTextField();
        jLabel29 = new javax.swing.JLabel();
        jTextFieldFPkon = new javax.swing.JTextField();
        jTextFieldFTpoc = new javax.swing.JTextField();
        jLabel30 = new javax.swing.JLabel();
        jButtonFlash = new javax.swing.JButton();
        jLabel4 = new javax.swing.JLabel();
        menuBar = new javax.swing.JMenuBar();
        fileMenu = new javax.swing.JMenu();
        saveMenuItem = new javax.swing.JMenuItem();
        exitMenuItem = new javax.swing.JMenuItem();
        actMenu = new javax.swing.JMenu();
        tabelMenuItem = new javax.swing.JMenuItem();
        porovMenuItem = new javax.swing.JMenuItem();
        seznMenuItem = new javax.swing.JMenuItem();
        grafMenuItem = new javax.swing.JMenuItem();
        vyhledMenuItem = new javax.swing.JMenuItem();
        vysledMenuItem = new javax.swing.JMenuItem();
        smazMenuItem = new javax.swing.JMenuItem();
        vlastMenuItem = new javax.swing.JMenuItem();
        jMenuItemFlash = new javax.swing.JMenuItem();
        jMenuItemKompr = new javax.swing.JMenuItem();
        jMenuItem1 = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JPopupMenu.Separator();
        konecMenuItem = new javax.swing.JMenuItem();
        helpMenu = new javax.swing.JMenu();
        contentsMenuItem = new javax.swing.JMenuItem();
        aboutMenuItem = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle(" F Y D A T ");
        setFont(new java.awt.Font("Lucida Sans", 1, 14)); // NOI18N
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowOpened(java.awt.event.WindowEvent evt) {
                formWindowOpened(evt);
            }
        });

        jPanelObr1.setPreferredSize(new java.awt.Dimension(316, 158));

        javax.swing.GroupLayout jPanelObr1Layout = new javax.swing.GroupLayout(jPanelObr1);
        jPanelObr1.setLayout(jPanelObr1Layout);
        jPanelObr1Layout.setHorizontalGroup(
            jPanelObr1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 316, Short.MAX_VALUE)
        );
        jPanelObr1Layout.setVerticalGroup(
            jPanelObr1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 158, Short.MAX_VALUE)
        );

        jLabelNadpis.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        jLabelNadpis.setText("<html>Databáze fyzikálních vlastností<br> organických látek, technických  plynů a jejich směsí.</html>");
        jLabelNadpis.setVerticalAlignment(javax.swing.SwingConstants.TOP);

        jLabelText.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
        jLabelText.setText("<html>Obsahuje data o více než 530 látkách. V následujících záložkách nejprve navolte složky vaší směsi, zadejte složení jednotlivých složek a vyberte fyzikální vlastnosti, které budete chtít spočítat. Mějte vždy na paměti fyzikální reálnost vámi navolených podmínek (existence kap. fáze, kritická oblast a pod.). Algoritmus předpokládá ideální chování, pouze u plynných a termodynamických vlastností umožňuje zahrnout generalizovanou korekci na neideální chování (Lee-Kesler). Výsledky z <i>Okna výsledků</i> si můžete přes schránku zkopírovat do vašeho textového editoru a doformátovat.<br>Také si můžete uložit výsledkové okno do souboru.<br>Data o látkách se načítají z interního souboru <i>fydat.drc</i>. Pokud bude v adresáři aplikace soubor s daty <i><b>fydat.xml</b></i> ve správném formátu, načtou se data z něho. Pokud by tam byl v komprimované podobě <i><b>fydat.zip</b></i>, rozbalí se a načte se.<br>Pokud nahrajete do adresáře aplikace i soubor návodu <i><b>fydat.pdf</i></b>, bude se zobrazovat při odpovídajíci volbě činnosti.  </html> ");
        jLabelText.setVerticalAlignment(javax.swing.SwingConstants.TOP);

        jLabelAutor.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jLabelAutor.setText("(c) Ing. Vratislav Hlubuček, CSc.  2010");

        jLabel5.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
        jLabel5.setText("<html>Báze FYDAT je zaměřena na oblast všech druhů technických výpočtů prováděných v chemickém průmyslu, výzkumně-vývojových a projekčních organizacích. Zejména pro přestup tepla, proudění a pod. Stejně dobře se však uplatní ve výuce<br> a dalších oblastech. Je programována v jazyce Java a tudíž funkční nejen na platformě Windows, ale i Linux a pod.<br< Autor nenese zodpovědnost za případné škody vyplývající z použití databáze v aplikacích.</html>");
        jLabel5.setVerticalAlignment(javax.swing.SwingConstants.TOP);

        jLabelCinnosti.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jLabelCinnosti.setText("FYDAT nabízí následující činnosti:");

        jList3.setBackground(new java.awt.Color(222, 206, 197));
        jList3.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jList3.setForeground(new java.awt.Color(87, 60, 13));
        jList3.setModel(new DefaultListModel());
        jList3.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jList3MouseClicked(evt);
            }
        });
        jList3.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jList3KeyTyped(evt);
            }
        });
        jScrollPane5.setViewportView(jList3);

        jLabel1.setText("<html>Na požadovanou činnost najeďte šipkami nebo myší a vyberte dvojklikem nebo stiskem <i>Enter</i>.</html>");

        jButtonKonec.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fydat/data/delete24.png"))); // NOI18N
        jButtonKonec.setText("Ukončit program");
        jButtonKonec.setIconTextGap(8);
        jButtonKonec.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonKonecActionPerformed(evt);
            }
        });

        jLabel17.setText("<html>Pokud chcete ještě načíst dodatečné látky z vlastního souboru   <i>.xml</i>,  tak klikněte na tlačítko.  </html>");

        jButtonVlastni.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jButtonVlastni.setText("Načíst vlastní dodatečné látky");
        jButtonVlastni.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonVlastniActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 18, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabelAutor, javax.swing.GroupLayout.PREFERRED_SIZE, 255, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGap(43, 43, 43))
                        .addComponent(jPanelObr1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(jLabel5, javax.swing.GroupLayout.PREFERRED_SIZE, 296, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(12, 12, 12)))
                .addGap(40, 40, 40)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabelNadpis, javax.swing.GroupLayout.PREFERRED_SIZE, 231, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabelText, javax.swing.GroupLayout.PREFERRED_SIZE, 253, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, 406, Short.MAX_VALUE)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jScrollPane5, javax.swing.GroupLayout.PREFERRED_SIZE, 323, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabelCinnosti, javax.swing.GroupLayout.PREFERRED_SIZE, 291, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel17, javax.swing.GroupLayout.PREFERRED_SIZE, 337, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                .addComponent(jButtonKonec, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(jButtonVlastni, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGap(30, 30, 30)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addComponent(jPanelObr1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18)
                                .addComponent(jLabelAutor)
                                .addGap(31, 31, 31)
                                .addComponent(jLabel5, javax.swing.GroupLayout.PREFERRED_SIZE, 194, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addComponent(jLabelCinnosti)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jScrollPane5, javax.swing.GroupLayout.PREFERRED_SIZE, 234, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18)
                                .addComponent(jLabel17, javax.swing.GroupLayout.PREFERRED_SIZE, 41, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jButtonVlastni, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addGap(22, 22, 22)
                        .addComponent(jButtonKonec))
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(jLabelNadpis, javax.swing.GroupLayout.PREFERRED_SIZE, 64, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabelText, javax.swing.GroupLayout.PREFERRED_SIZE, 436, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(74, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("Úvod a činnosti", jPanel2);

        jLabelSeznam.setText("Látky obsažené v databázi:");

        jScrollPaneSeznam.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N

        jList1.setFont(new Font("Monospaced", Font.BOLD,12));
        jList1.setModel(listModel);
        jList1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jList1MouseClicked(evt);
            }
        });
        jList1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jList1KeyTyped(evt);
            }
        });
        jScrollPaneSeznam.setViewportView(jList1);

        jLabel2.setText("<html>Na požadovanou látku najeďte šipkami nebo myší a vyberte dvojklikem nebo stiskem <i>Enter</i>.<br>Při stisknutém <i>Ctrl</i>  můžete provádět vícenásovný výběr a uplatnit ho najednou kliknutím na buttonu uprostřed s šipkou. Stisk jednoho písmene nastaví na látky od tohoto písmene.</html>");

        jButtonVybrano.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jButtonVybrano.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fydat/data/next24.png"))); // NOI18N
        jButtonVybrano.setMnemonic('s');
        jButtonVybrano.setText("Směs vybrána");
        jButtonVybrano.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        jButtonVybrano.setIconTextGap(8);
        jButtonVybrano.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonVybranoActionPerformed(evt);
            }
        });

        jListVybrano.setFont(new java.awt.Font("Lucida Sans Typewriter", 1, 11)); // NOI18N
        jListVybrano.setModel(new DefaultListModel());
        jListVybrano.setAutoscrolls(false);
        jScrollPane2.setViewportView(jListVybrano);

        jLabel3.setText("Látky vybrané do směsi:");

        jLabel15.setText("Sem zadávejte látky číslem:");

        jTextFieldCislem.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jTextFieldCislem.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextFieldCislem.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jTextFieldCislemKeyTyped(evt);
            }
        });

        jButtonSmaz.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fydat/data/delete16.png"))); // NOI18N
        jButtonSmaz.setText("Smaž dosud vybrané");
        jButtonSmaz.setIconTextGap(8);
        jButtonSmaz.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSmazActionPerformed(evt);
            }
        });

        jButtonDo.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fydat/data/next24.png"))); // NOI18N
        jButtonDo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonDoActionPerformed(evt);
            }
        });

        jButtonLatBack.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fydat/data/back24.png"))); // NOI18N
        jButtonLatBack.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonLatBackActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addComponent(jScrollPaneSeznam, javax.swing.GroupLayout.PREFERRED_SIZE, 398, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(27, 27, 27)
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jButtonDo)
                            .addComponent(jButtonLatBack))
                        .addGap(26, 26, 26)
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                .addGroup(jPanel4Layout.createSequentialGroup()
                                    .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addGroup(jPanel4Layout.createSequentialGroup()
                                            .addComponent(jLabel15)
                                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                            .addComponent(jTextFieldCislem, javax.swing.GroupLayout.PREFERRED_SIZE, 61, javax.swing.GroupLayout.PREFERRED_SIZE))
                                        .addComponent(jLabel3, javax.swing.GroupLayout.DEFAULT_SIZE, 474, Short.MAX_VALUE))
                                    .addGap(8, 8, 8))
                                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 237, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(jPanel4Layout.createSequentialGroup()
                                .addGap(8, 8, 8)
                                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jButtonSmaz)
                                    .addComponent(jButtonVybrano))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 72, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addGap(53, 53, 53))
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addComponent(jLabelSeznam, javax.swing.GroupLayout.PREFERRED_SIZE, 187, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 535, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap())))
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabelSeznam)
                            .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 77, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel4Layout.createSequentialGroup()
                                .addGap(11, 11, 11)
                                .addComponent(jScrollPaneSeznam, javax.swing.GroupLayout.DEFAULT_SIZE, 478, Short.MAX_VALUE))
                            .addGroup(jPanel4Layout.createSequentialGroup()
                                .addGap(144, 144, 144)
                                .addComponent(jButtonDo)
                                .addGap(18, 18, 18)
                                .addComponent(jButtonLatBack))))
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addGap(99, 99, 99)
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jTextFieldCislem, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel15))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabel3)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 196, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jButtonSmaz)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButtonVybrano)))
                .addGap(33, 33, 33))
        );

        jTabbedPane1.addTab("Výběr látek", jPanel4);

        jLabelInfoSloz.setText("<html>Složení je možno vkládat hmotově nebo molárně (viz volba). Vkládat můžete zlomky nebo i jen poměrové díly. Složení bude následně normalizováno. Jednotlivé již zadané složení smažete pomocí <i>Del</i>.</html>");
        jLabelInfoSloz.setMaximumSize(new java.awt.Dimension(300, 28));
        jLabelInfoSloz.setVerticalTextPosition(javax.swing.SwingConstants.TOP);

        jPanel9.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jRadioButtonHmot.setSelected(true);
        jRadioButtonHmot.setText("Hmotové zadání složení");
        jRadioButtonHmot.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonHmotActionPerformed(evt);
            }
        });

        jRadioButtonMol.setText("Molární zadání složení");
        jRadioButtonMol.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonMolActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel9Layout = new javax.swing.GroupLayout(jPanel9);
        jPanel9.setLayout(jPanel9Layout);
        jPanel9Layout.setHorizontalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel9Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jRadioButtonMol)
                    .addComponent(jRadioButtonHmot))
                .addContainerGap(48, Short.MAX_VALUE))
        );
        jPanel9Layout.setVerticalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel9Layout.createSequentialGroup()
                .addComponent(jRadioButtonHmot)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jRadioButtonMol))
        );

        jButton1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fydat/data/next24.png"))); // NOI18N
        jButton1.setText("Na výběr vlastností");
        jButton1.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        jButton1.setIconTextGap(6);
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jButton1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jButton1KeyTyped(evt);
            }
        });

        jLabel6.setText("<html>Na spodním panelu se zobrazí  bodové vlastnosti látky na jejímž řádku je fokus. Tlačítko vám umožní dočasnou změnu názvu složky (náhradní látky).</html>");
        jLabel6.setVerticalAlignment(javax.swing.SwingConstants.TOP);

        jLabel10.setText("Možno vložit uživatelský název směsi:");

        jButtonSmazSloz.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fydat/data/delete16.png"))); // NOI18N
        jButtonSmazSloz.setText("Smazat celé složení");
        jButtonSmazSloz.setIconTextGap(8);
        jButtonSmazSloz.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSmazSlozActionPerformed(evt);
            }
        });

        jTableSmes.setModel(new TableModelSmes());
        jScrollPane4.setViewportView(jTableSmes);

        jPanelLatka.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanelLatka.setPreferredSize(new java.awt.Dimension(700, 163));

        jLabel26.setText("Látka:");

        jTextFieldLNaz.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N

        jLabel27.setText("Vzorec:");

        jTextFieldLVz.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel31.setText("CAS:");

        jTextFieldLCAS.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel32.setText("Číslo:");

        jTextFieldLCis.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel33.setText("<html>Mol.hmot.<br>(kg/mol):</html>");

        jTextFieldLMol.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel34.setText("Tkr (K):");

        jTextFieldLTkr.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel35.setText("Tkr (°C):");

        jTextFieldLTkrC.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel36.setText("Pkr (MPa):");

        jTextFieldLPkr.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel37.setText("Vkr (ml/mol):");

        jTextFieldLVkr.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel38.setText("Acentr.f.:");

        jTextFieldLAc.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextFieldLAc.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextFieldLAcActionPerformed(evt);
            }
        });

        jLabel39.setText("Gyr.p:");

        jTextFieldLGyr.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel40.setText("Ind.lomu:");

        jTextFieldLInd.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel41.setText("TInd.lomu:");

        jTextFieldLTInd.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel42.setText("Dipolm:");

        jTextFieldLDip.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel43.setText("Dielek.k:");

        jTextFieldLDiel.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel44.setText("<html>Teplo tání.<br>(J/mol):</html>");

        jTextFieldLHt.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel45.setText("Ttání (°C):");

        jTextFieldLTt.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel46.setText("Tnbv (°C):");

        jTextFieldLTnbv.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jToggleButtonDocas.setText("<html>Uplatni dočasnou <br>změnu názvu látky</html>");
        jToggleButtonDocas.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButtonDocasActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanelLatkaLayout = new javax.swing.GroupLayout(jPanelLatka);
        jPanelLatka.setLayout(jPanelLatkaLayout);
        jPanelLatkaLayout.setHorizontalGroup(
            jPanelLatkaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelLatkaLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelLatkaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanelLatkaLayout.createSequentialGroup()
                        .addGroup(jPanelLatkaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanelLatkaLayout.createSequentialGroup()
                                .addComponent(jLabel26)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jTextFieldLNaz, javax.swing.GroupLayout.DEFAULT_SIZE, 369, Short.MAX_VALUE)
                                .addGap(18, 18, 18)
                                .addComponent(jLabel27)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jTextFieldLVz, javax.swing.GroupLayout.PREFERRED_SIZE, 76, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(jLabel31)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jTextFieldLCAS, javax.swing.GroupLayout.PREFERRED_SIZE, 76, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(jPanelLatkaLayout.createSequentialGroup()
                                .addGroup(jPanelLatkaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanelLatkaLayout.createSequentialGroup()
                                        .addComponent(jLabel38)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jTextFieldLAc))
                                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanelLatkaLayout.createSequentialGroup()
                                        .addComponent(jLabel33, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jTextFieldLMol, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(jPanelLatkaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(jPanelLatkaLayout.createSequentialGroup()
                                        .addComponent(jLabel34)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jTextFieldLTkr, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jLabel35)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jTextFieldLTkrC, javax.swing.GroupLayout.PREFERRED_SIZE, 38, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jLabel36)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jTextFieldLPkr, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jLabel37)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jTextFieldLVkr, javax.swing.GroupLayout.PREFERRED_SIZE, 48, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(jPanelLatkaLayout.createSequentialGroup()
                                        .addComponent(jLabel39)
                                        .addGap(2, 2, 2)
                                        .addComponent(jTextFieldLGyr, javax.swing.GroupLayout.PREFERRED_SIZE, 57, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addGap(18, 18, 18)
                                        .addComponent(jLabel40)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jTextFieldLInd, javax.swing.GroupLayout.DEFAULT_SIZE, 46, Short.MAX_VALUE)
                                        .addGap(18, 18, 18)
                                        .addComponent(jLabel41)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jTextFieldLTInd, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jLabel42)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jTextFieldLDip, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                .addGap(35, 35, 35)
                                .addComponent(jToggleButtonDocas, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addGap(115, 115, 115))
                    .addGroup(jPanelLatkaLayout.createSequentialGroup()
                        .addComponent(jLabel43)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextFieldLDiel, javax.swing.GroupLayout.PREFERRED_SIZE, 53, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel44, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextFieldLHt, javax.swing.GroupLayout.PREFERRED_SIZE, 63, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jLabel45)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextFieldLTt, javax.swing.GroupLayout.PREFERRED_SIZE, 38, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel46)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextFieldLTnbv, javax.swing.GroupLayout.PREFERRED_SIZE, 38, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel32)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextFieldLCis, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap(260, Short.MAX_VALUE))))
        );
        jPanelLatkaLayout.setVerticalGroup(
            jPanelLatkaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelLatkaLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelLatkaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel26)
                    .addComponent(jTextFieldLNaz, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel27)
                    .addComponent(jTextFieldLVz, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel31)
                    .addComponent(jTextFieldLCAS, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanelLatkaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanelLatkaLayout.createSequentialGroup()
                        .addGroup(jPanelLatkaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jLabel33, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(jPanelLatkaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                .addComponent(jTextFieldLMol, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(jLabel34)
                                .addComponent(jLabel35)
                                .addComponent(jTextFieldLTkrC, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(jLabel36)
                                .addComponent(jTextFieldLTkr, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(jTextFieldLPkr, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(jLabel37)
                                .addComponent(jTextFieldLVkr, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jPanelLatkaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel38)
                            .addComponent(jTextFieldLAc, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel39)
                            .addComponent(jTextFieldLGyr, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel40)
                            .addComponent(jTextFieldLInd, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel41)
                            .addComponent(jTextFieldLTInd, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel42)
                            .addComponent(jTextFieldLDip, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanelLatkaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(jPanelLatkaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                .addComponent(jLabel43)
                                .addComponent(jTextFieldLDiel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(jLabel44, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(jPanelLatkaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                .addComponent(jTextFieldLHt, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(jLabel45)
                                .addComponent(jTextFieldLTt, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(jLabel46)
                                .addComponent(jTextFieldLTnbv, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(jLabel32)
                                .addComponent(jTextFieldLCis, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addContainerGap(28, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanelLatkaLayout.createSequentialGroup()
                        .addComponent(jToggleButtonDocas, javax.swing.GroupLayout.PREFERRED_SIZE, 41, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(28, 28, 28))))
        );

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanelLatka, javax.swing.GroupLayout.PREFERRED_SIZE, 780, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addComponent(jScrollPane4, javax.swing.GroupLayout.PREFERRED_SIZE, 362, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel6, javax.swing.GroupLayout.PREFERRED_SIZE, 293, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabelInfoSloz, javax.swing.GroupLayout.PREFERRED_SIZE, 315, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(jPanel5Layout.createSequentialGroup()
                                .addGap(76, 76, 76)
                                .addComponent(jPanel9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(jLabel10)
                            .addComponent(jButton1)
                            .addComponent(jButtonSmazSloz)
                            .addComponent(jTextFieldNazSmesi, javax.swing.GroupLayout.PREFERRED_SIZE, 213, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap(263, Short.MAX_VALUE))
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addGap(20, 20, 20)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addComponent(jPanel9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabelInfoSloz, javax.swing.GroupLayout.PREFERRED_SIZE, 72, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel6, javax.swing.GroupLayout.PREFERRED_SIZE, 53, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jButtonSmazSloz)
                        .addGap(18, 18, 18)
                        .addComponent(jLabel10)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextFieldNazSmesi, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(15, 15, 15)
                        .addComponent(jButton1))
                    .addComponent(jScrollPane4, javax.swing.GroupLayout.PREFERRED_SIZE, 320, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addComponent(jPanelLatka, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(68, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("Složení", jPanel5);

        label1.setFont(new java.awt.Font("Dialog", 1, 12)); // NOI18N
        label1.setText("Nabídka vlastností");

        label2.setFont(new java.awt.Font("Dialog", 1, 12)); // NOI18N
        label2.setText("Vybrané vlastnosti");

        jLabel7.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
        jLabel7.setText("Vlastnost vybrat dvojklikem nebo vícenásobným výběrem myší se stiskem Ctrl a pak kliknutím na střední button s šipkou.");

        jLabel8.setText("(l)  kapalná fáze      (g)  plynná fáze      (rg)  reálný plyn");

        jButtonSmazat.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fydat/data/delete16.png"))); // NOI18N
        jButtonSmazat.setText("Smazat vybrané");
        jButtonSmazat.setIconTextGap(6);
        jButtonSmazat.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSmazatActionPerformed(evt);
            }
        });

        jPanel10.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createEtchedBorder(), " Tabelace podle "));

        jRadioButtonT.setSelected(true);
        jRadioButtonT.setText("teploty");
        jRadioButtonT.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonTActionPerformed(evt);
            }
        });

        jRadioButtonP.setText("tlaku");
        jRadioButtonP.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonPActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel10Layout = new javax.swing.GroupLayout(jPanel10);
        jPanel10.setLayout(jPanel10Layout);
        jPanel10Layout.setHorizontalGroup(
            jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel10Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jRadioButtonP)
                    .addComponent(jRadioButtonT))
                .addContainerGap(19, Short.MAX_VALUE))
        );
        jPanel10Layout.setVerticalGroup(
            jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel10Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jRadioButtonT)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jRadioButtonP)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jListVlast.setModel(new DefaultListModel());
        jListVlast.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jListVlastMouseClicked(evt);
            }
        });
        jScrollPane8.setViewportView(jListVlast);

        jButtonVlDo.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fydat/data/next24.png"))); // NOI18N
        jButtonVlDo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonVlDoActionPerformed(evt);
            }
        });

        jListVybrVl.setModel(new DefaultListModel());
        jScrollPane9.setViewportView(jListVybrVl);

        jButtonBack.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fydat/data/back24.png"))); // NOI18N
        jButtonBack.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonBackActionPerformed(evt);
            }
        });

        jPanel11.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jLabelPodleCeho.setText("Podle čeho?");

        jLabel11.setText("Počátek:");

        jTextFieldPoc.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextFieldPoc.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                jTextFieldPocFocusGained(evt);
            }
        });
        jTextFieldPoc.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jTextFieldPocKeyTyped(evt);
            }
        });

        jLabel12.setText("Konec:");

        jTextFieldKon.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextFieldKon.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                jTextFieldKonFocusGained(evt);
            }
        });
        jTextFieldKon.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jTextFieldKonKeyTyped(evt);
            }
        });

        jLabel13.setText("Krok:");

        jTextFieldKrok.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextFieldKrok.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                jTextFieldKrokFocusGained(evt);
            }
        });
        jTextFieldKrok.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jTextFieldKrokKeyTyped(evt);
            }
        });

        jLabelPri.setText("za konst.");
        jLabelPri.setVerticalAlignment(javax.swing.SwingConstants.TOP);

        jTextFieldPri.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextFieldPri.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                jTextFieldPriFocusGained(evt);
            }
        });
        jTextFieldPri.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jTextFieldPriKeyTyped(evt);
            }
        });

        javax.swing.GroupLayout jPanel11Layout = new javax.swing.GroupLayout(jPanel11);
        jPanel11.setLayout(jPanel11Layout);
        jPanel11Layout.setHorizontalGroup(
            jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel11Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabelPodleCeho)
                    .addGroup(jPanel11Layout.createSequentialGroup()
                        .addGroup(jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel11)
                            .addComponent(jLabel13)
                            .addComponent(jLabel12)
                            .addComponent(jLabelPri))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jTextFieldPri, javax.swing.GroupLayout.DEFAULT_SIZE, 72, Short.MAX_VALUE)
                            .addGroup(jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                .addComponent(jTextFieldKrok, javax.swing.GroupLayout.Alignment.LEADING)
                                .addComponent(jTextFieldKon, javax.swing.GroupLayout.Alignment.LEADING)
                                .addComponent(jTextFieldPoc, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 62, Short.MAX_VALUE)))))
                .addContainerGap(20, Short.MAX_VALUE))
        );
        jPanel11Layout.setVerticalGroup(
            jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel11Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabelPodleCeho)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel11)
                    .addComponent(jTextFieldPoc, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel12)
                    .addComponent(jTextFieldKon, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel13)
                    .addComponent(jTextFieldKrok, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jTextFieldPri, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabelPri, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jLabel14.setText("<html>Vložte počáteční a koncovou<br> hodnotu pro tabelaci a příslušný krok tabelace. Pozor na kritickou oblast!</html>");
        jLabel14.setVerticalTextPosition(javax.swing.SwingConstants.TOP);

        jCheckBoxPridSloz.setSelected(true);
        jCheckBoxPridSloz.setText("Přidat do výsl. okna i složení?");

        jButtonTabel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fydat/data/next24.png"))); // NOI18N
        jButtonTabel.setMnemonic('t');
        jButtonTabel.setText("Výpočet a tabelace");
        jButtonTabel.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        jButtonTabel.setIconTextGap(8);
        jButtonTabel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonTabelActionPerformed(evt);
            }
        });
        jButtonTabel.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jButtonTabelKeyTyped(evt);
            }
        });

        jPanel14.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jLabel18.setText("T1(°C):");

        jTextFieldT1.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel19.setText("T2(°C):");

        jTextFieldT2.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel20.setText("T3(°C):");

        jTextFieldT3.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        jLabel21.setText("P(MPa):");

        jTextFieldP.setHorizontalAlignment(javax.swing.JTextField.CENTER);

        javax.swing.GroupLayout jPanel14Layout = new javax.swing.GroupLayout(jPanel14);
        jPanel14.setLayout(jPanel14Layout);
        jPanel14Layout.setHorizontalGroup(
            jPanel14Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel14Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel14Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel14Layout.createSequentialGroup()
                        .addGroup(jPanel14Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel18)
                            .addComponent(jLabel20)
                            .addComponent(jLabel19))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel14Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jTextFieldT3)
                            .addComponent(jTextFieldT2)
                            .addComponent(jTextFieldT1, javax.swing.GroupLayout.PREFERRED_SIZE, 54, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addContainerGap(17, Short.MAX_VALUE))
                    .addGroup(jPanel14Layout.createSequentialGroup()
                        .addComponent(jLabel21)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextFieldP, javax.swing.GroupLayout.DEFAULT_SIZE, 54, Short.MAX_VALUE)
                        .addGap(15, 15, 15))))
        );
        jPanel14Layout.setVerticalGroup(
            jPanel14Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel14Layout.createSequentialGroup()
                .addGap(34, 34, 34)
                .addGroup(jPanel14Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel18)
                    .addComponent(jTextFieldT1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel14Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel19)
                    .addComponent(jTextFieldT2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel14Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel20)
                    .addComponent(jTextFieldT3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel14Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel21)
                    .addComponent(jTextFieldP, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(39, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout jPanel6Layout = new javax.swing.GroupLayout(jPanel6);
        jPanel6.setLayout(jPanel6Layout);
        jPanel6Layout.setHorizontalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel6Layout.createSequentialGroup()
                        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel8)
                            .addComponent(jLabel7, javax.swing.GroupLayout.PREFERRED_SIZE, 687, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabelPorov, javax.swing.GroupLayout.PREFERRED_SIZE, 580, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(333, 333, 333))
                    .addGroup(jPanel6Layout.createSequentialGroup()
                        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(label1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(jPanel6Layout.createSequentialGroup()
                                .addComponent(jScrollPane8, javax.swing.GroupLayout.PREFERRED_SIZE, 236, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jButtonVlDo)
                                    .addComponent(jButtonBack))))
                        .addGap(18, 18, 18)
                        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(label2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(jPanel6Layout.createSequentialGroup()
                                .addComponent(jScrollPane9, javax.swing.GroupLayout.PREFERRED_SIZE, 235, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18)
                                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(jPanel6Layout.createSequentialGroup()
                                        .addGap(9, 9, 9)
                                        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(jCheckBoxPridSloz)
                                            .addGroup(jPanel6Layout.createSequentialGroup()
                                                .addComponent(jPanel10, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                                .addGap(37, 37, 37)
                                                .addComponent(jButtonTabel, javax.swing.GroupLayout.PREFERRED_SIZE, 225, javax.swing.GroupLayout.PREFERRED_SIZE))
                                            .addComponent(jButtonSmazat, javax.swing.GroupLayout.PREFERRED_SIZE, 147, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                    .addGroup(jPanel6Layout.createSequentialGroup()
                                        .addComponent(jLabel14, javax.swing.GroupLayout.PREFERRED_SIZE, 122, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addGap(18, 18, 18)
                                        .addComponent(jPanel11, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                        .addComponent(jPanel14, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))))
                        .addGap(0, 40, Short.MAX_VALUE))))
        );
        jPanel6Layout.setVerticalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel6Layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(label1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(label2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jScrollPane9, javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(jPanel6Layout.createSequentialGroup()
                                .addComponent(jScrollPane8, javax.swing.GroupLayout.PREFERRED_SIZE, 514, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(0, 0, Short.MAX_VALUE))))
                    .addGroup(jPanel6Layout.createSequentialGroup()
                        .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel14, javax.swing.GroupLayout.PREFERRED_SIZE, 118, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jPanel14, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jPanel11, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jCheckBoxPridSloz)
                        .addGap(18, 18, 18)
                        .addComponent(jPanel10, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(27, 27, 27)
                        .addComponent(jButtonSmazat)
                        .addGap(145, 145, 145))
                    .addGroup(jPanel6Layout.createSequentialGroup()
                        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel6Layout.createSequentialGroup()
                                .addGap(207, 207, 207)
                                .addComponent(jButtonVlDo)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jButtonBack))
                            .addGroup(jPanel6Layout.createSequentialGroup()
                                .addGap(297, 297, 297)
                                .addComponent(jButtonTabel)))
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLabel7)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel8)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jLabelPorov, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(52, 52, 52))
        );

        jTabbedPane1.addTab("Výběr vlastností", jPanel6);

        jLabel16.setText("Výsledky tabelace:");

        jTextAreaTab.setColumns(20);
        jTextAreaTab.setFont(new Font("monospaced",Font.BOLD,12));
        jTextAreaTab.setRows(5);
        jScrollPane3.setViewportView(jTextAreaTab);

        javax.swing.GroupLayout jPanel8Layout = new javax.swing.GroupLayout(jPanel8);
        jPanel8.setLayout(jPanel8Layout);
        jPanel8Layout.setHorizontalGroup(
            jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel8Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel16, javax.swing.GroupLayout.PREFERRED_SIZE, 172, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 976, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(67, Short.MAX_VALUE))
        );
        jPanel8Layout.setVerticalGroup(
            jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel8Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel16)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 525, Short.MAX_VALUE)
                .addGap(49, 49, 49))
        );

        jTabbedPane1.addTab("Okno výsledků", jPanel8);

        jPanel12.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                jPanel12FocusGained(evt);
            }
        });

        jListGr.setModel(new DefaultListModel());
        jListGr.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jListGrMouseClicked(evt);
            }
        });
        jListGr.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jListGrKeyTyped(evt);
            }
        });
        jScrollPane6.setViewportView(jListGr);

        jLabel22.setText("Vyberte vlastnost pro graf a Enter:");

        jLabel24.setText("<html>Pokud není zobrazena nabídka vlastností, klikněte na tlačítku.</html>");

        jButtonNab.setText("Zobrazit nabídku pro graf");
        jButtonNab.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonNabActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel15Layout = new javax.swing.GroupLayout(jPanel15);
        jPanel15.setLayout(jPanel15Layout);
        jPanel15Layout.setHorizontalGroup(
            jPanel15Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jLabel24, javax.swing.GroupLayout.PREFERRED_SIZE, 197, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addComponent(jButtonNab)
        );
        jPanel15Layout.setVerticalGroup(
            jPanel15Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel15Layout.createSequentialGroup()
                .addComponent(jLabel24, javax.swing.GroupLayout.PREFERRED_SIZE, 32, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jButtonNab)
                .addContainerGap(27, Short.MAX_VALUE))
        );

        jCheckBoxOdNuly.setText("<html>Zobrazovat osu <i><b>y </b></i> absolutně, od nuly</html>");

        javax.swing.GroupLayout jPanel12Layout = new javax.swing.GroupLayout(jPanel12);
        jPanel12.setLayout(jPanel12Layout);
        jPanel12Layout.setHorizontalGroup(
            jPanel12Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel12Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel12Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane6, javax.swing.GroupLayout.PREFERRED_SIZE, 215, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(jPanel12Layout.createSequentialGroup()
                        .addGap(24, 24, 24)
                        .addComponent(jPanel15, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jLabel22))
                .addGap(18, 18, 18)
                .addGroup(jPanel12Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jCheckBoxOdNuly, javax.swing.GroupLayout.PREFERRED_SIZE, 250, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jTabbedPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 523, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabelNoGraf, javax.swing.GroupLayout.PREFERRED_SIZE, 296, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel12Layout.setVerticalGroup(
            jPanel12Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel12Layout.createSequentialGroup()
                .addGap(20, 20, 20)
                .addGroup(jPanel12Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel12Layout.createSequentialGroup()
                        .addComponent(jTabbedPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 441, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 18, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(jCheckBoxOdNuly, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 108, Short.MAX_VALUE))
                    .addGroup(jPanel12Layout.createSequentialGroup()
                        .addGroup(jPanel12Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel12Layout.createSequentialGroup()
                                .addComponent(jPanel15, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel22)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jScrollPane6, javax.swing.GroupLayout.PREFERRED_SIZE, 179, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(jLabelNoGraf))
                        .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
        );

        jTabbedPane1.addTab("Grafy", jPanel12);

        jList4.setFont(new Font("monospaced",Font.BOLD,14));
        jList4.setModel(new DefaultListModel());
        jList4.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jList4MouseClicked(evt);
            }
        });
        jList4.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jList4KeyTyped(evt);
            }
        });
        jScrollPane7.setViewportView(jList4);

        jLabel23.setText("Seznam látek v bázi nebo ve výběru:");

        jLabel25.setText("<html><p>Stisk jednoho písmene<br>(při setřídění látek podle abecedy) nastaví na látky od tohoto písmene. Seznam ovšem musí mít fokus.</p><p><br> Dvojklikem na látce zjistíte, zda má v důsledku deficitu dat použitu náhradní vlastnost od podobné látky.</p></html>");
        jLabel25.setVerticalAlignment(javax.swing.SwingConstants.TOP);

        jCheckBox1.setText("Seznam látek podle čísel");
        jCheckBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox1ActionPerformed(evt);
            }
        });

        jLabelSoubor.setText("Data ze souboru:");

        javax.swing.GroupLayout jPanelVyberLayout = new javax.swing.GroupLayout(jPanelVyber);
        jPanelVyber.setLayout(jPanelVyberLayout);
        jPanelVyberLayout.setHorizontalGroup(
            jPanelVyberLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelVyberLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelVyberLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabelSoubor, javax.swing.GroupLayout.PREFERRED_SIZE, 467, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(jPanelVyberLayout.createSequentialGroup()
                        .addGroup(jPanelVyberLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addGroup(jPanelVyberLayout.createSequentialGroup()
                                .addComponent(jLabel23, javax.swing.GroupLayout.PREFERRED_SIZE, 375, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(jLabelVyber1, javax.swing.GroupLayout.PREFERRED_SIZE, 254, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(jScrollPane7, javax.swing.GroupLayout.PREFERRED_SIZE, 697, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(28, 28, 28)
                        .addGroup(jPanelVyberLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jCheckBox1, javax.swing.GroupLayout.PREFERRED_SIZE, 199, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel25, javax.swing.GroupLayout.PREFERRED_SIZE, 140, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addGap(0, 119, Short.MAX_VALUE))
        );
        jPanelVyberLayout.setVerticalGroup(
            jPanelVyberLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelVyberLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelVyberLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabelVyber1, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel23))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanelVyberLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanelVyberLayout.createSequentialGroup()
                        .addComponent(jLabel25, javax.swing.GroupLayout.PREFERRED_SIZE, 233, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jCheckBox1)
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addComponent(jScrollPane7, javax.swing.GroupLayout.DEFAULT_SIZE, 517, Short.MAX_VALUE))
                .addGap(18, 18, 18)
                .addComponent(jLabelSoubor)
                .addGap(25, 25, 25))
        );

        jTabbedPane1.addTab("Seznam", jPanelVyber);

        jPanelFlash.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jLabel9.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jLabel9.setText("Výpočet ideálního flash");

        jLabelFbv.setText("Bod varu směsi (°C):");

        jLabelFrb.setText("Rosný bod směsi:");

        buttonGroupFlash.add(jRadioButtonAd);
        jRadioButtonAd.setSelected(true);
        jRadioButtonAd.setText("Adiabatický flash");

        buttonGroupFlash.add(jRadioButtonIzo);
        jRadioButtonIzo.setText("Izotermní flash");

        jLabel28.setText("Počáteční tlak (Pa):");

        jTextFieldFPpoc.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jTextFieldFPpoc.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextFieldFPpoc.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                jTextFieldFPpocKeyPressed(evt);
            }
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jTextFieldFPpocKeyTyped(evt);
            }
        });

        jLabel29.setText("Koncový tlak (Pa):");

        jTextFieldFPkon.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jTextFieldFPkon.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextFieldFPkon.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextFieldFPkonActionPerformed(evt);
            }
        });
        jTextFieldFPkon.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jTextFieldFPkonKeyTyped(evt);
            }
        });

        jTextFieldFTpoc.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jTextFieldFTpoc.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextFieldFTpoc.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jTextFieldFTpocKeyTyped(evt);
            }
        });

        jLabel30.setText("Počáteční teplota (°C):");

        jButtonFlash.setText("K výpočtu");
        jButtonFlash.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonFlashActionPerformed(evt);
            }
        });
        jButtonFlash.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jButtonFlashKeyTyped(evt);
            }
        });

        jLabel4.setText("<html><i>Zadávat data má smysl jen tehdy, pokud jste se<br> na tuto záložku dostali pouze volbou příslušné výpočetní činnosti!</i></html>");

        javax.swing.GroupLayout jPanelFlashLayout = new javax.swing.GroupLayout(jPanelFlash);
        jPanelFlash.setLayout(jPanelFlashLayout);
        jPanelFlashLayout.setHorizontalGroup(
            jPanelFlashLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelFlashLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelFlashLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanelFlashLayout.createSequentialGroup()
                        .addComponent(jLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, 279, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap())
                    .addGroup(jPanelFlashLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(jPanelFlashLayout.createSequentialGroup()
                            .addGroup(jPanelFlashLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                .addGroup(jPanelFlashLayout.createSequentialGroup()
                                    .addComponent(jRadioButtonAd)
                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 42, Short.MAX_VALUE)
                                    .addComponent(jRadioButtonIzo))
                                .addGroup(jPanelFlashLayout.createSequentialGroup()
                                    .addGroup(jPanelFlashLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addComponent(jLabel29)
                                        .addComponent(jLabel28))
                                    .addGap(38, 38, 38)
                                    .addGroup(jPanelFlashLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                        .addComponent(jTextFieldFPkon)
                                        .addComponent(jTextFieldFPpoc, javax.swing.GroupLayout.PREFERRED_SIZE, 63, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addComponent(jTextFieldFTpoc, javax.swing.GroupLayout.PREFERRED_SIZE, 59, javax.swing.GroupLayout.PREFERRED_SIZE))))
                            .addContainerGap(85, Short.MAX_VALUE))
                        .addGroup(jPanelFlashLayout.createSequentialGroup()
                            .addGroup(jPanelFlashLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                .addComponent(jLabel30)
                                .addGroup(jPanelFlashLayout.createSequentialGroup()
                                    .addComponent(jLabelFbv)
                                    .addGap(67, 67, 67)
                                    .addComponent(jLabelFrb))
                                .addComponent(jLabel9)
                                .addComponent(jButtonFlash))
                            .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))))
        );
        jPanelFlashLayout.setVerticalGroup(
            jPanelFlashLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelFlashLayout.createSequentialGroup()
                .addGap(22, 22, 22)
                .addComponent(jLabel9)
                .addGap(32, 32, 32)
                .addGroup(jPanelFlashLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jRadioButtonAd)
                    .addComponent(jRadioButtonIzo))
                .addGap(18, 18, 18)
                .addGroup(jPanelFlashLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanelFlashLayout.createSequentialGroup()
                        .addComponent(jTextFieldFPpoc, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextFieldFPkon, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanelFlashLayout.createSequentialGroup()
                        .addComponent(jLabel28)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabel29)))
                .addGap(21, 21, 21)
                .addGroup(jPanelFlashLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabelFbv)
                    .addComponent(jLabelFrb))
                .addGap(18, 18, 18)
                .addGroup(jPanelFlashLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel30)
                    .addComponent(jTextFieldFTpoc, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(36, 36, 36)
                .addComponent(jButtonFlash)
                .addGap(34, 34, 34)
                .addComponent(jLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, 47, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(79, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout jPanel13Layout = new javax.swing.GroupLayout(jPanel13);
        jPanel13.setLayout(jPanel13Layout);
        jPanel13Layout.setHorizontalGroup(
            jPanel13Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel13Layout.createSequentialGroup()
                .addGap(18, 18, 18)
                .addComponent(jPanelFlash, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(690, Short.MAX_VALUE))
        );
        jPanel13Layout.setVerticalGroup(
            jPanel13Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel13Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanelFlash, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(147, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("Výpočty", jPanel13);

        menuBar.setMaximumSize(new java.awt.Dimension(113, 1200));

        fileMenu.setText("File");

        saveMenuItem.setText("Save");
        saveMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveMenuItemActionPerformed(evt);
            }
        });
        fileMenu.add(saveMenuItem);

        exitMenuItem.setText("Exit");
        exitMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitMenuItemActionPerformed(evt);
            }
        });
        fileMenu.add(exitMenuItem);

        menuBar.add(fileMenu);

        actMenu.setText("Činnosti");

        tabelMenuItem.setText("Tabelace vlastností podle teploty a tlaku");
        tabelMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tabelMenuItemActionPerformed(evt);
            }
        });
        actMenu.add(tabelMenuItem);

        porovMenuItem.setText("Porovnání vlastnosti u více látek");
        porovMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                porovMenuItemActionPerformed(evt);
            }
        });
        actMenu.add(porovMenuItem);

        seznMenuItem.setText("Seznam látek v databázi");
        seznMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                seznMenuItemActionPerformed(evt);
            }
        });
        actMenu.add(seznMenuItem);

        grafMenuItem.setText("Grafické zobrazení");
        grafMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                grafMenuItemActionPerformed(evt);
            }
        });
        actMenu.add(grafMenuItem);

        vyhledMenuItem.setText("Vyhledání látky podle části názvu");
        vyhledMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                vyhledMenuItemActionPerformed(evt);
            }
        });
        actMenu.add(vyhledMenuItem);

        vysledMenuItem.setText("Zobrazit výsledkové okno");
        vysledMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                vysledMenuItemActionPerformed(evt);
            }
        });
        actMenu.add(vysledMenuItem);

        smazMenuItem.setText("Smazat výsledkové okno");
        smazMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                smazMenuItemActionPerformed(evt);
            }
        });
        actMenu.add(smazMenuItem);

        vlastMenuItem.setText("Seřazení látek podle hodnoty vlastnosti");
        vlastMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                vlastMenuItemActionPerformed(evt);
            }
        });
        actMenu.add(vlastMenuItem);

        jMenuItemFlash.setText("Flash výpočet (ideální)");
        jMenuItemFlash.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemFlashActionPerformed(evt);
            }
        });
        actMenu.add(jMenuItemFlash);

        jMenuItemKompr.setText("Komprese/škrcení");
        jMenuItemKompr.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemKomprActionPerformed(evt);
            }
        });
        actMenu.add(jMenuItemKompr);

        jMenuItem1.setText("Zobraz nápovědu návodu");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        actMenu.add(jMenuItem1);
        actMenu.add(jSeparator1);

        konecMenuItem.setText("Konec činnosti programu");
        konecMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                konecMenuItemActionPerformed(evt);
            }
        });
        actMenu.add(konecMenuItem);

        menuBar.add(actMenu);

        helpMenu.setText("Help");

        contentsMenuItem.setText("Contents");
        helpMenu.add(contentsMenuItem);

        aboutMenuItem.setText("About");
        aboutMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aboutMenuItemActionPerformed(evt);
            }
        });
        helpMenu.add(aboutMenuItem);

        menuBar.add(helpMenu);

        setJMenuBar(menuBar);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 1058, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 638, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 18, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void exitMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitMenuItemActionPerformed
        System.exit(0);
    }//GEN-LAST:event_exitMenuItemActionPerformed

    private void jList1KeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jList1KeyTyped
        // výběr látky Enterem nebo nastavení na písmeno
        String s;
        int k;
        int[] iSel;
        if (evt.getKeyChar() == KeyEvent.VK_ENTER) {
            iSel = jList1.getSelectedIndices();
            for (int i=0; i<iSel.length; i++) {
//                s = (String) jList1.getSelectedValue();
                s = (String) jList1.getModel().getElementAt(iSel[i]);
                k = Integer.valueOf(s.substring(0, 3).trim()); // první znaky č. látky
                jCisla[jVyber] = k;
                jVyber++;
                ((DefaultListModel) jListVybrano.getModel()).addElement(s.substring(0, 33));
            }
        }
        if (evt.getKeyChar() >= 'A' && evt.getKeyChar() <= 'z') {  // nastaví list na stisk písmene
//            System.out.println("bylo písmeno " +evt.getKeyChar());
            for (k = 0; k < jList1.getModel().getSize(); k++) {
                s = (String) ((DefaultListModel) jList1.getModel()).getElementAt(k);
                s = s.toLowerCase();
                if (evt.getKeyChar() <= s.charAt(4)) {
                    jList1.ensureIndexIsVisible(530);    // aby nejprve zajel na konec
                    jList1.ensureIndexIsVisible(k);
                    break;
                }
            }
        }
    }//GEN-LAST:event_jList1KeyTyped

    private void jList1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jList1MouseClicked
        // výběr látky myší
        String s;
        int k;
        if (evt.getClickCount() == 2) {
            s = (String) jList1.getSelectedValue();
            k = Integer.valueOf(s.substring(0, 3).trim()); // první znaky č. látky
            jCisla[jVyber] = k;
//            System.out.println("mCislo: " + jVyber + " " + jCisla[jVyber]);
            jVyber++;
            ((DefaultListModel) jListVybrano.getModel()).addElement(s.substring(0, 33));
        }
    }//GEN-LAST:event_jList1MouseClicked

    private void jButtonVybranoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonVybranoActionPerformed
        // Ukončen výběr směsi
        int i;
        if (cinnost == 0 || cinnost == 8 || cinnost == 9) {  // tabelace
            try {
                sm = new Smes(jVyber, jCisla);
            } catch (JDOMException e) {
                e.printStackTrace();                
            } catch (IOException e) {
                e.printStackTrace();
            }
            jTabbedPane1.setSelectedIndex(2);
            //  Zrušení předchozí tabulky
            smesModel.removeAllSlozka();
//            jTableSmes.repaint();
            for (i = 0; i < jVyber; i++) {
                smesModel.addSlozka(new Slozka(jCisla[i],
                        sm.getSlozka(i).getNazev(), ""));
            }
            if (jTableSmes.getRowCount() > 0) {
                jTableSmes.getSelectionModel().setSelectionInterval(0, 0);
                jTableSmes.getColumnModel().getSelectionModel().setSelectionInterval(2, 2);
                jTableSmes.requestFocus();
            }
        }
        if (cinnost == 1) {  // porovnání
            //  Zrušení předchozí tabulky
            smesModel.removeAllSlozka();
//            jTableSmes.repaint();
            int[] pom = new int[1];
            double[] pomd = new double[1];
            pomd[0] = 1.0;
            smPor = new Smes[jVyber];
            for (i = 0; i < jVyber; i++) {
                pom[0] = jCisla[i];
                try {
                    smPor[i] = new Smes(1, pom);
                    smPor[i].zadatSloz(true, pomd);
                } catch (JDOMException e) {
                    e.printStackTrace();                     
                } catch (IOException e) {
                    e.printStackTrace();
                }
//                listCisla.add(String.format("% 3d", jCisla[i]));
//                listNazvy.add(smPor[i].getSlozka(0).getNazev());  // ***************************
                smesModel.addSlozka(new Slozka(jCisla[i],
                        smPor[i].getSlozka(0).getNazev(), "1"));
            }
//            listSlozeni.removeAll();
            x = new double[jVyber];
            for (i = 0; i < jVyber; i++) {
                x[i] = 1.0;
//                listSlozeni.add("1.0");
            }
            jTabbedPane1.setSelectedIndex(2);
        }

    }//GEN-LAST:event_jButtonVybranoActionPerformed

    private void jRadioButtonMolActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonMolActionPerformed
        // molární složení
        jRadioButtonHmot.setSelected(false);
    }//GEN-LAST:event_jRadioButtonMolActionPerformed

    private void jRadioButtonHmotActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonHmotActionPerformed
        // hmotové složení
        jRadioButtonMol.setSelected(false);
    }//GEN-LAST:event_jRadioButtonHmotActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        // Přechod na výběr vlastností:
        int i;
        boolean isSlozeni = true;
//        if (listSlozeni.getItemCount() > 0 && listSlozeni.getItemCount() >= jVyber) {  // bylo zadáno složení
        for (i = 0; i < smesModel.getRowCount(); i++) {
            if (smesModel.getValueAt(i, 2).equals("")) {
                isSlozeni = false;
            }
        }
        if (isSlozeni) {  // bylo zadáno složení
            vlastnostiNaVyber();
            zmenaSloz = true;
        } else {
            JOptionPane.showMessageDialog(this,
                    "Je třeba nejdříve zadat složení!\nA to pro všechny složky.",
                    "Zadej složení", JOptionPane.WARNING_MESSAGE);
        }
        if (cinnost == 8 || cinnost == 9) {
            jTabbedPane1.setSelectedIndex(7);
            jTextFieldFPpoc.requestFocus();
            return;
        }
        if (cinnost == 1) {
            jLabelPorov.setText("<html>Porovnání - vyberte jen<br< JEDNU vlastnost!</html>");
        } else {
            jLabelPorov.setText("");
        }
        jPanel11.setVisible(false);
        jPanel14.setVisible(false);
        jLabel14.setVisible(false);        
    }//GEN-LAST:event_jButton1ActionPerformed

    private void formWindowOpened(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowOpened
        // Zobrazení titulku hl. okna:
        this.setTitle(" F Y D A T   Databáze fyzikálních vlastností     "
                + OWNER + "    " +  VERZE + "  (Java)");
    }//GEN-LAST:event_formWindowOpened

    private void jButtonSmazatActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSmazatActionPerformed
        // Smazat dosud vybrané vlastnosti:
        ((DefaultListModel) jListVybrVl.getModel()).removeAllElements();
        nVybrVla = 0;
        ((DefaultListModel) jListGr.getModel()).removeAllElements();  // maže vl. pro graf
    }//GEN-LAST:event_jButtonSmazatActionPerformed

    private void jRadioButtonPActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonPActionPerformed
        // Zvolena tabelace podle tlaku:
        jRadioButtonT.setSelected(false);
        tabDleTepl = false;
        rozsahTabelace();
    }//GEN-LAST:event_jRadioButtonPActionPerformed

    private void jRadioButtonTActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonTActionPerformed
        // Zvolena tabelace podle teploty:
        jRadioButtonP.setSelected(false);
        tabDleTepl = true;
        rozsahTabelace();
    }//GEN-LAST:event_jRadioButtonTActionPerformed

    private void jButtonTabelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonTabelActionPerformed
        // Výpočet a tabelace:
        if (cinnost == 0) {
            pripravTabelaci();
            tabelace += tabelace();          // vlastní tabelace
            jPanel15.setVisible(true);
        }
        if (cinnost == 1) {                 // porovnání vlastností
            tabelace += porovnani();
        }
        if (cinnost == 7) {                 // podle hodnoty vlastností
            rozsahTabelace();
            return;
        }
        jTextAreaTab.setText(tabelace);
//        jTextAreaTab.append(tabelace);
        jTabbedPane1.setSelectedIndex(4);

    }//GEN-LAST:event_jButtonTabelActionPerformed

    private void jButton1KeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jButton1KeyTyped
        // Stisk Enter "Na výběr vlastností":
        if (evt.getKeyChar() == KeyEvent.VK_ENTER) {
            int i;
            boolean isSlozeni = true;
            if (cinnost == 8 || cinnost == 9) {
                jTabbedPane1.setSelectedIndex(7);
                jTextFieldFPpoc.requestFocus();
                return;
            }
            for (i = 0; i < smesModel.getRowCount(); i++) {
                if (smesModel.getValueAt(i, 2).equals("")) {
                    isSlozeni = false;
                }
            }
            if (isSlozeni) {  // bylo zadáno složení
                vlastnostiNaVyber();
            } else {
                JOptionPane.showMessageDialog(this,
                        "Je třeba nejdříve zadat složení!\nA to pro všechny složky.",
                        "Zadej složení", JOptionPane.WARNING_MESSAGE);
            }
        }
    }//GEN-LAST:event_jButton1KeyTyped

    private void jTextFieldCislemKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextFieldCislemKeyTyped
        // Enter za složkou směsi číslem
        int i;
        String s = "";
        if (evt.getKeyChar() == KeyEvent.VK_ENTER) {
            if (jTextFieldCislem.getText().equals("")) {
//                    JOptionPane.showMessageDialog(this,
//                            "Nemůžete zadat 'prázdné' číslo látky !",
//                            "Zadej složky směsi", JOptionPane.WARNING_MESSAGE);
                return;
            }
            try {
                i = Integer.parseInt(jTextFieldCislem.getText());   // číslo zadané látky
                s = String.format("%3d ", i)
                        + ((Latka.getLatka(i) == null) ? "mimo rozsah" : Latka.getLatka(i).getNazev());
                if (s.indexOf("mimo rozsah") > 0 || i > 700) {
                    JOptionPane.showMessageDialog(this,
                            "Látka číslo " + i + " není v databázi\n" +
                             "nebo číslo látky musí být kladné a maximálně 700 !",
                            "Zadej složky směsi", JOptionPane.WARNING_MESSAGE);
                    jTextFieldCislem.setText("");
                    return;
                }
                if (Latka.getLatka(i).getNazev().equals("")) {
                    JOptionPane.showMessageDialog(this,
                            "Látka s tímto číslem (" + i + ") neexistuje !",
                            "Zadej složky směsi", JOptionPane.WARNING_MESSAGE);
                    jTextFieldCislem.setText("");
                    return;
                } else {
                    ((DefaultListModel) jListVybrano.getModel()).addElement(s);
                    jCisla[jVyber] = i;
                    jVyber++;
                }
            } catch (NumberFormatException e) {
                JOptionPane.showMessageDialog(this,
                        "Číslo " + e.getMessage() + " nebylo zadáno správně! !",
                        "Zadej látku číslem", JOptionPane.WARNING_MESSAGE);
                // e.printStackTrace();
            }
            jTextFieldCislem.setText("");
        }
    }//GEN-LAST:event_jTextFieldCislemKeyTyped

    private void jButtonSmazActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSmazActionPerformed
        // Smaže dosud vybrané látky:
//        jListVybrano.removeAll(); // nefunguje !
        ((DefaultListModel) jListVybrano.getModel()).removeAllElements();
        jVyber = 0;
        jCisla = new int[50];
    }//GEN-LAST:event_jButtonSmazActionPerformed

    private void aboutMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aboutMenuItemActionPerformed
        // Menu položka "About":
        JOptionPane.showMessageDialog(this,
                "F Y D A T  Databáze fyzikálních vlastností\n"
                + "organických látek a technických plynů.\n"
                + "a jejich směsí\n"
                + "(c) Ing. Vratislav Hlubuček,CSc. 2010, 2014", "FYDAT", JOptionPane.INFORMATION_MESSAGE);

    }//GEN-LAST:event_aboutMenuItemActionPerformed

    private void jButtonSmazSlozActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSmazSlozActionPerformed
        // Smazat celé zadané složení:
//        listSlozeni.removeAll();
        int i;
        for (i = 0; i < jVyber; i++) {
            jTableSmes.setValueAt("", i, 2);
        }
        jTableSmes.repaint();
    }//GEN-LAST:event_jButtonSmazSlozActionPerformed

    private void jTextFieldPocKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextFieldPocKeyTyped
        // předat fokus na další:
        if (evt.getKeyChar() == KeyEvent.VK_ENTER) {
            jTextFieldKon.requestFocus();
        }
    }//GEN-LAST:event_jTextFieldPocKeyTyped

    private void jTextFieldKonKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextFieldKonKeyTyped
        // předat fokus na další:
        if (evt.getKeyChar() == KeyEvent.VK_ENTER) {
            jTextFieldKrok.requestFocus();
        }
    }//GEN-LAST:event_jTextFieldKonKeyTyped

    private void jTextFieldKrokKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextFieldKrokKeyTyped
        // předat fokus na další:
        if (evt.getKeyChar() == KeyEvent.VK_ENTER) {
            jTextFieldPri.requestFocus();
        }
    }//GEN-LAST:event_jTextFieldKrokKeyTyped

    private void jTextFieldPriKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextFieldPriKeyTyped
        // předat fokus na další:
        if (evt.getKeyChar() == KeyEvent.VK_ENTER) {
            jButtonTabel.requestFocus();
        }
    }//GEN-LAST:event_jTextFieldPriKeyTyped

    private void jButtonTabelKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jButtonTabelKeyTyped
        // Stisk Enter "Na výběr vlastností":
        if (evt.getKeyChar() == KeyEvent.VK_ENTER) {
            pripravTabelaci();
            tabelace += tabelace();
            jPanel15.setVisible(true);
            jTextAreaTab.setText(tabelace);
//            jTextAreaTab.append(tabelace);
            jTabbedPane1.setSelectedIndex(6);
        }
    }//GEN-LAST:event_jButtonTabelKeyTyped

    private void jButtonKonecActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonKonecActionPerformed
        // Ukončit program
        System.exit(0);
    }//GEN-LAST:event_jButtonKonecActionPerformed

    private void jTextFieldPocFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jTextFieldPocFocusGained
        // Nasvítí stávající obsah
        jTextFieldPoc.selectAll();
    }//GEN-LAST:event_jTextFieldPocFocusGained

    private void jTextFieldKonFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jTextFieldKonFocusGained
        // Nasvítí stávající obsah
        jTextFieldKon.selectAll();
    }//GEN-LAST:event_jTextFieldKonFocusGained

    private void jTextFieldKrokFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jTextFieldKrokFocusGained
        // Nasvítí stávající obsah
        jTextFieldKrok.selectAll();
    }//GEN-LAST:event_jTextFieldKrokFocusGained

    private void jTextFieldPriFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jTextFieldPriFocusGained
        // Nasvítí stávající obsah
        jTextFieldPri.selectAll();
    }//GEN-LAST:event_jTextFieldPriFocusGained

    private void tabelMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tabelMenuItemActionPerformed
        // Vybrána tabelace
        jTabbedPane1.setSelectedIndex(1);
//        jListVybrano.removeAll(); // tady nefungovalo!
        ((DefaultListModel) jListVybrano.getModel()).removeAllElements();
        jList1.requestFocus();
        cinnost = 0;
    }//GEN-LAST:event_tabelMenuItemActionPerformed

    private void konecMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_konecMenuItemActionPerformed
        System.exit(0);
    }//GEN-LAST:event_konecMenuItemActionPerformed

    private void vysledMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_vysledMenuItemActionPerformed
        // Zobraz okno výsledků
        cinnost = 5;
        jTabbedPane1.setSelectedIndex(4);
    }//GEN-LAST:event_vysledMenuItemActionPerformed

    private void seznMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_seznMenuItemActionPerformed
        // Seznam látek:
        try {
            naplnSeznam2(true);
        } catch (JDOMException e) {
            System.out.println("Chyba xml při načítání souboru látek!");                
        } catch (IOException e) {
            System.out.println("Chyba při načítání souboru látek!");
        }
        cinnost = 2;
        jTabbedPane1.setSelectedIndex(6);
    }//GEN-LAST:event_seznMenuItemActionPerformed

    private void vyhledMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_vyhledMenuItemActionPerformed
        // Vyhledání láttek podle části názvu
        try {
            najdiPodleNazvu();
        } catch (JDOMException e) {
            System.out.println("Chyba xml při načítání souboru látek!");             
        } catch (IOException e) {
            System.out.println("Chyba při načítání souboru látek!");
        }
        cinnost = 4;
        jTabbedPane1.setSelectedIndex(6);
    }//GEN-LAST:event_vyhledMenuItemActionPerformed

    private void smazMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_smazMenuItemActionPerformed
        // Smazat výsledkové okno
        int i = JOptionPane.showConfirmDialog(null, "Opravdu chcete smazat výsledkové okno?", "FYDAT činnosti", JOptionPane.YES_NO_OPTION, WIDTH, null);
        if (i == JOptionPane.YES_OPTION) {
            jTextAreaTab.setText("");
        }
        cinnost = 6;
    }//GEN-LAST:event_smazMenuItemActionPerformed

    private void grafMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_grafMenuItemActionPerformed
        // Grafické zobrazení
        pregraf();
        cinnost = 3;
    }//GEN-LAST:event_grafMenuItemActionPerformed

    private void porovMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_porovMenuItemActionPerformed
        // Porovnání vlastnosti více látek
        volbaCinnosti(1);
        cinnost = 1;
    }//GEN-LAST:event_porovMenuItemActionPerformed

    private void vlastMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_vlastMenuItemActionPerformed
        // Hledání látek podle hodnoty vlastnosti
        cinnost = 7;
        jTabbedPane1.setSelectedIndex(4);
        vlastnostiNaVyber();
    }//GEN-LAST:event_vlastMenuItemActionPerformed

    private void jList3KeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jList3KeyTyped
        // Vybrat činnost:
        if (evt.getKeyChar() == KeyEvent.VK_ENTER) {
            zvolenaCinnost = jList3.getSelectedIndex();
            volbaCinnosti(zvolenaCinnost);
//            System.out.println("Kzvoleno: " + zvolenaCinnost);
        }
    }//GEN-LAST:event_jList3KeyTyped

    private void jList3MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jList3MouseClicked
        // Vybrat činnost myší:
        if (evt.getClickCount() == 2) {
            zvolenaCinnost = jList3.getSelectedIndex();
            volbaCinnosti(zvolenaCinnost);
//            jVyber = 0;
        }
    }//GEN-LAST:event_jList3MouseClicked

    private void jListGrKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jListGrKeyTyped
        // Vyber vlastnosti pro graf Enterem
        if (evt.getKeyChar() == KeyEvent.VK_ENTER) {
            VlaGraf = (String) jListGr.getSelectedValue();
            iGraf = jListGr.getSelectedIndex();
            jListGr.setSelectedIndex(iGraf + 1);
            jListGr.requestFocus();
            jTabbedPane2.removeAll();
            graf();
        }
    }//GEN-LAST:event_jListGrKeyTyped

    private void jButtonNabActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonNabActionPerformed
        // Tlačítko zpřístupnění nabídek pro graf
        pregraf();
        jListGr.requestFocus();
    }//GEN-LAST:event_jButtonNabActionPerformed

    private void jListGrMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jListGrMouseClicked
        // Zobrazení grafu dvojklikem
        if (evt.getClickCount() == 2) {
            VlaGraf = (String) jListGr.getSelectedValue();
            iGraf = jListGr.getSelectedIndex();
            jListGr.setSelectedIndex(iGraf + 1);
            jListGr.requestFocus();
            jTabbedPane2.removeAll();
            graf();
        }
    }//GEN-LAST:event_jListGrMouseClicked

    private void jList4KeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jList4KeyTyped
        // Listování "písmeny" v seznamu
        int k;
        String s;
        if (cinnost == 7) {
            return;
        }
        if (evt.getKeyChar() >= 'A' && evt.getKeyChar() <= 'z') {  // nastaví list na stisk písmene
//            System.out.println("bylo písmeno " +evt.getKeyChar());
            for (k = 0; k < jList4.getModel().getSize(); k++) {
                s = (String) ((DefaultListModel) jList4.getModel()).getElementAt(k);
                s = s.toLowerCase();
                if (evt.getKeyChar() <= s.charAt(4)) {
                    jList4.ensureIndexIsVisible(530);    // aby nejprve zajel na konec
                    jList4.ensureIndexIsVisible(k);
                    break;
                }
            }
        }

    }//GEN-LAST:event_jList4KeyTyped

    private void jList4MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jList4MouseClicked
        // Prověření látky dvojklikem
        String s;
        int k;
        if (evt.getClickCount() == 2 && cinnost != 8) {
            s = (String) jList4.getSelectedValue();
            k = Integer.valueOf(s.substring(0, 3).trim()); // první znaky č. látky
            proverLatku(k);
        }

    }//GEN-LAST:event_jList4MouseClicked

    private void jButtonFlashActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonFlashActionPerformed
        // Spustit Flash mysší
        if (jRadioButtonAd.isSelected()) {
            adiabFlash = true;
        } else {
            adiabFlash = false;
        }
        if (cinnost == 8) {
            tabelace += flash();
        }
        if (cinnost == 9) {
            tabelace += komprese();
        }
        jTextAreaTab.setText(tabelace);
        jTabbedPane1.setSelectedIndex(4);
    }//GEN-LAST:event_jButtonFlashActionPerformed

    private void jTextFieldFPkonKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextFieldFPkonKeyTyped
        // Zadání koncového tlaku
        double pFpoc;
        if (evt.getKeyChar() == KeyEvent.VK_ENTER) {
            if (jRadioButtonAd.isSelected()) {
                p = Double.parseDouble((jTextFieldFPpoc.getText()).replace(',', '.'));  // pro českou notaci
            } else {
                p = Double.parseDouble((jTextFieldFPkon.getText()).replace(',', '.'));  // pro českou notaci
            }
            zalozeniSmesi();
//            jTabbedPane1.setSelectedIndex(7);
            jLabelFbv.setText("Bod varu  (°C): " + String.format("%-6.1f", (sm.sTbv(p) - TABS)));
            jLabelFrb.setText("Rosný bod (°C): " + String.format("%-6.1f", (sm.sTrb(p) - TABS)));
            jTextFieldFTpoc.requestFocus();
        }
    }//GEN-LAST:event_jTextFieldFPkonKeyTyped

    private void jTextFieldFPpocKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextFieldFPpocKeyTyped
        // Předat fokus dál
        if (evt.getKeyChar() == KeyEvent.VK_ENTER) {
            jTextFieldFPkon.requestFocus();
        }
    }//GEN-LAST:event_jTextFieldFPpocKeyTyped

    private void jTextFieldFTpocKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextFieldFTpocKeyTyped
        // Předat fokus dál
        if (evt.getKeyChar() == KeyEvent.VK_ENTER) {
            jButtonFlash.requestFocus();
        }
    }//GEN-LAST:event_jTextFieldFTpocKeyTyped

    private void jMenuItemFlashActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemFlashActionPerformed
        // Flash
        volbaCinnosti(8);
        cinnost = 8;
    }//GEN-LAST:event_jMenuItemFlashActionPerformed

    private void jButtonFlashKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jButtonFlashKeyTyped
        // Spustit Flash Enterem
        if (evt.getKeyChar() == KeyEvent.VK_ENTER) {
            if (jRadioButtonAd.isSelected()) {
                adiabFlash = true;
            } else {
                adiabFlash = false;
            }
            if (cinnost == 8) {
                tabelace += flash();
            }
            if (cinnost == 9) {
                tabelace += komprese();
            }
            jTextAreaTab.setText(tabelace);
            jTabbedPane1.setSelectedIndex(4);
        }
    }//GEN-LAST:event_jButtonFlashKeyTyped

    private void jMenuItemKomprActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemKomprActionPerformed
        // Komprese/škrcení
        volbaCinnosti(9);
        cinnost = 9;
    }//GEN-LAST:event_jMenuItemKomprActionPerformed

    private void jTextFieldLAcActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextFieldLAcActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jTextFieldLAcActionPerformed

    private void jToggleButtonDocasActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButtonDocasActionPerformed
        // Dočasná změna názvu složky
        docasnaZmenaNazvu();

    }//GEN-LAST:event_jToggleButtonDocasActionPerformed

    private void jPanel12FocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jPanel12FocusGained
        // Upozornění na nemožnost grafu:
        if (cinnost == 1) {
            jLabelNoGraf.setText("Pro tuto činnost neexistuje graf! ");
        }
    }//GEN-LAST:event_jPanel12FocusGained

    private void jListVlastMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jListVlastMouseClicked
        // přidání vybrané vlastnosti dvoj-kliokem myši do Vybraných
        int i = jListVlast.getSelectedIndex();
        int  nClick;
        String pol;
        DefaultListModel model = (DefaultListModel) jListVybrVl.getModel();
        nClick = evt.getClickCount();
        if (nClick < 2) return;
        pol = (String)((DefaultListModel) jListVlast.getModel()).getElementAt(i);
        if (i >= 0 && (model.getSize() == 0
                || !pol.equals(model.get(model.getSize()-1)))) {
            model.addElement(pol);
            vybrVla[nVybrVla] = jListVlast.getSelectedIndex();
            nVybrVla++;
            if(cinnost == 7) {
                podleHodnoty();
            }
        }
    }//GEN-LAST:event_jListVlastMouseClicked

    private void jButtonDoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonDoActionPerformed
        // Multiselection látek vybrána
        String s;
        int k;
        int[] iSel;
            iSel = jList1.getSelectedIndices();
            for (int i=0; i<iSel.length; i++) {
//                s = (String) jList1.getSelectedValue();
                s = (String) jList1.getModel().getElementAt(iSel[i]);
                k = Integer.valueOf(s.substring(0, 3).trim()); // první znaky č. látky
                jCisla[jVyber] = k;
                jVyber++;
                ((DefaultListModel) jListVybrano.getModel()).addElement(s.substring(0, 33));
            }
    }//GEN-LAST:event_jButtonDoActionPerformed

    private void jButtonVlDoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonVlDoActionPerformed
        // Přesuň multivýběr vlastností (šipka vpravo)
        String s;
        int[] iSel;
            iSel = jListVlast.getSelectedIndices();     // pole s indexy vybraných vlastností
            for (int i=0; i<iSel.length; i++) {
                s = (String) jListVlast.getModel().getElementAt(iSel[i]);
                ((DefaultListModel) jListVybrVl.getModel()).addElement(s);
                vybrVla[nVybrVla] = iSel[i];
                nVybrVla++;
//                ((DefaultListModel) jListVybrano.getModel()).addElement(s.substring(0, 33));
            }
            rozsahTabelace();
    }//GEN-LAST:event_jButtonVlDoActionPerformed

    private void jButtonBackActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonBackActionPerformed
        // Odebrat vybranou vlastnost (šipka vlevo)
        int i, j;
        i = jListVybrVl.getSelectedIndex();
        ((DefaultListModel) jListVybrVl.getModel()).removeElementAt(i);
        for (j=i; j<nVybrVla; j++) {
            vybrVla[j] =  vybrVla[j+1];
        }
        nVybrVla--;
    }//GEN-LAST:event_jButtonBackActionPerformed

    private void jButtonLatBackActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonLatBackActionPerformed
       // Odebrat vybranou látku
        int i, j;
        i = jListVybrano.getSelectedIndex();
        ((DefaultListModel) jListVybrano.getModel()).removeElementAt(i);
        for (j=i; j<jVyber; j++) {
            jCisla[j] =  jCisla[j+1];
        }
       jVyber--;
    }//GEN-LAST:event_jButtonLatBackActionPerformed

    private void jTextFieldFPkonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextFieldFPkonActionPerformed
        // Kontrola tlaků
        if (8 == cinnost) { // kontrola pro flash
            double pFpoc = Double.parseDouble((jTextFieldFPpoc.getText()).replace(',', '.')); // pro českou notaci
            double pFkon = Double.parseDouble((jTextFieldFPkon.getText()).replace(',', '.')); 
            if (pFpoc < pFkon) {
                JOptionPane.showMessageDialog(this,
                        "Pro flash musí být počáteční tlak vyšší,\nnež konečný! !",
                        "FLASH", JOptionPane.WARNING_MESSAGE);
            }
        }        
        if (9 == cinnost) { // kontrola pro škrcení/kompresi
            double pFpoc = Double.parseDouble((jTextFieldFPpoc.getText()).replace(',', '.')); // pro českou notaci
            double pFkon = Double.parseDouble((jTextFieldFPkon.getText()).replace(',', '.')); 
            if (jRadioButtonIzo.isSelected() && pFpoc < pFkon) {
                JOptionPane.showMessageDialog(this,
                        "Pro škrcení musí být počáteční tlak vyšší,\nnež konečný! !",
                        "Škrcení", JOptionPane.WARNING_MESSAGE);
            }
            if (jRadioButtonAd.isSelected() && pFpoc > pFkon) {
                JOptionPane.showMessageDialog(this,
                        "Pro kompresi musí být počáteční tlak nižšší,\nnež konečný! !",
                        "Komprese", JOptionPane.WARNING_MESSAGE);
            }            
        }
    }//GEN-LAST:event_jTextFieldFPkonActionPerformed

    private void jTextFieldFPpocKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextFieldFPpocKeyPressed
        // Ošetření "Výpočet" při vstupu mimo "Činnosti"
        if (cinnost <8 || cinnost > 9) {
                JOptionPane.showMessageDialog(this,
                        "Do panelu 'Výpočet' musíte pouze přes volbu 'Činností', vraťte se !",
                        "Výpočet", JOptionPane.WARNING_MESSAGE);
                jTextFieldFPpoc.setText("");    // zruš vložený znak
        }        
    }//GEN-LAST:event_jTextFieldFPpocKeyPressed

    private void saveMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveMenuItemActionPerformed
        // Kliknutí na Save
        ulozVysledkyKod();       
    }//GEN-LAST:event_saveMenuItemActionPerformed

    private void jCheckBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox1ActionPerformed
        // Seznam podle čísel
        try {
        naplnSeznam2(false);
        } catch (JDOMException e) {
            System.out.println("Chyba xml při načítání souboru látek!");
        } catch (IOException e) {
            System.out.println("Chyba při načítání souboru látek!");
        }        
    }//GEN-LAST:event_jCheckBox1ActionPerformed

    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
        // spustit nápovědu
        ZobrazPDF.viewPDF(NAPOVEDA);
    }//GEN-LAST:event_jMenuItem1ActionPerformed

    private void jButtonVlastniActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonVlastniActionPerformed
        // Načíst soubor s vlastními dodatečnými látkami
        Latka.nahrajDodatecneLatky();
        try {
            naplnSeznam();
            naplnSeznam2(true);
        } catch (IOException ex) {
            Logger.getLogger(FydatGUI.class.getName()).log(Level.SEVERE, null, ex);
        } catch (JDOMException ex) {
            Logger.getLogger(FydatGUI.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_jButtonVlastniActionPerformed

    /**
     * Inicializační rutina
     */
    private void myInit() {
        //        jTextAreaNadpis.setBorderPainted(false);
//        this.setExtendedState(FydatGUI.MAXIMIZED_BOTH);  // otevře maximalizivané okno      
        cinnost = -1;   // nevybrána
        jPanel2.add(pl);
        pl.nactiavykresli();
        pl.repaint();
        jPanel2.setVisible(true);
        jPanel11.setVisible(false);
        jPanel14.setVisible(false);
        jPanel15.setVisible(false);
        jLabel14.setVisible(false);
        ((DefaultListModel) jList3.getModel()).addElement("Tabelace vlastností podle teploty a tlaku");
        ((DefaultListModel) jList3.getModel()).addElement("Porovnání jedné vlastnosti u více látek");
        ((DefaultListModel) jList3.getModel()).addElement("Seznam látek v databázi");
        ((DefaultListModel) jList3.getModel()).addElement("Grafické zobrazení");
        ((DefaultListModel) jList3.getModel()).addElement("Vyhledání látky podle části názvu");
        ((DefaultListModel) jList3.getModel()).addElement("Zobrazit výsledkové okno");
        ((DefaultListModel) jList3.getModel()).addElement("Smazat výsledkové okno");
//        ((DefaultListModel) jList3.getModel()).addElement("Smazat okno složení");
        ((DefaultListModel) jList3.getModel()).addElement("Seřazení látek podle hodnoty vlastnosti");
        ((DefaultListModel) jList3.getModel()).addElement("Flash výpočet (ideální)");
        ((DefaultListModel) jList3.getModel()).addElement("Komprese/škrcení");
        ((DefaultListModel) jList3.getModel()).addElement("Uložit výsledkové okno do souboru");
        ((DefaultListModel) jList3.getModel()).addElement("Zobrazit nápovědu dokumentace");
        ((DefaultListModel) jList3.getModel()).addElement("KONEC činnosti programu");
// Formátování tabulky
        jTableSmes.setModel(smesModel);
        JTableHeader header = jTableSmes.getTableHeader();
        header.setBackground(new Color(0xA0CCFF));
        jTableSmes.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
        int vColIndex = 0;
        TableColumn col = jTableSmes.getColumnModel().getColumn(vColIndex);
        int width = 50;
        col.setPreferredWidth(width);
        TableColumn col2 = jTableSmes.getColumnModel().getColumn(1);
        col2.setPreferredWidth(225);
        TableColumn col3 = jTableSmes.getColumnModel().getColumn(2);
        col3.setPreferredWidth(80);
        TableColumnModel tcm = jTableSmes.getColumnModel();
        TableColumn tc = tcm.getColumn(TableModelSmes.COLUMN_CISLO);
        tc.setCellRenderer(new CenterRenderer());
        TableColumnModel tcmSl = jTableSmes.getColumnModel();
        TableColumn tcSl = tcmSl.getColumn(TableModelSmes.COLUMN_SLOZENI);
        tcSl.setCellRenderer(new CenterRendererSloz());
        jTableSmes.getSelectionModel().addListSelectionListener(new ListSelectionListener() {

            public void valueChanged(ListSelectionEvent e) {
                int row = jTableSmes.getSelectedRow();
                if (row != -1) {
                    Object o = jTableSmes.getModel().getValueAt(row, 2);
                    Object o1 = jTableSmes.getModel().getValueAt(row, 0);
//                    System.out.println("INDEX:" + e.getLastIndex() + "   c= " + o1 + "   x= " + o);
                    int cislo = Integer.parseInt("" + o1);
                    zobrazLatku(cislo);
                }
            }
        });

        zkratky[0] = "ViskG";
        zkratky[1] = "rViskG";
        zkratky[2] = "CpG";
        zkratky[3] = "rCpG";
        zkratky[4] = "CpGW";
        zkratky[5] = "rCpGW";
        zkratky[6] = "rCvG";
        zkratky[7] = "rCvGW";
        zkratky[8] = "Kapa";
        zkratky[9] = "VodG";
        zkratky[10] = "rVodG";
        zkratky[11] = "HustG";
        zkratky[12] = "rHustG";
        zkratky[13] = "HustL";
        zkratky[14] = "Hust";
        zkratky[15] = "CpL";
        zkratky[16] = "CpLW";
        zkratky[17] = "CpW";
        zkratky[18] = "VodL";
        zkratky[19] = "Vod";
        zkratky[20] = "ViskL";
        zkratky[21] = "Visk";
        zkratky[22] = "dHv";
        zkratky[23] = "dHvW";
        zkratky[24] = "Sigma";
        zkratky[25] = "Tenze";
        zkratky[26] = "Tbv(K)";
        zkratky[27] = "Trb(K)";
        zkratky[28] = "Tbv(°C)";
        zkratky[29] = "Trb(°C)";
        zkratky[30] = "UG";
        zkratky[31] = "UGW";
        zkratky[32] = "HG";
        zkratky[33] = "HGW";
        zkratky[34] = "SG";
        zkratky[35] = "SGW";
        zkratky[36] = "LnFug";
        zkratky[37] = "JTkoef";
        zkratky[38] = "PrL";
        zkratky[39] = "PrG";
        zkratky[40] = "ObjRoz";
        zkratky[41] = "VisKinL";
        zkratky[42] = "VisKinG";
        zkratky[43] = "HL";
        zkratky[44] = "HLW";
        zkratky[45] = "SL";
        zkratky[46] = "SLW";
        zkratky[47] = "UL";
        zkratky[48] = "ULW";
        T1 = 20;
        T2 = 50;
        T3 = 100;
        t = 293.15;
        p = 101320;
        // Short-cuts
        jButtonKonec.setMnemonic(KeyEvent.VK_K);
        jButtonVybrano.setMnemonic(KeyEvent.VK_V);
        jButtonSmaz.setMnemonic(KeyEvent.VK_S);
        jButton1.setMnemonic(KeyEvent.VK_V);
//        jButton2.setMnemonic(KeyEvent.VK_V);
//        jButton3.setMnemonic(KeyEvent.VK_R);
        jButtonSmazSloz.setMnemonic(KeyEvent.VK_S);
        jToggleButtonDocas.setMnemonic(KeyEvent.VK_D);
        jButtonTabel.setMnemonic(KeyEvent.VK_V);
        jButtonNab.setMnemonic(KeyEvent.VK_Z);
        jButtonFlash.setMnemonic(KeyEvent.VK_V);
        jButtonSmazat.setMnemonic(KeyEvent.VK_S);
        this.setLocale(new Locale("cs", "CZ"));  // ******************************************
        jList3.setSelectedIndex(0);
        jList3.requestFocus();
        try {
            naplnSeznam();
            naplnSeznam2(true);
        } catch (JDOMException e) {
            System.out.println("Chyba xml při načítání souboru látek!");
        } catch (IOException e) {
            System.out.println("Chyba při načítání souboru látek!");
        }
        jLabelSoubor.setText("Data o látkách jsou ze souboru: " + Latka.getSouborDat());
    }

    /**
     * Rutina zpracovávající volbu činností
     * @param zvolenaCinnost
     */
    void volbaCinnosti(int zvolenaCinnost) {
        cinnost = zvolenaCinnost;
        jLabelPorov.setText("");
        jPanel15.setVisible(false);
        ((DefaultListModel) jListVybrano.getModel()).removeAllElements();
        ((DefaultListModel) jListGr.getModel()).removeAllElements();
        jVyber = 0;     // nulování vybraných vlastností a látek
        jCisla = new int[50];
        if (0 == zvolenaCinnost) {  // tabelace
            bylaTabelace = true;
            jTabbedPane1.setSelectedIndex(1);
            jListVybrano.removeAll();
            jList1.requestFocus();
        }
        if (1 == zvolenaCinnost) {  // porovnávání
            jTabbedPane1.setSelectedIndex(1);
            bylaTabelace = false;
            jListVybrano.removeAll();
            jList1.requestFocus();
        }
        if (2 == zvolenaCinnost) {
            // seznam látek
            try {
                naplnSeznam2(true);
            } catch (JDOMException e) {
            System.out.println("Chyba xml při načítání souboru látek!");               
            } catch (IOException e) {
                System.out.println("Chyba při načítání souboru látek!");
            }
            jTabbedPane1.setSelectedIndex(6);
        }
        if (3 == zvolenaCinnost) {
            // Grafické zobrazení
            pregraf();
            cinnost = 3;
        }
        if (4 == zvolenaCinnost) {
            // vyhledání láttek podle části názvu
            try {
                najdiPodleNazvu();
        } catch (JDOMException e) {
            System.out.println("Chyba xml při načítání souboru látek!");                 
            } catch (IOException e) {
                System.out.println("Chyba při načítání souboru látek!");
            }
            jTabbedPane1.setSelectedIndex(6);
        }
        if (5 == zvolenaCinnost) {
            // zobraz okno výsledků
            jTabbedPane1.setSelectedIndex(4);
        }
        if (6 == zvolenaCinnost) {
            // smazat výsledkové okno
            int i = JOptionPane.showConfirmDialog(null, "Opravdu chcete smazat výsledkové okno?", "FYDAT činnosti", JOptionPane.YES_NO_OPTION, WIDTH, null);
            if (i == JOptionPane.YES_OPTION) {
                jTextAreaTab.setText("");
            }
        }
        if (7 == zvolenaCinnost) {
            // podle hodnoty vlastnosti
            cinnost = 7;
            zvolenaCinnost = cinnost;
            jTabbedPane1.setSelectedIndex(1);
            vlastnostiNaVyber();
//            rozsahTabelace();
        }
        if (8 == zvolenaCinnost) {
            // Flash výpočet
            cinnost = 8;
            zvolenaCinnost = cinnost;
            bylaTabelace = false;            
            jLabel9.setText("Výpočet ideálního flash");
            jRadioButtonAd.setText("Adiabatický");
            jRadioButtonIzo.setText("Izotermní");
            jTabbedPane1.setSelectedIndex(1);
        }
        if (9 == zvolenaCinnost) {
            cinnost = 9;
            zvolenaCinnost = cinnost;
            bylaTabelace = false;            
            jLabel9.setText("Výpočet komprese/škrcení");
            jRadioButtonAd.setText("Komprese par");
            jRadioButtonIzo.setText("Škrcení");
            jTabbedPane1.setSelectedIndex(1);
        }
        if (10 == zvolenaCinnost) {
            ulozVysledkyKod();
        }        
        if (11 == zvolenaCinnost) {
            ZobrazPDF.viewPDF(NAPOVEDA);
        }   
        if (12 == zvolenaCinnost) {
            System.exit(0);
        }
    }

    /**
     * Naplnění seznamu látek pro výběr látek
     * @throws IOException
     */
    void naplnSeznam() throws IOException, JDOMException {
        String[] s;       // původně: musí být přesně 533 jinak chyby!
//        Font fontCur = new Font("Courier", Font.BOLD,  12);
        int nLat;
        jLabel23.setText("Seznam látek v bázi nebo ve výběru:");
        s = Latka.seznamLatek(true);  // true - dle abecedy
        nLat = s.length;
        listModel.removeAllElements();
        for (int i = 0; i < nLat; i++) {
            listModel.addElement(s[i]);  // vkládání přes model (tabelace, porov.)
        }
    }

    /**
     * Naplnění seznamu látek
     * @throws IOException
     */
    void naplnSeznam2(boolean abc) throws IOException, JDOMException {
        String[] s;       // původně: musí být přesně 533 jinak chyby!
//        Font fontCur = new Font("Courier", Font.BOLD,  12);
        int nLat;
        jLabel23.setText("Seznam látek v bázi nebo ve výběru (" + Latka.getnZaznamu() + "):");
        ((DefaultListModel) jList4.getModel()).removeAllElements();
        jLabelVyber1.setText("");
        s = Latka.seznamLatek(abc);  // true - dle abecedy, false podle čísel
        nLat = s.length;
        for (int i = 0; i < nLat; i++) {
            ((DefaultListModel) jList4.getModel()).addElement(s[i]);  // vkládání přes model
        }
        jCheckBox1.setSelected(false);
    }

    /**
     * Vyhledání látek podl ečásti názvu
     * @throws IOException
     */
    void najdiPodleNazvu() throws IOException, JDOMException {
        String[] s;       // původně: musí být přesně 533 jinak chyby!
        String cast, castU;
        cast = "DICHLOR";
        cast = (String) JOptionPane.showInputDialog(
                this,
                "Vložte název látky nebo její části či vzorce (bez *) :\n",
                "Vyhledání látek",
                JOptionPane.PLAIN_MESSAGE,
                null,
                null,
                "");
        castU = cast.toUpperCase();
//      Najde látky podle části názvu
        int nLat;
        jLabel23.setText("Seznam látek v bázi nebo ve výběru:");
        ((DefaultListModel) jList4.getModel()).removeAllElements();
        s = Latka.seznamLatek(true);  // true - dle abecedy
        nLat = s.length;
        for (int i = 0; i < nLat; i++) {
            if (s[i].indexOf(castU) > 0 || s[i].indexOf(cast) > 0) {
                ((DefaultListModel) jList4.getModel()).addElement(s[i]);  // vkládání přes model
            }
        }
        jLabelVyber1.setText(cast + "        počet= " + ((DefaultListModel) jList4.getModel()).size());
    }
// Pomocná třída pro kreslení grafů

    class Platno extends Canvas {

        Image img = null;

        void nactiavykresli() {
            img = tlk.getImage("d:/Datexcel/Fydexx/fydat.png");
            repaint();
//        Graphics2D g2d = (Graphics2D) g;    // inicializace 2D grafiky
//        Dimension d =getSize();
//          if (img != null) {
//            g2d.drawImage(img, 10,300,d.width-40,(d.width-30)/2, this);
//            System.out.println("nacti a vykreslit: "+img.getSource());
//    }

        }

        @Override
        public void paint(Graphics g) {
            super.paint(g);
            Graphics2D g2d = (Graphics2D) g;    // inicializace 2D grafiky
            Dimension d = getSize();
            if (img != null) {
                g2d.drawImage(img, 10, 300, d.width - 40, (d.width - 30) / 2, this);
//            System.out.println("pl.paint: w,h: "+img.getSource()+" w "+d.width+" h "+d.height);
            }
        }
    } // Platno

    public static class KomparSeznam implements Comparator {

        public int compare(Object o1, Object o2) {
            String s1 = ((String) o1).substring(4, 30);
            String s2 = ((String) o2).substring(4, 30);
//            System.out.println("* " + s1 + " : " + s2);
            return s1.compareTo(s2);
        }
    }

    /**
     * Výběr vlastností
     */
    private void vlastnostiNaVyber() {
        int i;
        jTabbedPane1.setSelectedIndex(3);
        DefaultListModel defModel = ((DefaultListModel) jListVlast.getModel());
        defModel.removeAllElements();
        defModel.addElement("Viskozita(g)(Pa.s)");
        defModel.addElement("Viskozita(rg)(Pa.s)");
        defModel.addElement("Mol.tepelná kapacita Cp(g)(J/mol/K)");
        defModel.addElement("Mol.tepelná kapacita Cp(rg)(J/mol/K)");
        defModel.addElement("Tepelná kapacita Cp(g)(J/kg/K)");
        defModel.addElement("Tepelná kapacita Cp(rg)(J/kg/K)");
        defModel.addElement("Mol.tepelná kapacita Cv(rg)(J/mol/K)");
        defModel.addElement("Tepelná kapacita Cv(g)(J/kg/K)");
        defModel.addElement("Adiabatický koef. kapa(g)(-)");
        defModel.addElement("Tepelná vodivost(g)(W/m/K)");
        defModel.addElement("Tepelná vodivost(rg)(W/m/K)");
        defModel.addElement("Hustota(g)(kg/m3)");
        defModel.addElement("Hustota(rg)(kg/m3)");
        defModel.addElement("Hustota(l)(kg/m3)");
        defModel.addElement("Hustota(l i g)(kg/m3)");
        defModel.addElement("Mol.tepelná kapacita(l)(J/mol/K)");
        defModel.addElement("Tepelná kapacita Cp(l)(J/kg/K)");
        defModel.addElement("Tepelná kapacita Cp(l i g)(J/kg/K)");
        defModel.addElement("Tepelná vodivost(l)(W/m/K)");
        defModel.addElement("Tepelná vodivost(l i g)(W/m/K)");
        defModel.addElement("Viskozita(l)(Pa.s)");
        defModel.addElement("Viskozita(l i g)(Pa.s)");
        defModel.addElement("Mol.výparné teplo(l)(J/mol)");
        defModel.addElement("Výparné teplo(l)(J/kg)");
        defModel.addElement("Povrchové napětí(l)(N/m)");
        defModel.addElement("Tenze par(l)(Pa)");
        defModel.addElement("Teplota bodu varu (l)(K)");
        defModel.addElement("Teplota rosného bodu (g)(K)");
        defModel.addElement("Teplota bodu varu (l)(°C)");
        defModel.addElement("Teplota rosného bodu (g)(°C)");
        defModel.addElement("Mol.vnitř.energie (rg)(J/mol)");
        defModel.addElement("Vnitřní energie (rg)(J/kg)");
        defModel.addElement("Mol. entalpie (rg)(J/mol)");
        defModel.addElement("Entalpie (rg)(J/kg)");
        defModel.addElement("Mol. entropie (rg)(J/mol/K)");
        defModel.addElement("Entropie (rg)(J/kg/K)");
        defModel.addElement("Ln-fug.koef (rg)(-)");
        defModel.addElement("Joule-Thomp. koef (rg)(K/MPa)");
        defModel.addElement("Prandtlovo číslo (l)(-)");
        defModel.addElement("Prandtlovo číslo (rg)(-)");
        defModel.addElement("Obj.roztažnost (l)(1/K)");
        defModel.addElement("10^6 Kinem.vizkozita (l)(m2/s)");
        defModel.addElement("10^6 Kinem.vizkozita (rg)(m2/s)");
        defModel.addElement("Mol. entalpie (l)(J/mol)");
        defModel.addElement("Entalpie (l)(J/kg)");
        defModel.addElement("Mol. entropie (l)(J/mol/K))");
        defModel.addElement("Entropie (l)(J/kg/K))");
        defModel.addElement("Mol. vnitř. energie (l)(J/mol)");
        defModel.addElement("Vnitřní energie (l)(J/kg)");
        ((DefaultListModel) jListVybrVl.getModel()).removeAllElements();
        nVybrVla = 0;
        // Založení směsi
        if (cinnost != 7) zalozeniSmesi();
    }

    /**
     * Založí Smes ze zadaných dat
     */
    private void zalozeniSmesi() {
        // Založení směsi
        int i;
        String pom;
        try {
            sm = new Smes(jVyber, jCisla);
            x = new double[Math.max(2, jVyber)];
            double s = 0;
            for (i = 0; i < jVyber; i++) {
                pom = (String) jTableSmes.getValueAt(i, 2);
//                x[i] = Double.parseDouble((listSlozeni.getItem(i)).replace(',', '.'));
                x[i] = Double.parseDouble(pom.replace(',', '.'));
//                System.out.println("x: " + i + "  " +x[i]);
                s += x[i];
            }
            for (i = 0; i < jVyber; i++) {
                x[i] = x[i] / s;
            }
           if (cinnost == 8 || cinnost == 9) {
                 sm.setNeMistniHlasky(true);
            }
//           if (cinnost == 7) {
//                 x[0] = 1; x[1] = 0;
//            }
            sm.zadatSloz(jRadioButtonHmot.isSelected(), x);
//            sm.sKapa(320, 101320);
            if (!(jTextFieldNazSmesi.getText()).equals("")) {
                sm.setNazev(jTextFieldNazSmesi.getText());
            }
        } catch (JDOMException e) {
            e.printStackTrace();             
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * Vytváří textové zobrazení složení
     * @return
     */
    String vytvorTextSlozeni() {
        int i;
        String tx = "";
        if (sm == null) return "";
        tx = (cinnost == 0) ? sm.getNazev() : "Porovnání vlastnosti";
        tx += "\nDefinice a složení směsi               Stř.mol.hmotnost(kg/mol)= " + String.format("%-6.4f%n", sm.sMolHmot());
        tx += "Pseudokritické veličiny:               Tkrs(K)= "
                + String.format("%-6.1f", sm.sTksm()) + " Pkrs(MPa)= "
                + String.format("%-6.2f", sm.sPksm() / 1e6) + " Vkrs(ml/mol)= "
                + String.format("%-6.2f%n", sm.sVksm() * 1e6);
        tx += "Čís. Látka                     Vzorec          Molhm.  Tkrit   Pkrit  Vkrit   Složení  Složení\n";
        tx += "                                               kg/mol    K      MPa   ml/mol   Xhmot    Xmol\n";
        tx += "__________________________________________________________________________________________________\n";
        for (i = 0; i < jVyber; i++) {
            tx += String.format("%3d  %-25s %-15s %-6.4f  %-5.1f   %-5.2f  %-5.1f   %-6.4f   %-6.4f%n",
                    jCisla[i], sm.getSlozka(i).getNazev(),
                    sm.getSlozka(i).getVzorec(), sm.getSlozka(i).getMolHmot(),
                    sm.getSlozka(i).gettKr(), sm.getSlozka(i).getpKr() / 1e6,
                    sm.getSlozka(i).getvKr() * 1e6,
                    (cinnost == 0 || cinnost == 9) ? sm.getxHmot(i) : 1.0,
                    (cinnost == 0 || cinnost == 9) ? sm.getxMol(i) : 1.0);
        }
        tx += "__________________________________________________________________________________________________\n";
        if (jCheckBoxPridSloz.isSelected() && zmenaSloz) {
            tabelace += "\n" + tx;
            zmenaSloz = false;
            return tx;
        }
        return "";
    }

    /**
     * Předpříprava na tabelaci
     */
    private void pripravTabelaci() {
        if (jRadioButtonT.isSelected()) {
            Ptab = Double.parseDouble((jTextFieldPri.getText()).replace(',', '.'));
            tabDleTepl = true;
        }
        if (jRadioButtonP.isSelected()) {
            Ttab = Double.parseDouble((jTextFieldPri.getText()).replace(',', '.'));
            tabDleTepl = false;
        }
        tabPoc = Double.parseDouble((jTextFieldPoc.getText()).replace(',', '.'));  // pro českou notaci
        tabKon = Double.parseDouble((jTextFieldKon.getText()).replace(',', '.'));  // pro českou notaci
        tabKrok = Double.parseDouble((jTextFieldKrok.getText()).replace(',', '.'));  // pro českou notaci
    }

    /**
     * Porovnání jedné vlastnosti u více látek
     * @return
     */
    private String porovnani() {
        int len;
        double pom;
        String mez = " ", naz;
        T1 = Double.parseDouble((jTextFieldT1.getText()).replace(',', '.'));  // pro českou notaci
        T2 = Double.parseDouble((jTextFieldT2.getText()).replace(',', '.'));  // pro českou notaci
        T3 = Double.parseDouble((jTextFieldT3.getText()).replace(',', '.'));  // pro českou notaci
        p = Double.parseDouble((jTextFieldP.getText()).replace(',', '.')) * 1e6;  // pro českou notaci
        int i, j;
        pom = t;
        String tab = "";      // "globální" tabelační string
//        tab += "Porovnání vlastnosti: " + zkratky[vybrVla[0]];
//        tab += "Porovnání vlastnosti: " + listVybrVl.getItem(0);
        tab += "Porovnání vlastnosti: " + ((DefaultListModel) jListVybrVl.getModel()).getElementAt(0);
        tab += "\nTlak(MPa): " + String.format("%-6.3f", p / 1e6);
        tab += "\nLátka                          " + T1 + "(°C)     "
                + T2 + "(°C)     " + T3 + "(°C)\n";
        for (j = 0; j < jVyber; j++) {
            t = T1 + TABS;
            naz = smPor[j].getSlozka(0).getNazev();
            len = naz.length();
            tab += naz;
            for (i = 0; i < 30 - len; i++) {
                tab += mez;
            }
            tab += String.format("  %-10.4g ", tabelFce(smPor[j], vybrVla[0]));
            t = T2 + TABS;
            tab += String.format("  %-10.4g ", tabelFce(smPor[j], vybrVla[0]));
            t = T3 + TABS;
            tab += String.format("  %-10.4g ", tabelFce(smPor[j], vybrVla[0])) + "\n";
        }
        tab += "\n";
        return tab;

    }

    /**
     * Zabezpečí provedení vlastní tabelace s výsledky do stringu tab
     * @return tab - tabelační string
     */                                              
    String tabelace() {
        int i, j;
        double pomP = 0;
        String tab = "";      // "globální" tabelační string
        if (tabDleTepl) {
            tab = String.format("\nTabelace při tlaku (MPa)= %-7.5f%n"
                    + "Bod varu směsi  (°C)= %5.1f%n"
                    + "Rosný bod směsi (°C)= %5.1f%n", Ptab,
                    sm.sTbv(Ptab*1e6) - TABS,sm.sTrb(Ptab*1e6) - TABS);
        } else {                                                                                                                                                                                                      for(i = 0; i < sm.getnSloz();i++) {
                pomP += sm.getSlozka(i).tenze(Ttab + TABS)*sm.getxMol(i);
            }
            tab = String.format("\nTabelace při teplotě (°C)= %-6.1f%n"
                    + "Tlak bodu varu při této teplotě je (MPa): %-4.2f%n", Ttab,pomP/1e6);
        }
        tab += "Počet vybraných vlastností= " + nVybrVla + "\n";
        if (tabDleTepl) {
            tab += "T (°C)    ";
            for (j = 0; j < nVybrVla; j++) {
                tab += zkratky[vybrVla[j]] + "       ";
            }
            tab += "\n";
            t = tabPoc + TABS;
            p = Ptab * 1e6;
            do {
                tab += String.format("%5.1f  ", t - TABS);
                for (j = 0; j < nVybrVla; j++) {
                    tab += String.format("  %-10.4g ", tabelFce(sm, vybrVla[j]));
                }
                tab += "\n";
                t += tabKrok;
            } while (t <= tabKon + TABS);
        } else {      // tabelace dle tlaku
            tab += "P (MPa)    ";
            for (j = 0; j < nVybrVla; j++) {
                tab += zkratky[vybrVla[j]] + "        ";
            }
            tab += "\n";
            p = tabPoc * 1e6;
            t = Ttab + TABS;
            do {
                tab += String.format("%5.1f  ", p / 1e6);
                for (j = 0; j < nVybrVla; j++) {
                    tab += String.format("  %-10.4g ", tabelFce(sm, vybrVla[j]));
                }
                tab += "\n";
                p += tabKrok * 1e6;
            } while (p <= tabKon * 1e6);
        }
        tab += "\n";
        return tab;
    }

    /**
     * Spočte hodnotu i-té tabelované funkce
     * @param i pořadový index
     * @return hodnota funkce
     */
    Double tabelFce(Smes sm, int i) {
        double f = 0;
        switch (i) {
            case 0:
                f = sm.sViskG(t);
                break;
            case 1:
                f = sm.srViskG(t, p);
                break;
            case 2:
                f = sm.sCpG(t);
                break;
            case 3:
                f = sm.srCpG(t, p);
                break;
            case 4:
                f = sm.sCpGW(t);
                break;
            case 5:
                f = sm.srCpGW(t, p);
                break;
            case 6:
                f = sm.srCvG(t, p);
                break;
            case 7:
                f = sm.srCvGW(t, p);
                break;
            case 8:
                f = sm.sKapa(t, p);
                break;
            case 9:
                f = sm.sVodG(t);
                break;
            case 10:
                f = sm.srVodG(t, p);
                break;
            case 11:
                f = sm.sHustGW(t, p);
                break;
            case 12:
                f = sm.srHustGW(t, p);
                break;
            case 13:
                f = sm.sHustL(t);
                break;
            case 14:
                f = sm.sHust(t, p);
                break;
            case 15:
                f = sm.sCpL(t);
                break;
            case 16:
                f = sm.sCpLW(t);
                break;
            case 17:
                f = sm.sCpW(t, p);
                break;
            case 18:
                f = sm.sVodL(t);
                break;
            case 19:
                f = sm.sVod(t, p);
                break;
            case 20:
                f = sm.sViskL(t);
                break;
            case 21:
                f = sm.sVisk(t, p);
                break;
            case 22:
                f = sm.sdHv(t);
                break;
            case 23:
                f = sm.sdHvW(t);
                break;
            case 24:
                f = sm.sSigma(t);
                break;
            case 25:
                f = sm.sTenze(t);
                break;
            case 26 :
                f = sm.sTbv(p);
                break;
            case 27:
                f = sm.sTrb(p);
                break;
            case 28 :
                f = sm.sTbv(p) - TABS;
                break;
            case 29:
                f = sm.sTrb(p) - TABS;
                break;
            case 30:
                f = sm.srUG(t, p);
                break;
            case 31:
                f = sm.srUGW(t, p);
                break;
            case 32:
                f = sm.srHG(t, p);
                break;
            case 33:
                f = sm.srHGW(t, p);
                break;
            case 34:
                f = sm.srSG(t, p);
                break;
            case 35:
                f = sm.srSGW(t, p);
                break;
            case 36:
                f = sm.sLnFug(t, p);
                break;
            case 37:
                f = sm.sJTcoef(t, p);
                break;
            case 38:
                f = sm.sPrL(t);
                break;
            case 39:
                f = sm.sPrG(t, p);
                break;
            case 40:
                f = sm.sObjRozL(t);
                break;
            case 41:
                f = sm.sViskKinemL(t);
                break;
            case 42:
                f = sm.sViskKinemG(t, p);
                break;
            case 43:
                f = sm.sHL(t);
                break;
            case 44:
                f = sm.sHLW(t);
                break;
            case 45:
                f = sm.sSL(t);
                break;
            case 46:
                f = sm.sSLW(t);
                break;
            case 47:
                f = sm.sUL(t);
                break;
            case 48:
                f = sm.sULW(t);
                break;
            default:
                break;
        }
        return f;
    }

    /**
     * Předpříprava pro grafy
     */
    private void pregraf() {
        int i;
        if (cinnost != 0 && !bylaTabelace) {
            JOptionPane.showMessageDialog(this,
                    "Graf má smysl pouze u Tabelace!\nZvolte něco jiného.",
                    "FYDAT činnosti", JOptionPane.WARNING_MESSAGE);
        } else {
            ((DefaultListModel) jListGr.getModel()).removeAllElements();
            for (i = 0; i < nVybrVla; i++) {   // nabídni vlastnosti pro graf
                //        listModel3.addElement(listVybrVl.getItem(i));
                ((DefaultListModel) jListGr.getModel()).addElement(
                        ((DefaultListModel) jListVybrVl.getModel()).getElementAt(i));
            }
            if (((DefaultListModel) jListGr.getModel()).getSize() > 0) {
                jPanel15.setVisible(false);
            }
            jListGr.setSelectedIndex(0);
            jTabbedPane1.setSelectedIndex(5);
            jListGr.requestFocus();
        }
    }

    /**
     * Zobrazení grafu vlastností
     */
    private void graf() {
        int i, j;
        double ymin = 1e8, ymax = -1e8;
        double[] xt = new double[21];
        double[] y = new double[21];
        cinnost = 0;    // obnova tabelační činnosti
        x[0] = tabPoc;
        j = 0;
        sm.setNeMistniHlasky(true);
        do {
            xt[j] = tabPoc + (tabKon - tabPoc) / 20 * j;
            if (tabDleTepl) {
                t = xt[j] + TABS;
                p = Ptab * 1e6;
            } else {      // tabelace dle tlaku
                p = xt[j] * 1e6;
                t = Ttab + TABS;
            }
            y[j] = tabelFce(sm, vybrVla[iGraf]);
            if (y[j] > ymax) {
                ymax = y[j];
            }
            if (y[j] < ymin) {
                ymin = y[j];
            }
            j++;
        } while (j <= 20);
        sm.setNeMistniHlasky(false);
        // Graf
        XYSeries series1 = new XYSeries("First");
        for (i = 0; i < j; i++) {
            series1.add(xt[i], y[i]);
        }
        XYSeriesCollection dataset = new XYSeriesCollection();
        dataset.addSeries(series1);
        // vytvoř chart...
        JFreeChart chart = ChartFactory.createXYLineChart(VlaGraf, // chart title
                (tabDleTepl) ? "Teplota (°C)" : "Tlak (MPa)", // domain axis label
                VlaGraf, // range axis label
                dataset, // data
                PlotOrientation.VERTICAL, // orientace
                false, // include legend
                false, false);
        XYPlot plot = chart.getXYPlot();
        Stroke parLine = new BasicStroke(3.0f, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND,
                1.0f, null, 0.0f);          // tlouštka, první parametr
        plot.getRenderer().setSeriesStroke(0, parLine); // nastavení tlouštky čáry
        plot.getRenderer().setSeriesPaint(0, Color.BLUE);   // nastavení barvy čáry
        chart.getTitle().setFont(new Font("Tahoma", Font.BOLD, 18));      // font a velikost

        // omezení dolní meze y nad nulu
        if (!jCheckBoxOdNuly.isSelected()) {  // pokud se nevyžaduje  natvrdo od nuly
            if (ymax / ymin < 1.3) {
                if (ymin > 0.0) {
                    plot.getRangeAxis().setLowerBound(0.9 * ymin);
                } else {
                    plot.getRangeAxis().setUpperBound(0.9 * ymax);
                }
            }
        }

        ChartPanel chartPanel = new ChartPanel(chart);      // někdy bývá final
        chartPanel.setPreferredSize(new java.awt.Dimension(320, 270));
        //    setContentPane(chartPanel);     //  tady se zadrhne !
        //    this.setContentPane(chartPanel);  // i tady
        //    getContentPane().add(chartPanel);  // tady ne, ale nic nedělá
        chartPanel.setVisible(true);

        //    int len =  jTabbedPane1.getTabCount();
        //    jTabbedPane1.add(VlaGraf,chartPanel);     // původně na hlavní
        jTabbedPane2.add(sm.getNazev(), chartPanel);
    }

    /**
     * Umožní dočasnou změnu názvu látky (náhradní látky)
     * @param n pořadový index látky ve směsi
     */
    private void docasnaZmenaNazvu() {
        int n;
        String nova;
        Latka poml;     // pomocná látka k přejmenování
        do {
            nova = JOptionPane.showInputDialog(
                    null,
                    "Vložte nahrazující název látky\n"
                    + "Bude jen dočasný:",
                    "Dočasná změna názvu látky",
                    JOptionPane.PLAIN_MESSAGE);
        } while (nova.equals(""));
        if (nova.equals(null)) {
            return;
        }
        n = jTableSmes.getSelectedRow();
        sm.setNazevSlozky(n, nova);
        jTableSmes.setValueAt(nova, n, 1);
        jTextFieldLNaz.setText(nova);
        jTableSmes.repaint();
    }

    /**
     * Seřazení látek podle konkrétní hodnoty vlastnosti
     */
    private void podleHodnoty() {
        int i, j, nVl;
        double hodnota;  // požadovaná hodnota
        PodleVlastnosti[] hodnoty = new PodleVlastnosti[700];
        // jistější je použít ArrayList
        PodleVlastnosti pom;
        if (nVybrVla > 0) {
            nVl = vybrVla[0];
            vlPom = zkratky[nVl];
        } else {
            return;  // nebyla vybrána vlastnost
        }
        try {
            new OknoSrovnani(this, true).setVisible(true);  // srovnávací parametry
            t = tPom + TABS;
            p = pPom * 1e6;
            hodnota = hPom;
        } catch (NullPointerException e) {
            return;
        }
        i = 0;
        try {
            for (j = 0; j < 700; j++) {         // 699, po jednotlivých látkách
                if (Latka.getIndexZaznamu()[j+1] >= 0) {    // látka je v bázi
                    pom = new PodleVlastnosti(j + 1, nVl, hodnota, t, p);
                    if (pom.odchylka > -9998.9) {
                        hodnoty[i] = pom;
                        i++;
                    }
                }
            }
            Arrays.sort(hodnoty, 0, i);   // prázdné položky v poli by vadily !!!
        } catch (NullPointerException e) {
            e.printStackTrace();
            System.out.println("Null-exception: " + e.getMessage());
        }
        ((DefaultListModel) jList4.getModel()).removeAllElements();  // smaže výsledkové okno
        for (j = 0; j < i; j++) {   // zapíše do listu výsledků
            ((DefaultListModel) jList4.getModel()).addElement(hodnoty[j]);
        }
        jLabel23.setText("Podle hodnoty " + zkratky[nVl]
                + " = " + hodnota + "  t(°C)= " + (t - TABS)
                + "  tlak(MPa)= " + p / 1e6);
        jTabbedPane1.setSelectedIndex(6);  // zobraz seznam podle hodnoty vlastnosti
        ((DefaultListModel) jListVybrVl.getModel()).removeAllElements();
        nVybrVla = 0;   // smaže vybranou vlstnost
        
    }

    /**
     * Prověrka látky na náhradní vlastnosti
     * @param ii
     */
    private void proverLatku(int ii) {
        int i, k;
        String tx, stav = "";
        String[] vla = {"Viskozita (g)", "Cp (g)", "Vodivost (g)",
            "Hustota (l)", "Viskozita (l)", "Vodivost (l)", "Cp (l)",
            "Výpar.teplo", "Tenze par", "Povrch.napětí"};
        Latka ltk = null;
        ltk = Latka.getLatka(ii - 1);
        tx = "Prověření dat látky " + ii + " " + ltk.getNazev()
                + " : " + ltk.getVzorec() + "\n";
        tx += "------------------------------------------------------------\n";
        for (i = 0; i < 10; i++) {
            k = ltk.getTrida(i);
            k = (k < 65000) ? k : k - 65536;
            if ((k) >= 0) {
                stav = "OK";
            } else {
                stav = String.format("%-3d", Math.abs(k)) + " "
                        + Latka.getLatka(Math.abs(k + 1)).getNazev();
            }
            tx += String.format("%-15s", vla[i]) + " : " + stav + "\n";
//            System.out.println("Třída: "+k);
        }
        tabelace += tx + "\n";
        jTextAreaTab.setText(tabelace);
        jTabbedPane1.setSelectedIndex(4);
    }

    /**
     * Výpočet ideálního flash (adiab. nebo izotermní)
     */
    private String flash() {
        int i, nSloz;
        double tFpoc, pFpoc, pFkon, fmin = -9999;
        double VFpoc = 0, VF = 0, pom, tFkon = 0, hl = 0, hv = 0;
        String tx;
        nSloz = sm.getnSloz();
        sm.setNeMistniHlasky(true);
        double[] xPoc = new double[nSloz];
        double[] yPoc = new double[nSloz];
        double[] xKon = new double[nSloz];
        double[] yKon = new double[nSloz];
        jTabbedPane1.setSelectedIndex(7);
        tx = vytvorTextSlozeni();
//        jTextAreaSloz.append(tx);
        tabelace += tx + "\n";
        pFpoc = Double.parseDouble((jTextFieldFPpoc.getText()).replace(',', '.'));  // pro českou notaci
        pFkon = Double.parseDouble((jTextFieldFPkon.getText()).replace(',', '.'));  // pro českou notaci
        tFpoc = Double.parseDouble((jTextFieldFTpoc.getText()).replace(',', '.'));  // pro českou notaci
        // nalezení výchozího stavu
        tPom = tFpoc + TABS;   // přes statické proměnné
        pPom = pFpoc;
        x[0] = 0.3;   // odhad V/F
        x[1] = 0;    // dummy
        I_Fmin fi = this;  // new FydatGUI()vytvoří další instanci a proto nezná proměnné, jen statické!
        try {
            // Výchozí stav
            pocatek = true;
            fmin = Numer.m_Fmin1(fi, 2, x, 1e-4); // volání minimalizace
//            System.out.println("* V/Fpoc, fmin : "+ x[0]+"  "+fmin);
            VFpoc = x[0];
            if (VFpoc < 0) {
                VFpoc = 0;
            }
            if (VFpoc > 1) {
                VFpoc = 1;
            }
            for (i = 0; i < nSloz; i++) {
                pom = sm.getSlozka(i).tenze(tPom) / pPom;
                x[i] = sm.getxMol(i);
                xPoc[i] = x[i]
                        / (1.0 + VFpoc * (pom - 1.0));
                yPoc[i] = x[i] / VFpoc - xPoc[i] * (1 / VFpoc - 1.0);  // také xPoc[]*pom;
            }
            normalizuj(nSloz, xPoc);
            normalizuj(nSloz, yPoc);
            // počáteční entalpie
            try {
                sm.zadatSloz(false, yPoc);            // mol.sl. parní fáze
                hv = sm.srHG(tPom, pPom);    // koncová entalpie par
                if (Double.isNaN(hv)) {
                    hv = 0;
                }
                sm.zadatSloz(false, xPoc);
                hl = sm.sHL(tPom);           // koncová entalpie kapaliny
                if (Double.isNaN(hl)) {
                    hl = 0;
                }
                sm.zadatSloz(false, x);            // vrátit mol. složení nástřiku
                hPom = VFpoc * hv + (1.0 - VFpoc) * hl;
            } catch (IOException e) {
                e.getStackTrace();
            }
            // Koncový stav
            // izotermní i adiab. flash
            tPom = tFpoc + TABS;   // přes statické proměnné
            pPom = pFkon;
            x[0] = 0.3;   // odhad V/F
            x[1] = (adiabFlash) ? tFpoc : 0;    // dummy nebo T
            pocatek = false;
            fmin = Numer.m_Fmin1(fi, 2, x, 1e-4); // volání minimalizace
//                System.out.println("* V/F,T, fmin : "+ x[0]+"  "+x[1]+" * "+fmin);
            VF = x[0];
            tFkon = x[1];
            if (adiabFlash) {
                tPom = x[1] + TABS;
            }
            if (VF < 0) {
                VF = 0;
            }
            if (VF > 1) {
                VF = 1;
            }
            for (i = 0; i < sm.getnSloz(); i++) {
                pom = sm.getSlozka(i).tenze(tPom) / pPom;
                xKon[i] = sm.getxMol(i)
                        / (1.0 + VF * (pom - 1.0));

                yKon[i] = sm.getxMol(i) / VF - xKon[i] * (1 / VF - 1.0);
                if (VF > 0.9999) {
                    xKon[i] = 0.0;
                    yKon[i] = sm.getxMol(i);
                }
                if (VF < 0.0001) {
                    xKon[i] = sm.getxMol(i);
                    yKon[i] = 0.0;
                }
            }
            normalizuj(nSloz, xKon);
            normalizuj(nSloz, yKon);
        } catch (NumerException ex) {
            double value = ex.getValue();
            JOptionPane.showMessageDialog(null, "Překročen max. počet iterací, výsledná hodnota je:" + value);
        }
        // Zápis výsledků
        tx = "\nFLASH " + ((jRadioButtonIzo.isSelected()) ? " izotermní" : " adiabatický");
        tx += "\nPočáteční tlak (MPa): " + String.format("%-6.4f", pFpoc / 1e6);
        tx += "   Koncový tlak (MPa): " + String.format("%-6.4f", pFkon / 1e6);
        tx += "\nPočáteční teplota (°C): " + String.format("%-5.1f", tFpoc)
                + "  Koncová teplota (°C): "
                + String.format("%-5.1f", (jRadioButtonIzo.isSelected()) ? tFpoc : tFkon);
        tx += "\nKoncový Bod varu a rosný bod (°C): "
                + String.format("%-5.1f", sm.sTbv(pFkon) - TABS)
                + "  " + String.format("%-5.1f", sm.sTrb(pFkon) - TABS);
        tx += "\nPoměr parní fáze k nástřiku (poč, kon): "
                + String.format("%-6.4f", VFpoc) + String.format("  %-6.4f", VF);
        tx += "\n Složka                    Pára   Kapalina Nástřik (mol.zl.)";
        for (i = 0; i < nSloz; i++) {
            tx += "\n" + String.format("%-25s", sm.getSlozka(i).getNazev())
                    + "  " + String.format("%-6.4f", yKon[i])
                    + "  " + String.format("%-6.4f", xKon[i])
                    + "  " + String.format("%-6.4f", sm.getxMol(i));
        }
        tx += "\n";
        sm.setNeMistniHlasky(false);
        return tx;
    }

    /**
     * Cílová funkce pro Fmin  dle interface I_Fmin
     * @param x double[] minimalizační proměnné
     * @return
     */
    public double f(double[] x) {
        int i, nSloz;
        double sum = 0, sumh = 0, hv = 0, hl = 0, hf = 0, pom, VF = 0;
        nSloz = sm.getnSloz();
        switch (cinnost) {
            case 8:         // FLASH  *************************************
                if (!adiabFlash || pocatek) {  // izotermní flash
                    for (i = 0; i < sm.getnSloz(); i++) {       // přes statické proměnné
                        sum += sm.getxMol(i) * (sm.getSlozka(i).tenze(tPom) / pPom - 1.0)
                                / (1.0 + x[0] * (sm.getSlozka(i).tenze(tPom) / pPom - 1.0));
                    }
                    //        System.out.println("sum: "+sum+"  V/F= "+x[0]+"  "+x[1]+"tenze "+sm.getSlozka(0).tenze(tPom)/pPom);
                    return sum * sum + 0.01 * (x[1] * x[1]);
                } else {                 // adiabatický flash
                    for (i = 0; i < sm.getnSloz(); i++) {       // přes statické proměnné pPom
                        sum += sm.getxMol(i) * (sm.getSlozka(i).tenze(x[1] + TABS) / pPom - 1.0)
                                / (1.0 + x[0] * (sm.getSlozka(i).tenze(x[1] + TABS) / pPom - 1.0));
                    }
//            hf = sm.sHL(tPom);  // entalpie nástřiku při výchozí abs. teplotě
                    VF = x[0];
                    if (x[0] < 0) {
                        VF = 0;
                    }
                    if (x[0] > 1) {
                        VF = 1;
                    }
                    zz = new double[nSloz];
                    xx = new double[nSloz];
                    yy = new double[nSloz];
                    for (i = 0; i < nSloz; i++) {
                        zz[i] = sm.getxMol(i);      // zapamatovat složení nástřiku
                        pom = sm.getSlozka(i).tenze(x[1] + TABS) / pPom;
                        xx[i] = sm.getxMol(i)
                                / //                        (1.0 + x[0] *(pom - 1.0));
                                (1.0 + VF * (pom - 1.0));
                        yy[i] = xx[i] * pom; // nebo též zz[i]/VF - xx[i]*(1/VF-1.0);
                        if (VF > 0.9999) {
                            xx[i] = 0.0;
                            yy[i] = sm.getxMol(i);
                        }
                        if (VF < 0.0001) {
                            xx[i] = sm.getxMol(i);
                            yy[i] = 0.0;
                        }
                    }
                    normalizuj(nSloz, xx);
                    normalizuj(nSloz, yy);
                    normalizuj(nSloz, zz);          // není třeba už je
                    try {
                        if(VF < 0.0001) {
                            hv = 0;
                        } else {
                            sm.zadatSloz(false, yy);            // mol.sl. parní fáze
                            hv = sm.srHG(x[1] + TABS, pPom);    // koncová entalpie par
                            if (Double.isNaN(hv)) {
                                hv = 0;
                            }
                        }
                        if (VF > 0.9999) {
                            hl = 0;
                        } else {
                            sm.zadatSloz(false, xx);
                            hl = sm.sHL(x[1] + TABS);           // koncová entalpie kapaliny
                            if (Double.isNaN(hl)) {
                                hl = 0;
                            }
                        }
                        sm.zadatSloz(false, zz);            // vrátit mol. složení nástřiku
                    } catch (IOException e) {
                        e.getStackTrace();
                    }
//            sumh = x[0]*hv/hPom + (1.0 - x[0])*hl/hPom - 1.0;   // entalpická bilance
                    sumh = VF * hv / hPom + (1.0 - VF) * hl / hPom - 1.0;   // entalpická bilance
//            System.out.println("sum: "+sum+"  V/F= "+x[0]+"  T "+x[1]+"  sumh "+sumh);
//            System.out.println("** hf,hl,hv: "+ hPom+"  "+hl+"  "+hv);
                    return sum * sum + sumh * sumh;
//            break;
                }
            case 9:    // Komprese/škrcení **********************************
                if (adiabFlash) {
                    sumh = sm.srSG(x[0], hPom) - sm.srSG(tPom, pPom);
//            System.out.println("Ksum: "+sumh+"  T= "+x[0]);
                    return sumh * sumh + (x[1] * x[1]);
                } else {
                    sumh = sm.srHG(x[0], hPom) - sm.srHG(tPom, pPom);
                    return sumh * sumh + 0.01 * (x[1] * x[1]);
                }
            //break;
        }
        return 0;
    }

    /**
     * Komprese/škrcení par
     * @return  výsledky
     */
    private String komprese() {
        String tx = "";
        int i, nSloz;
        double tFpoc, pFpoc, pFkon, fmin = -9999;
        double VFpoc = 0, VF = 0, pom, tFkon = 0, hl = 0, hv = 0;
        sm.setNeMistniHlasky(true);
        nSloz = sm.getnSloz();
        jTabbedPane1.setSelectedIndex(7);
        tx = vytvorTextSlozeni();
//        jTextAreaSloz.append(tx);
        tabelace += tx + "\n";
        pFpoc = Double.parseDouble((jTextFieldFPpoc.getText()).replace(',', '.'));  // pro českou notaci
        pFkon = Double.parseDouble((jTextFieldFPkon.getText()).replace(',', '.'));  // pro českou notaci
        tFpoc = Double.parseDouble((jTextFieldFTpoc.getText()).replace(',', '.'));  // pro českou notaci
        tPom = tFpoc + TABS;   // přes statické proměnné
        pPom = pFpoc;
        hPom = pFkon;
        if(jRadioButtonIzo.isSelected() && pFpoc < pFkon) {
            JOptionPane.showMessageDialog(this,
                "Zadání neodpovídá škrcení\nKoncový tlak vyšší, než počáteční.",
                "FYDAT škrcení", JOptionPane.WARNING_MESSAGE);
            return "";
        }
        if(jRadioButtonAd.isSelected() && pFpoc > pFkon) {
            JOptionPane.showMessageDialog(this,
                "Zadání neodpovídá kompresi\nKoncový tlak nižší, než počáteční.",
                "FYDAT komprese", JOptionPane.WARNING_MESSAGE);
            return "";
        }
        x[0] = tPom;   // odhad koncové teploty
        x[1] = 0;    // dummy
        I_Fmin fi = this;
        try {
            fmin = Numer.m_Fmin1(fi, 2, x, 1e-4); // volání minimalizace
//            System.out.println("*Komp T, fmin : " + x[0] + " * " + fmin);
        } catch (NumerException e) {
            e.getStackTrace();
        }
        // Zápis výsledků
        tx = "\n" + ((jRadioButtonIzo.isSelected()) ? "ŠKRCENÍ" : "KOMPRESE");
        tx += "\nPočáteční tlak (MPa): " + String.format("%-6.4f", pFpoc / 1e6);
        tx += "   Koncový tlak (MPa): " + String.format("%-6.4f", pFkon / 1e6);
        tx += "\nPočáteční teplota (°C): " + String.format("%-5.1f", tFpoc)
                + "  Koncová teplota (°C): "
                + String.format("%-5.1f", x[0] - TABS);
        tx += "\nBod varu a rosný bod - výchozí (°C): "
                + String.format("%-5.1f", sm.sTbv(pFpoc) - TABS)
                + "  " + String.format("%-5.1f", sm.sTrb(pFpoc) - TABS);
        tx += "\nBod varu a rosný bod - koncový(°C): "
                + String.format("%-5.1f", sm.sTbv(pFkon) - TABS)
                + "  " + String.format("%-5.1f", sm.sTrb(pFkon) - TABS);
        pom = sm.srUGW(x[0], hPom) - sm.srUGW(tPom, pPom);
        tx += "\nČistá kompresní práce (kJ/kg): "
                + String.format("%-8.2f", pom / 1000.);
        tx += "\nVýkon kompresoru (kW na 1kg/s) :"
                + String.format("%-8.1f", (pom / 1000.
                + (hPom / sm.srHustGW(x[0], hPom)
                - pPom / sm.srHustGW(tPom, pPom)) / 1000));
        tx += "\nVyužitelná entalpie (kJ/kg): "
                + String.format("%-8.1f", (sm.srHGW(x[0], hPom)
                - sm.sHLW(sm.sTbv(pFkon))) / 1000.);
        tx += "\n";
        sm.setNeMistniHlasky(false);
        return tx;
    }

    /**
     * Normalizuje zlomky složení
     * @param n počet prvků pole
     * @param x pole double[]
     */
    private void normalizuj(int n, double[] x) {
        int i;
        double sum = 0;
        for (i = 0; i < n; i++) {
            sum += x[i];
        }
        for (i = 0; i < n; i++) {
            x[i] = (Math.abs(sum) < 1e-8) ? 0.0 : x[i] / sum;
        }
    }

    private void neimplementovano() {
        JOptionPane.showMessageDialog(this,
                "Zatím neimplementováno!\nPočkejte na další vezri.",
                "FYDAT činnosti", JOptionPane.WARNING_MESSAGE);
    }

    private void zobrazLatku(int cislo) {
        // TODO add your handling code here:
        int i;
        Latka la = new Latka();
        Latka.getLatka(cislo);
        jTextFieldLNaz.setText(Latka.getLatka(cislo).getNazev());
        jTextFieldLVz.setText(Latka.getLatka(cislo).getVzorec());
        jTextFieldLCAS.setText("" + Latka.getLatka(cislo).getCas());
        jTextFieldLCis.setText("" + Latka.getLatka(cislo).getCislo());
        jTextFieldLMol.setText(String.format("%6.4f", Latka.getLatka(cislo).getMolHmot()));
        jTextFieldLTkr.setText(String.format("%6.1f", Latka.getLatka(cislo).gettKr()));
        jTextFieldLTkrC.setText(String.format("%6.1f", (Latka.getLatka(cislo).gettKr() - TABS)));
        jTextFieldLPkr.setText(String.format("%6.3f", Latka.getLatka(cislo).getpKr() / 1e6));
        jTextFieldLVkr.setText(String.format("%6.1f", Latka.getLatka(cislo).getvKr() * 1e6));
        jTextFieldLAc.setText(String.format("%6.4f", Latka.getLatka(cislo).getAcent()));
        jTextFieldLGyr.setText(String.format("%6.3f", Latka.getLatka(cislo).getGyr()));
        jTextFieldLInd.setText(String.format("%6.4f", Latka.getLatka(cislo).getIndLomu()));
        jTextFieldLTInd.setText(String.format("%4.1f", Latka.getLatka(cislo).gettIndLomu()));
        jTextFieldLDip.setText(String.format("%6.3f", Latka.getLatka(cislo).getDipolm()));
        jTextFieldLDiel.setText(String.format("%6.2f", Latka.getLatka(cislo).getDielektr()));
        if (Latka.getLatka(cislo).getdHtani() > 0.01) {
            jTextFieldLHt.setText(String.format("%6.2f", Latka.getLatka(cislo).getdHtani()));
        } else {
            jTextFieldLHt.setText("N/A");
        }
        if (Latka.getLatka(cislo).gettTani() > 0.01) {
            jTextFieldLTt.setText(String.format("%6.1f", Latka.getLatka(cislo).gettTani() - TABS));
        } else {
            jTextFieldLTt.setText("N/A");
        }
        if (Latka.getLatka(cislo).gettNbv() > 0.01) {
            jTextFieldLTnbv.setText(String.format("%6.1f", Latka.getLatka(cislo).gettNbv() - TABS));
        } else {
            jTextFieldLTnbv.setText("N/A");
            
        }

    }

    public void rozsahTabelace() {
        String tx;
        if (((DefaultListModel) jListVybrVl.getModel()).getSize() > 0) {
            jTabbedPane1.setSelectedIndex(3);
            if (tabDleTepl) {
                jLabelPodleCeho.setText("Podle teploty (°C):");
                jLabelPri.setText("<html>Při tlaku<br> (MPa):</html>");
                jTextFieldPoc.setText("0");
                jTextFieldKon.setText("100");
                jTextFieldKrok.setText("10");
                jTextFieldPri.setText("0,103320");
            } else {
                jLabelPodleCeho.setText("Podle tlaku (MPa):");
                jLabelPri.setText("<html>Při tepl.<br> (°C):</html>");
                jTextFieldPoc.setText("0,1");
                jTextFieldKon.setText("2");
                jTextFieldKrok.setText("0,1");
                jTextFieldPri.setText("200");
            }
            tabPoc = Double.parseDouble((jTextFieldPoc.getText()).replace(',', '.'));  // pro českou notaci
            tabKon = Double.parseDouble((jTextFieldKon.getText()).replace(',', '.'));  // pro českou notaci
            tabKrok = Double.parseDouble((jTextFieldKrok.getText()).replace(',', '.'));  // pro českou notaci
            jLabel14.setText("<html>Vložte počáteční a koncovou<br> hodnotu pro tabelaci a příslušný krok tabelace. Pozor na kritickou oblast!</html>");
        }
        if (cinnost == 1) {
            jLabel14.setText("<html>Vlož 3 teploty a tlak<br> pro porovnání.</html>");
            jPanel14.setVisible(true);
            jPanel11.setVisible(false);
            jLabel14.setVisible(true);
            jTextFieldT1.setText("" + T1);
            jTextFieldT2.setText("" + T2);
            jTextFieldT3.setText("" + T3);
            jTextFieldP.setText("0,1");
        } else {
            jPanel11.setVisible(true);
            jLabel14.setVisible(true);
            jPanel14.setVisible(false);
        }
        if (cinnost == 7) { // podle hodnoty vlastnosti
            podleHodnoty();
        } else {
            tx = vytvorTextSlozeni();
//            jTextAreaSloz.append(tx);
        }
        
    }

//    private void ulozVysledky() {
//        int i;
//        String curDir, filenam,  vysledek;
//        File soubor;
//        JFileChooser fc;
//        FileWriter fout = null;
//        PrintWriter opw = null;
//        vysledek = jTextAreaTab.getText();
//        if("".equals(vysledek)) {
//            JOptionPane.showMessageDialog(null, "Nebyl dosud spočítán výsledek!" ,
//                "Uložení výsledků", JOptionPane.WARNING_MESSAGE);
//            return;            
//        }
//        curDir = System.getProperty("user.dir");    // běžný adresář aplikace 
//        fc = new JFileChooser(curDir); 
//        fc.setFileFilter(new FileNameExtensionFilter("Textový výsledek .txt, .res", "txt","TXT","res"));        
//        fc.setDialogTitle("Uložení výsledků");
//        fc.setFileSelectionMode(JFileChooser.FILES_ONLY);
//        int res = fc.showSaveDialog(this);
//        if (res == JFileChooser.APPROVE_OPTION) {
//            soubor = fc.getSelectedFile();  
//            filenam = soubor.getPath();     // textové plné jméno souboru
//            i = filenam.lastIndexOf(".");
//            if(i <= 0)filenam +=  ".txt";   // doplnění typu txt
//            if(fout == null) {
//                try {
//                    fout = new FileWriter(filenam,true); // režim append souboru
////                    DataOutputStream fw = new DataOutputStream(fout);                
////                    fw.writeUTF(vysledek);  // vlastní zápis 
//                    opw = new PrintWriter(fout);
//                    opw.write(vysledek); 
//                    JOptionPane.showMessageDialog(null, "Výsledkové okno uloženo do souboru: "
//                        + filenam + "\nKodování UTF-8" ,"Uložení výsledků", 
//                        JOptionPane.INFORMATION_MESSAGE);
//                } catch (FileNotFoundException ex) {
//                    Logger.getLogger(FydatGUI.class.getName()).log(Level.SEVERE, null, ex);
//                } catch (IOException ex) {
//                    Logger.getLogger(FydatGUI.class.getName()).log(Level.SEVERE, null, ex);
//                } finally {
//                    try {
//                        if(fout != null)fout.close(); 
//                    } catch (IOException ex) {
//                        Logger.getLogger(FydatGUI.class.getName()).log(Level.SEVERE, null, ex);
//                    }
//                }         
//            }                         
//        }
//    }    

    private void ulozVysledkyKod() {
        int i;
        String curDir, filenam, vysledek, kodovani = "Cp1250";
        File soubor;
        JFileChooser fc;
        FileOutputStream fout = null;
        OutputStreamWriter osw;
        PrintWriter opw = null;
        vysledek = jTextAreaTab.getText();
        if("".equals(vysledek)) {
            JOptionPane.showMessageDialog(null, "Nebyl dosud spočítán výsledek!" ,
                "Uložení výsledků", JOptionPane.WARNING_MESSAGE);
            return;            
        }
        Object[] moznosti = {"Windows Cp1250", "UTF-8", "Linux ISO8859-2"};
        String s = (String)JOptionPane.showInputDialog(
                            this,
                            "Zvolte kódovní textu výsledků\n"
                            + "(Windows, UTF-8, Linux)",
                            "Uložení výsledků",
                            JOptionPane.QUESTION_MESSAGE,
                            null,
                            moznosti,
                            "Windows Cp1250");
        if ((s != null) && (s.length() > 0)) {
            if("UTF-8".equals(s)) kodovani = "UTF8"; 
            if("Linux ISO8859-2".equals(s)) kodovani = "ISO8859-2"; 
        } else {
            return;
        }
        if("Cp1250".equals(kodovani)) vysledek = zajistiCRLF(vysledek); // doplní CRLF
        curDir = System.getProperty("user.dir");    // běžný adresář aplikace 
        fc = new JFileChooser(curDir); 
        fc.setFileFilter(new FileNameExtensionFilter("Textový výsledek .txt, .res", "txt","TXT","res"));        
        fc.setDialogTitle("Uložení výsledků");
        fc.setFileSelectionMode(JFileChooser.FILES_ONLY);
        int res = fc.showSaveDialog(this);
        if (res == JFileChooser.APPROVE_OPTION) {
            soubor = fc.getSelectedFile();  
            filenam = soubor.getPath();     // textové plné jméno souboru
            i = filenam.lastIndexOf(".");
            if(i <= 0)filenam +=  ".txt";   // doplnění typu txt
            if(fout == null) {
                try {
                    fout = new FileOutputStream(filenam,true); // režim append souboru
                    osw = new OutputStreamWriter(fout, kodovani);
                    opw = new PrintWriter(osw);
                    opw.format("%s",vysledek);
                    JOptionPane.showMessageDialog(null, "Výsledkové okno uloženo do souboru: "
                        + filenam + "\nKodování " + kodovani ,"Uložení výsledků", 
                        JOptionPane.INFORMATION_MESSAGE);
                } catch (FileNotFoundException ex) {
                    Logger.getLogger(FydatGUI.class.getName()).log(Level.SEVERE, null, ex);
                    ex.getLocalizedMessage();
                } catch (IOException ex) {
                    Logger.getLogger(FydatGUI.class.getName()).log(Level.SEVERE, null, ex);
                    ex.getLocalizedMessage();
                } finally {
                    try {
                        if(fout != null) { opw.close(); fout.close(); }
                    } catch (IOException ex) {
                        Logger.getLogger(FydatGUI.class.getName()).log(Level.SEVERE, null, ex);
                        ex.getLocalizedMessage();
                    }
                }         
            }                         
        }
    }    

    private String zajistiCRLF(String tx) {
        int i, n;
        char c;
        String txnew = "";
        n = tx.length();
        for(i = 0; i < n; i++) {
            c = tx.charAt(i);
            if(c == '\n' && i > 0) {
                if(tx.charAt(i - 1) != '\r') txnew += '\r';
            }
            txnew += tx.substring(i, i + 1);            
        }
        return txnew;
    }

    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://downloadjList1j.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        if (nastavVzhled >=0 && nastavVzhled <5) {
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if (vzhled[nastavVzhled].equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(ZkJFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(ZkJFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(ZkJFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(ZkJFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        }    
        //</editor-fold>        
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new FydatGUI().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuItem aboutMenuItem;
    private javax.swing.JMenu actMenu;
    private javax.swing.ButtonGroup buttonGroupFlash;
    private javax.swing.JMenuItem contentsMenuItem;
    private javax.swing.JMenuItem exitMenuItem;
    private javax.swing.JMenu fileMenu;
    private javax.swing.JMenuItem grafMenuItem;
    private javax.swing.JMenu helpMenu;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButtonBack;
    private javax.swing.JButton jButtonDo;
    private javax.swing.JButton jButtonFlash;
    private javax.swing.JButton jButtonKonec;
    private javax.swing.JButton jButtonLatBack;
    private javax.swing.JButton jButtonNab;
    private javax.swing.JButton jButtonSmaz;
    private javax.swing.JButton jButtonSmazSloz;
    private javax.swing.JButton jButtonSmazat;
    private javax.swing.JButton jButtonTabel;
    private javax.swing.JButton jButtonVlDo;
    private javax.swing.JButton jButtonVlastni;
    private javax.swing.JButton jButtonVybrano;
    private javax.swing.JCheckBox jCheckBox1;
    private javax.swing.JCheckBox jCheckBoxOdNuly;
    private javax.swing.JCheckBox jCheckBoxPridSloz;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel21;
    private javax.swing.JLabel jLabel22;
    private javax.swing.JLabel jLabel23;
    private javax.swing.JLabel jLabel24;
    private javax.swing.JLabel jLabel25;
    private javax.swing.JLabel jLabel26;
    private javax.swing.JLabel jLabel27;
    private javax.swing.JLabel jLabel28;
    private javax.swing.JLabel jLabel29;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel30;
    private javax.swing.JLabel jLabel31;
    private javax.swing.JLabel jLabel32;
    private javax.swing.JLabel jLabel33;
    private javax.swing.JLabel jLabel34;
    private javax.swing.JLabel jLabel35;
    private javax.swing.JLabel jLabel36;
    private javax.swing.JLabel jLabel37;
    private javax.swing.JLabel jLabel38;
    private javax.swing.JLabel jLabel39;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel40;
    private javax.swing.JLabel jLabel41;
    private javax.swing.JLabel jLabel42;
    private javax.swing.JLabel jLabel43;
    private javax.swing.JLabel jLabel44;
    private javax.swing.JLabel jLabel45;
    private javax.swing.JLabel jLabel46;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JLabel jLabelAutor;
    private javax.swing.JLabel jLabelCinnosti;
    private javax.swing.JLabel jLabelFbv;
    private javax.swing.JLabel jLabelFrb;
    private javax.swing.JLabel jLabelInfoSloz;
    private javax.swing.JLabel jLabelNadpis;
    private javax.swing.JLabel jLabelNoGraf;
    private javax.swing.JLabel jLabelPodleCeho;
    private javax.swing.JLabel jLabelPorov;
    private javax.swing.JLabel jLabelPri;
    private javax.swing.JLabel jLabelSeznam;
    private javax.swing.JLabel jLabelSoubor;
    private javax.swing.JLabel jLabelText;
    private javax.swing.JLabel jLabelVyber1;
    private javax.swing.JList jList1;
    private javax.swing.JList jList3;
    private javax.swing.JList jList4;
    private javax.swing.JList jListGr;
    private javax.swing.JList jListVlast;
    private javax.swing.JList jListVybrVl;
    private javax.swing.JList jListVybrano;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItemFlash;
    private javax.swing.JMenuItem jMenuItemKompr;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel11;
    private javax.swing.JPanel jPanel12;
    private javax.swing.JPanel jPanel13;
    private javax.swing.JPanel jPanel14;
    private javax.swing.JPanel jPanel15;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JPanel jPanelFlash;
    private javax.swing.JPanel jPanelLatka;
    private fydat.JPanelObr jPanelObr1;
    private javax.swing.JPanel jPanelVyber;
    private javax.swing.JRadioButton jRadioButtonAd;
    private javax.swing.JRadioButton jRadioButtonHmot;
    private javax.swing.JRadioButton jRadioButtonIzo;
    private javax.swing.JRadioButton jRadioButtonMol;
    private javax.swing.JRadioButton jRadioButtonP;
    private javax.swing.JRadioButton jRadioButtonT;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JScrollPane jScrollPane6;
    private javax.swing.JScrollPane jScrollPane7;
    private javax.swing.JScrollPane jScrollPane8;
    private javax.swing.JScrollPane jScrollPane9;
    private javax.swing.JScrollPane jScrollPaneSeznam;
    private javax.swing.JPopupMenu.Separator jSeparator1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTabbedPane jTabbedPane2;
    private javax.swing.JTable jTableSmes;
    private javax.swing.JTextArea jTextAreaTab;
    private javax.swing.JTextField jTextFieldCislem;
    private javax.swing.JTextField jTextFieldFPkon;
    private javax.swing.JTextField jTextFieldFPpoc;
    private javax.swing.JTextField jTextFieldFTpoc;
    private javax.swing.JTextField jTextFieldKon;
    private javax.swing.JTextField jTextFieldKrok;
    private javax.swing.JTextField jTextFieldLAc;
    private javax.swing.JTextField jTextFieldLCAS;
    private javax.swing.JTextField jTextFieldLCis;
    private javax.swing.JTextField jTextFieldLDiel;
    private javax.swing.JTextField jTextFieldLDip;
    private javax.swing.JTextField jTextFieldLGyr;
    private javax.swing.JTextField jTextFieldLHt;
    private javax.swing.JTextField jTextFieldLInd;
    private javax.swing.JTextField jTextFieldLMol;
    private javax.swing.JTextField jTextFieldLNaz;
    private javax.swing.JTextField jTextFieldLPkr;
    private javax.swing.JTextField jTextFieldLTInd;
    private javax.swing.JTextField jTextFieldLTkr;
    private javax.swing.JTextField jTextFieldLTkrC;
    private javax.swing.JTextField jTextFieldLTnbv;
    private javax.swing.JTextField jTextFieldLTt;
    private javax.swing.JTextField jTextFieldLVkr;
    private javax.swing.JTextField jTextFieldLVz;
    private javax.swing.JTextField jTextFieldNazSmesi;
    private javax.swing.JTextField jTextFieldP;
    private javax.swing.JTextField jTextFieldPoc;
    private javax.swing.JTextField jTextFieldPri;
    private javax.swing.JTextField jTextFieldT1;
    private javax.swing.JTextField jTextFieldT2;
    private javax.swing.JTextField jTextFieldT3;
    private javax.swing.JToggleButton jToggleButtonDocas;
    private javax.swing.JMenuItem konecMenuItem;
    private java.awt.Label label1;
    private java.awt.Label label2;
    private javax.swing.JMenuBar menuBar;
    private javax.swing.JMenuItem porovMenuItem;
    private javax.swing.JMenuItem saveMenuItem;
    private javax.swing.JMenuItem seznMenuItem;
    private javax.swing.JMenuItem smazMenuItem;
    private javax.swing.JMenuItem tabelMenuItem;
    private javax.swing.JMenuItem vlastMenuItem;
    private javax.swing.JMenuItem vyhledMenuItem;
    private javax.swing.JMenuItem vysledMenuItem;
    // End of variables declaration//GEN-END:variables
}
